// *****************************************************************************
// AoMXaiLoaderAggBoom.xs
// 
// Loader for Aggressive Boomer personality.  
// Boom 90% - heavy boom
// Mil 30% - small mil bias, versus "normal" econ bias for boomer
// Offense 90% - huge offense bias
// Noise +/- 20%
// *****************************************************************************


include "AoMXaiCV.xs";  // The control variable definitions
include "AoMXai.xs";		// The whole AI complex
include "AoMXaiCVFuncs.xs"; // Control Variable set functions.


// *****************************************************************************
//
// setParameters()
//
// Do most of the control variable (cv) initial declarations here.
//
// *****************************************************************************
void setParameters(void)   // This function is called from main() before init() is run.
{
   aiEcho("Starting setParameters()");
   cvDoAutoSaves = true;              // Autosaves on

   cvRushBoomSlider = -0.9;
   cvMilitaryEconSlider = 0.3;
   cvOffenseDefenseSlider = 0.9;

   cvSliderNoise = 0.1;	// This amount is added or subtracted to/from each slider for some game-to-game variety.

   aiEcho("In setParameters, sliders are...");
   aiEcho("RushBoom "+cvRushBoomSlider+", MilitaryEcon "+cvMilitaryEconSlider+", OffenseDefense "+cvOffenseDefenseSlider);
   if(aiGetWorldDifficulty() == cDifficultyEasy)
   {
	xsSetRuleMinInterval("startAttacking",60*25);	// Allow attacks after 25 minutes
	xsEnableRule("startAttacking");
   }
}


// *****************************************************************************
//
// setOverrides()
//
// Override certain defaults here as indicated in the aomMKcv.xs file.
//
// *****************************************************************************
void setOverrides(void)    // This function is called from main() after init() is run.  Use it to 
                           // override any initial settings done in the main scripts.
{
   aiEcho("Starting setOverrides()");
}

