// *****************************************************************************
// AoMXaiLoaderEcoRush.xs
//
// Loader for Economic Rusher personality.  
// Rush 90% - heavy rush
// Economy 90% - heavy economic bias
// Defense 0% - offense/defense balanced
// Noise +/- 20%
// *****************************************************************************


include "AoMXaiCV.xs";      // The control variable definitions
include "AoMXai.xs";        // The whole AI complex
include "AoMXaiCVFuncs.xs"; // Control Variable set functions.

// *****************************************************************************
//
// setParameters()
//
// Do most of the control variable (cv) initial declarations here.
//
// *****************************************************************************
void setParameters(void)   // This function is called from main() before init() is run.
{
   aiEcho("Starting setParameters()");
   cvDoAutoSaves = true;              // Autosaves on

   cvRushBoomSlider = 0.9;
   cvMilitaryEconSlider = -0.9;
   cvOffenseDefenseSlider = 0.0;

   cvSliderNoise = 0.2;    // This amount is added or subtracted to/from each slider for some game-to-game variety.

   aiEcho("In setParameters, sliders are...");
   aiEcho("RushBoom "+cvRushBoomSlider+", MilitaryEcon "+cvMilitaryEconSlider+", OffenseDefense "+cvOffenseDefenseSlider);
}


// *****************************************************************************
//
// setOverrides()
//
// Override certain defaults here as indicated in the aomMKcv.xs file.
//
// *****************************************************************************
void setOverrides(void)    // This function is called from main() after init() is run.  Use it to 
                           // override any initial settings done in the main scripts.
{
   aiEcho("Starting setOverrides()");
}

