//A crude, inefficent way of getting the AI to send custom messages.
//Now expanded to include other important commands!
//These vars/consts/plans/etc communicate with rotg_script to invoke commands. May be a 1 sec delay between actual invocation.

mutable void SendChat(int toPlayer=-1, string message="", int reserve=0) { }   //Chat will appear regardless.
mutable void SendChatRelation(int toPlayerRel=-1, string message="", int reserve=0) { }  //Ditto.
mutable void Debug(string message="", int reserve=0) { }  //Chat is intended for debugging only! Comment out in public version.
mutable void rotgCaptureModeSet(bool activate=true) { }  //Watch out! This doesn't check your current capture-mode-state.
mutable bool rotgTechActivate(int techid=-1, int reserve=0) { }

const int cText = 0;
const int cSendTo = 1;
const int cTechForce = 2;
const int cCaptureModeSet = 3;
int Pid = -1;

//MUST be called immediately! If rotg_script changes our civ/culture, info on titan availability is lost.
int rotgPreLaunch(int cultureid=-1)
{
   if ( (cultureid == cTechAge1Aztec) || (cultureid == cTechAge1Maya) || (cultureid == cTechAge1Inca) )
      int Pid = aiPlanCreate( "rotg", cPlanData );
   else
      Pid = aiPlanCreate( "oldc", cPlanData );
   aiPlanAddUserVariableString( Pid, cText, "cht", 1 );
   aiPlanSetUserVariableString( Pid, cText, 0, "" );
   aiPlanAddUserVariableInt( Pid, cSendTo, "snd2", 1 );
   aiPlanAddUserVariableInt( Pid, cTechForce, "tfor", 1 );
   if ( cultureid == cTechAge1Aztec ) {
      aiPlanAddUserVariableInt( Pid, cCaptureModeSet, "cptr", 1 );
      aiPlanSetUserVariableInt( Pid, cCaptureModeSet, 0, -1 );
   }
  //Tell rotg_script that nothing needs to be done at the start.
   aiPlanSetAllowUnderAttackResponse( Pid, false );
  //Tell rotg_script whether or not Titan Age is allowed this game.
   aiPlanSetMilitary( Pid, (kbGetTechStatus(cTechSecretsoftheTitans) != cTechStatusUnobtainable) );
   return( Pid );
}

void SendChat(int toPlayer=-1, string message="", int reserve=0)
{
   int the_index = -1;
   int vars = aiPlanGetNumberUserVariableValues( Pid, cText );
   if ( reserve > vars ) {
      aiPlanSetNumberUserVariableValues( Pid, cText, reserve, false );
      aiPlanSetNumberUserVariableValues( Pid, cSendTo, reserve, false );
      vars = reserve;
   }
   for(i=0; < vars) {
      if ( aiPlanGetUserVariableString(Pid, cText, i) == "" ) {  //Take the 1st open slot.
         the_index = i;
         break;
      }
   }
   if ( the_index < 0 ) {  //Add a slot if no open ones.
      aiPlanSetNumberUserVariableValues( Pid, cText, vars+1, false );
      aiPlanSetNumberUserVariableValues( Pid, cSendTo, vars+1, false );
      the_index = vars;
   }
   aiPlanSetUserVariableString( Pid, cText, the_index, message );
   aiPlanSetUserVariableInt( Pid, cSendTo, the_index, toPlayer );
   aiPlanSetAllowUnderAttackResponse( Pid, true );  //Tell script there is something to do.
}
void SendChatRelation(int toPlayerRel=-1, string message="", int reserve=0)
{
   if ( toPlayerRel != cPlayerRelationSelf )
      toPlayerRel = toPlayerRel + 10000;
   else
      toPlayerRel = cMyID;
   SendChat( toPlayerRel, message, reserve );
}

void Debug(string message="", int reserve=0) {
   SendChatRelation( cPlayerRelationAny, message, reserve );
}

void rotgCaptureModeSet(bool activate=true) {
   if ( activate )
      aiPlanSetUserVariableInt( Pid, cCaptureModeSet, 0, 1 );
   else
      aiPlanSetUserVariableInt( Pid, cCaptureModeSet, 0, 0 );
   aiPlanSetAllowUnderAttackResponse( Pid, true );  //Tell script there is something to do.
}

bool rotgTechActivate(int techid=-1, int reserve=0)
{
   static int qid = -1;
   if ( qid < 0 ) {
      qid = kbUnitQueryCreate( "techCheat" );
      kbUnitQuerySetPlayerID( qid, cMyID, false );
      kbUnitQuerySetState( qid, cUnitStateAlive );
   }
   kbUnitQuerySetUnitType( qid, cUnitTypeBuilding );
   if ( kbUnitQueryExecute(qid) <= 0 ) {
      kbUnitQuerySetUnitType( qid, cUnitTypeVillagerChinese );
      if ( kbUnitQueryExecute(qid) <= 0 ) {
         kbUnitQuerySetUnitType( qid, cUnitTypeOxCart );
         kbUnitQueryExecute( qid );
      }
   }
   int results = kbUnitQueryNumberResults( qid );
   bool success = (results > 0);
   if ( success ) {
      for(resourceid=0; <= cResourceFavor)
         aiResourceCheat( cMyID, resourceid, kbTechCostPerResource(techid, resourceid) );
      aiTaskUnitResearch( kbUnitQueryGetResult(qid, 0), techid );
      kbUnitQueryResetResults( qid );
   }
   return( success );
}

bool rotgLaunchCivSelection(int civid=-1, int cultureid=-1)
{
   if ( kbGetTechStatus(cultureid) < cTechStatusActive ) {
      if ( rotgTechActivate(civid) == false ) {
         aiErrorMessage( "Player#"+cMyID+" needs a Building/Chinese Villager/Ox Cart at start to choose new civ!" );
         return( false );
      }
   }
   return( true );
}

