//==============================================================================
// The Return of the Gods AI
//==============================================================================
// ROTGAIEcon.xs
// This is a modification of Georg Kalus' extension of the default aomx ai file
// by Loki_GdD
//
// Handles common economy functions.
//==============================================================================


//==============================================================================
rule updateBreakdowns
minInterval 12
inactive
{   
   if ((aiGetGameMode() == cGameModeDeathmatch) && (kbGetAge() < cAge4) && (xsGetTime() < 4*60*1000))
      return;

   for (i = 0; < 2)
      {   
      int Resource = cResourceWood;
      float ChosenForcast = gWoodForecast;
      int cNumberPlanType = cGatherGoalPlanNumWoodPlans;
      int BaseID = gWoodBaseID;
      int PlanPriority = 50;
      if (i == 1) {
         Resource = cResourceGold;
         ChosenForcast = gGoldForecast;
         cNumberPlanType = cGatherGoalPlanNumGoldPlans;
         BaseID = gGoldBaseID;
      }
      int mainBaseID = kbBaseGetMainID(cMyID);
      int randomBaseID = mainBaseID;
      int randomBase = findUnit(cUnitTypeAbstractSettlement);
      if (randomBase >= 0)
         randomBaseID = kbUnitGetBaseID(randomBase);

      bool BaseOnOtherAG = true;
      if ((gTransportMap) && (SameAG(kbBaseGetLocation(cMyID, BaseID), kbBaseGetLocation(cMyID, mainBaseID)) == false))
         BaseOnOtherAG = false;
      float ResSupply = kbResourceGet(Resource) * 1.25;
      float Forecast = ChosenForcast;	
      if (Forecast <= 0)
         Forecast = 0;

      float Ponti = 0.0;
      if(ResSupply < Forecast)
         Ponti = 0.0; 
      else
         Ponti = ResSupply/Forecast -1;

      float Percentage = 1.0;
      Percentage = Percentage - Ponti;
      if (Percentage > 1.0)
         Percentage = 1.0; 
      else if (Percentage < 0.1)
         Percentage = 0.1; 
      int Villagers = kbUnitCount(cMyID,cUnitTypeAbstractVillager,cUnitStateAlive);
      int GathererCount = 0.5 + aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanGathererPct, Resource) * Villagers;
      // If we have no need for res, set plans=0 and exit
      if (GathererCount <= 0) {
         aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, 0);
         aiRemoveResourceBreakdown(Resource, cAIResourceSubTypeEasy, mainBaseID);
         if (BaseID != mainBaseID)
            aiRemoveResourceBreakdown(Resource, cAIResourceSubTypeEasy, BaseID);
         continue;
      }

      // If we're this far, we need some res gatherers.  The number of plans we use will be the greater of 
      // a) the ideal number for this number of gatherers, or
      // b) the number of plans active that have resource sites, either main base or res base.

      //Count of sites.
      int numberMainBaseSites = kbGetNumberValidResources(mainBaseID, Resource, cAIResourceSubTypeEasy);
      bool ResBaseEmpty = true;
      if (ResourceBaseID != -1) {
         int ResourceBaseSites = kbGetNumberValidResources(ResourceBaseID, Resource, cAIResourceSubTypeEasy);
         if (ResourceBaseSites > 0)
            ResBaseEmpty = false; 
         if ((i == 0) && (ResBaseEmpty == false) && (kbGetAge() > cAge1))
            numberMainBaseSites = 0;
         if (ResBaseEmpty)
            aiRemoveResourceBreakdown(Resource, cAIResourceSubTypeEasy, ResourceBaseID);
      }
      int numberResBaseSites = 0;
      if ((BaseID >= 0) && (BaseID != mainBaseID))
         numberResBaseSites = kbGetNumberValidResources(BaseID, Resource, cAIResourceSubTypeEasy);
      if ((BaseID == ResourceBaseID) && (ResBaseEmpty))
         numberResBaseSites = 0;		
      //Get the count of plans we currently have going.
      int numPlans = aiPlanGetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0);
      int desiredPlans = 2;

      if ((kbGetAge() == cAge1) || (kbGetAge() == cAge2) && (kbUnitCount(cMyID,cUnitTypeAge2Building, cUnitStateAlive) < 2))
         desiredPlans = 1;

      if (GathererCount < desiredPlans)
         desiredPlans = GathererCount;

      if (desiredPlans < numPlans)
         desiredPlans = numPlans;    // Try to preserve existing plans
      if ((i == 1) && (numberMainBaseSites > 1) && (ResBaseEmpty == false))
         numberMainBaseSites = 1;

      if (i == 0)
         aiPlanSetUserVariableInt(gSomeData, 15, 0, numberMainBaseSites+numberResBaseSites);
      else
         aiPlanSetUserVariableInt(gSomeData, 14, 0, numberMainBaseSites+numberResBaseSites);	

      if (BaseOnOtherAG == false) {
         int Transport = kbUnitCount(cMyID, cUnitTypeTransport, cUnitStateAlive);
         int TransPlan = findPlanByString("Remote Resource Refill Transport", cPlanTransport, -1);
         int numVills = 0;
         vector BaseLoc = kbBaseGetLocation(cMyID, BaseID);
         int AreaID = kbAreaGroupGetIDByPosition(BaseLoc);
         int WorkersThere = NumUnitsOnAreaGroupByRel(true, AreaID, cUnitTypeAbstractVillager, cMyID);
         if (SameAG(kbBaseGetLocation(cMyID, gGoldBaseID), kbBaseGetLocation(cMyID, gWoodBaseID))) {
            if (i == 0)
               WorkersThere = WorkersThere - (aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanGathererPct, cResourceGold) * Villagers);
            else
               WorkersThere = WorkersThere - (aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanGathererPct, cResourceWood) * Villagers);
         }

         if (WorkersThere < GathererCount)
            numVills = GathererCount - WorkersThere;
         if ((Transport < 1) && (TransPlan != -1))
            aiPlanDestroy(TransPlan);
         if ((numVills > 0) && (Transport > 0) && (TransPlan == -1) && (Villagers > 14) && (findPlanByString("Remote Resource Transport", cPlanTransport) == -1)) {
            if (numVills > 12)
               numVills = 12;
            else if (numVills <= 1)
               numVills = 1;	
            if ( numVills > 3 ) {
               vector here=kbBaseGetLocation(cMyID, mainBaseID);
               int startAreaID=kbAreaGetIDByPosition(here);
               int DestAreaID=kbAreaGetIDByPosition(BaseLoc);
               int resourceTransportPlan = createTransportPlan("Remote Resource Refill Transport", startAreaID, DestAreaID, false, cUnitTypeTransport, 80, mainBaseID);
               if (resourceTransportPlan != -1) {
                  aiPlanAddUnitType(resourceTransportPlan, cUnitTypeAbstractVillager, numVills, numVills, numVills);
                  aiPlanSetRequiresAllNeedUnits(resourceTransportPlan, true);
                  aiPlanSetActive(resourceTransportPlan);
               }
            }
         }
      }	
      // Three cases are possible:
      // 1)  We have enough sites at our main base.  All should work in main base.
      // 2)  We have some res at main, but not enough.  Split the sites
      // 3)  We have no res at main...use resBase

      if (numberMainBaseSites >= desiredPlans) {
         //Remove any breakdown for resBaseID
         if (BaseID != mainBaseID)
            aiRemoveResourceBreakdown(Resource, cAIResourceSubTypeEasy, BaseID);
         BaseID = mainBaseID;
         if (i == 0)
            gWoodBaseID = BaseID;
         else
            gGoldBaseID = BaseID;
         aiSetResourceBreakdown(Resource, cAIResourceSubTypeEasy, desiredPlans, PlanPriority, Percentage, BaseID);
         aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, desiredPlans);
         continue;
      }
      if ((numberMainBaseSites > 0) && (numberMainBaseSites < desiredPlans)) {
         aiSetResourceBreakdown(Resource, cAIResourceSubTypeEasy, numberMainBaseSites, PlanPriority, Percentage, mainBaseID);
         if (numberResBaseSites > 0) {  // We do have remote res
            aiSetResourceBreakdown(Resource, cAIResourceSubTypeEasy, desiredPlans - numberMainBaseSites, PlanPriority, Percentage, BaseID);	
            aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, desiredPlans);
         }
         else {  // No remote res...bummer.  Kill old breakdown, look for more
            if (BaseID != mainBaseID)		
               aiRemoveResourceBreakdown(Resource, cAIResourceSubTypeEasy, BaseID);   // Remove old breakdown
            //Try to find a new res base.
            if ((ResourceBaseID != -1) && (ResBaseEmpty == false))
               BaseID = kbBaseFindCreateResourceBase(Resource, cAIResourceSubTypeEasy, ResourceBaseID);
            else
               BaseID = kbBaseFindCreateResourceBase(Resource, cAIResourceSubTypeEasy, randomBaseID);
            if (BaseID >= 0) {
               aiSetResourceBreakdown(Resource, cAIResourceSubTypeEasy, desiredPlans - numberMainBaseSites, PlanPriority, Percentage, BaseID);	
               aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, desiredPlans);      // We can have the full amount
               if (i == 0)
                  gWoodBaseID = BaseID;
               else
                  gGoldBaseID = BaseID;					
            }
            else
               aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, numberMainBaseSites);   // That's all we get
         }
         continue;
      }

      if (numberMainBaseSites < 1) {
         aiRemoveResourceBreakdown(Resource, cAIResourceSubTypeEasy, mainBaseID);
         if ( numberResBaseSites >= desiredPlans ) {  // We have enough remote res
            aiSetResourceBreakdown(Resource, cAIResourceSubTypeEasy, desiredPlans, PlanPriority, Percentage, BaseID);
            aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, desiredPlans);
         }
         else if ( numberResBaseSites > 0 ) {   // We have some, but not enough
            aiSetResourceBreakdown(Resource, cAIResourceSubTypeEasy, numberResBaseSites, PlanPriority, Percentage, BaseID);
            aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, numberResBaseSites);
         }
         else {
            int oldResBase=BaseID;
            aiRemoveResourceBreakdown(Resource, cAIResourceSubTypeEasy, BaseID);   // Remove old breakdown
            //Try to find a new res base.
            if ( (ResourceBaseID != -1) && (ResBaseEmpty == false) )
               BaseID=kbBaseFindCreateResourceBase(Resource, cAIResourceSubTypeEasy, ResourceBaseID);
            else
               BaseID=kbBaseFindCreateResourceBase(Resource, cAIResourceSubTypeEasy, randomBaseID);
            if ( (BaseID < 0) && (gTransportMap) )
               BaseID = newResourceBase(oldResBase, Resource);  //try to find a res base on another island
            if (BaseID >= 0) {
               if (i == 0)
                  gWoodBaseID = BaseID;
               else
                  gGoldBaseID = BaseID;				
               numberResBaseSites = kbGetNumberValidResources(BaseID, Resource, cAIResourceSubTypeEasy);
               if (numberResBaseSites < desiredPlans)
                  desiredPlans = numberResBaseSites;
               aiPlanSetVariableInt(gGatherGoalPlanID, cNumberPlanType, 0, desiredPlans);      
               aiSetResourceBreakdown(Resource, cAIResourceSubTypeEasy, desiredPlans, PlanPriority, Percentage, BaseID);
            }
         }
         continue;
      }
   }
}
//==============================================================================
rule updateFoodBreakdown
minInterval 15
inactive
{
   if ( aiGetGameMode() == cGameModeDeathmatch ) {
      if ( (kbGetAge() < cAge4) && (xsGetTime() < 4*60*1000) )
         return;
   } 

   int mainBaseID = kbBaseGetMainID(cMyID);
   vector mainBaseLocation = kbBaseGetLocation(cMyID, mainBaseID);
   int easyPriority = 65;
   int aggressivePriority = 45;
   int mainFarmPriority = 90;
   int otherFarmPriority = 88;
   int numAggressivePlans = aiGetResourceBreakdownNumberPlans(cResourceFood, cAIResourceSubTypeHuntAggressive, mainBaseID);

   float distance = gMaximumBaseResourceDistance - 10;
   if ((kbGetAge() > cAge1) && (xsGetTime() > 12*60*1000))
      distance = 50;	
   //Get the number of valid resources spots.
   int numberAggressiveResourceSpots = kbGetNumberValidResources(mainBaseID, cResourceFood, cAIResourceSubTypeHuntAggressive, distance);
   int numberEasyResourceSpots = kbGetNumberValidResources(mainBaseID, cResourceFood, cAIResourceSubTypeEasy, distance);
   bool useHerds = false;
   if ( xsGetTime() >= 12*60*1000 ) {
      useHerds = ( getNumUnitsByRel(cUnitTypeHerdable, cUnitStateAlive, -1, cPlayerRelationAny, mainBaseLocation, 35.0, false) > 0 );
      if ( useHerds )
         numberEasyResourceSpots++;
   }
   // Only do one aggressive site at a time, they tend to take lots of gatherers
   if (numberAggressiveResourceSpots > 1)
      numberAggressiveResourceSpots = 1;

   int totalNumberResourceSpots = numberAggressiveResourceSpots + numberEasyResourceSpots;
   int gathererCount = kbUnitCount(cMyID, cUnitTypeAbstractVillager, cUnitStateAlive);
   int foodGathererCount = 0.5 + aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanGathererPct, cResourceFood) * gathererCount;

   if (foodGathererCount <= 2)
      foodGathererCount = 2;
   MoreFarms = foodGathererCount; // Update build more farms
   if (MoreFarms >= 20)
      MoreFarms = 20;

   // Preference order is existing farms (except in age 1), new farms if low on food sites, aggressive hunt (size permitting), easy, then age 1 farms.  
   int aggHunters = 0;
   int easy = 0;
   int farmers = 0;
   int unassigned = foodGathererCount;
   int farmerReserve = 0;  // Number of farms we already have, use them first unless Egypt first age (slow slow farming)
   int farmerPreBuild = 0; // Number of farmers to ask for ahead of time when food starts running low.
   int farmerReserveOtherBase1 = 0;  // Number of farms we already have at our otherBase1
   int farmerReserveOtherBase2 = 0;  // Number of farms we already have at our otherBase2
   int farmerReserveOtherBase3 = 0;  // Number of farms we already have at our otherBase3
   int farmerReserveOtherBase4 = 0;  // Number of farms we already have at our otherBase4

   int numBuilding1NearBase = -1;
   int numShooters = -1;
   int TC = -1;
   float distanceToMainBase = 0.0;
   vector otherBaseLocation = cInvalidVector;
   int farmsWanted = 3;

   if (gFarmBaseID >= 0) {
      farmerReserve = kbBaseGetNumberUnits(cMyID, gFarmBaseID, -1, cUnitTypeFarm);
      if (gOtherBase1ID > 0) {
         otherBaseLocation = kbBaseGetLocation(cMyID, gOtherBase1ID);
         numBuilding1NearBase = getNumUnits(cUnitTypeMilitaryBuilding, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         numShooters = getNumUnits(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         TC = getNumUnits(cUnitTypeAbstractSettlement, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         distanceToMainBase = xsVectorLength(mainBaseLocation - otherBaseLocation);
         if ((numBuilding1NearBase > 1) && (numShooters > 1) && (TC > 0) || (distanceToMainBase < 75.0) && (numShooters > 0) && (TC > 0)) {
            farmerReserveOtherBase1 = kbBaseGetNumberUnits(cMyID, gOtherBase1ID, -1, cUnitTypeFarm);
            if (farmerReserveOtherBase1 < farmsWanted)
               farmerReserveOtherBase1++;
            if (farmerReserveOtherBase1 > farmsWanted)
               farmerReserveOtherBase1 = farmsWanted;
            farmerReserve = farmerReserve + farmerReserveOtherBase1;
         }
      }
      if (gOtherBase2ID > 0) {
         otherBaseLocation = kbBaseGetLocation(cMyID, gOtherBase2ID);
         numBuilding1NearBase = getNumUnits(cUnitTypeMilitaryBuilding, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         numShooters = getNumUnits(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         TC = getNumUnits(cUnitTypeAbstractSettlement, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         distanceToMainBase = xsVectorLength(mainBaseLocation - otherBaseLocation);
         if ((numBuilding1NearBase > 1) && (numShooters > 1) && (TC > 0) || (distanceToMainBase < 75.0) && (numShooters > 0) && (TC > 0)) {
            farmerReserveOtherBase2 = kbBaseGetNumberUnits(cMyID, gOtherBase2ID, -1, cUnitTypeFarm);
            if (farmerReserveOtherBase2 < farmsWanted)
               farmerReserveOtherBase2++;
            if (farmerReserveOtherBase2 > farmsWanted)
               farmerReserveOtherBase2 = farmsWanted;
            farmerReserve = farmerReserve + farmerReserveOtherBase2;
         }
      }
      if (gOtherBase3ID > 0) {
         otherBaseLocation = kbBaseGetLocation(cMyID, gOtherBase3ID);
         numBuilding1NearBase = getNumUnits(cUnitTypeMilitaryBuilding, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         numShooters = getNumUnits(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         TC = getNumUnits(cUnitTypeAbstractSettlement, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         distanceToMainBase = xsVectorLength(mainBaseLocation - otherBaseLocation);
         if ((numBuilding1NearBase > 1) && (numShooters > 1) && (TC > 0) || (distanceToMainBase < 75.0) && (numShooters > 0) && (TC > 0)) {
            farmerReserveOtherBase3 = kbBaseGetNumberUnits(cMyID, gOtherBase3ID, -1, cUnitTypeFarm);
            if (farmerReserveOtherBase3 < farmsWanted)
               farmerReserveOtherBase3++;
            if (farmerReserveOtherBase3 > farmsWanted)
               farmerReserveOtherBase3 = farmsWanted;
            farmerReserve = farmerReserve + farmerReserveOtherBase3;
         }
      }
      if (gOtherBase4ID > 0) {
         otherBaseLocation = kbBaseGetLocation(cMyID, gOtherBase4ID);
         numBuilding1NearBase = getNumUnits(cUnitTypeMilitaryBuilding, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         numShooters = getNumUnits(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         TC = getNumUnits(cUnitTypeAbstractSettlement, cUnitStateAlive, -1, cMyID, otherBaseLocation, 25.0);
         distanceToMainBase = xsVectorLength(mainBaseLocation - otherBaseLocation);
         if ((numBuilding1NearBase > 1) && (numShooters > 1) && (TC > 0) || (distanceToMainBase < 75.0) && (numShooters > 0) && (TC > 0)) {
            farmerReserveOtherBase4 = kbBaseGetNumberUnits(cMyID, gOtherBase4ID, -1, cUnitTypeFarm);
            if (farmerReserveOtherBase4 < farmsWanted)
               farmerReserveOtherBase4++;
            if (farmerReserveOtherBase4 > farmsWanted)
               farmerReserveOtherBase4 = farmsWanted;
            farmerReserve = farmerReserve + farmerReserveOtherBase4;
         }
      }
   }

   if (farmerReserve > unassigned)
      farmerReserve = unassigned;   // Can't reserve more than we have!
   if ((farmerReserve > 0) && (kbGetAge() > cAge1)) {
      unassigned = unassigned - farmerReserve;
   }

   float aggressiveAmount = kbGetAmountValidResources(mainBaseID, cResourceFood, cAIResourceSubTypeHuntAggressive, distance);
   float easyAmount = kbGetAmountValidResources(mainBaseID, cResourceFood, cAIResourceSubTypeEasy, distance);
   float totalAmount = aggressiveAmount + easyAmount;

   if ( (aiGetGameMode() == cGameModeLightning) || (aiGetGameMode() == cGameModeDeathmatch) ||
        (xsGetTime() > 8*60*1000) )
      totalAmount = 200;

   if ( kbProtoUnitAvailable(cUnitTypeFarm) && (xsGetTime() > 3*60*1000) ) {
      if ((totalNumberResourceSpots < 2) || (totalAmount <= 1500) || (gFarming) || (kbGetAge() > cAge2)) {
         farmerPreBuild = 4;  
         if (farmerPreBuild > unassigned)
            farmerPreBuild = unassigned;
         unassigned = unassigned - farmerPreBuild;
         if (farmerPreBuild > 0)
            gFarming = true;
         static bool extraFarms = false;
         if (extraFarms == false) {
            if ( (aiGetGameMode() != cGameModeLightning) && (aiGetWorldDifficulty() >= cDifficultyHard) )
               xsEnableRule("buildExtraFarms");
            xsEnableRule("fixUnfinishedFarms");
            extraFarms = true;
         }			
      }
   }

   int numPlansWanted = 2;
   int farmThreshold = 12;
   if ( gFarming && (farmerReserve >= farmThreshold) )
      numPlansWanted = 1;

   int numTemples = kbUnitCount(cMyID, cUnitTypeAbstractTemple, cUnitStateAliveOrBuilding);
   int houseProtoID = cUnitTypeLogicalTypeHouses;
   int numHouses = kbUnitCount(cMyID, houseProtoID, cUnitStateAlive);
   if ( (kbGetAge() == cAge1) && (numTemples < 1) || (unassigned < numPlansWanted) )
      numPlansWanted = 1;
   if ( unassigned <= 0 )
      numPlansWanted = 0;

   if (numPlansWanted > totalNumberResourceSpots) {
      if ((totalNumberResourceSpots < 1) && (kbGetAge() < cAge3))
         numPlansWanted = 1;
      else
         numPlansWanted = totalNumberResourceSpots;
   }

   int numPlansUnassigned = numPlansWanted;
   int minVillsToStartAggressive = aiGetMinNumberNeedForGatheringAggressives();

   int HuntPlanState = aiPlanGetState(findPlanByString("AutoGPFoodHuntAggressive"));
   // Start a new plan if we have enough villies and we have the resource.
   // If we have a plan open, don't kill it as long as we are within 2 of the needed min...the plan will steal from elsewhere.
   if ( (numPlansUnassigned > 0) && (numberAggressiveResourceSpots > 0) && (unassigned > minVillsToStartAggressive) ||
        (numAggressivePlans > 0) && (HuntPlanState > 0) && (unassigned >= minVillsToStartAggressive - 2) ) {
      aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeHuntAggressive, 1);
      aggHunters = aiGetMinNumberNeedForGatheringAggressives(); // This plan will over-grab due to high priority
      if (numPlansUnassigned == 1)
         aggHunters = unassigned - 1;   // use them all if we're small enough for 1 plan		
      numPlansUnassigned--;
      unassigned = unassigned - aggHunters;
      numberAggressiveResourceSpots = 1;  // indicates 1 used
   }
   else {
      aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeHuntAggressive, 0);
      numberAggressiveResourceSpots = 0;  // indicate none used
   }

   if ( (numPlansUnassigned > 0) && (numberEasyResourceSpots > 0) ) {
      if (numberEasyResourceSpots > numPlansUnassigned)
         numberEasyResourceSpots = numPlansUnassigned;
      aiPlanSetVariableInt( gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeEasy, numberEasyResourceSpots );
      easy = (numberEasyResourceSpots * unassigned) / numPlansUnassigned;
      unassigned = unassigned - easy;
      numPlansUnassigned = numPlansUnassigned - numberEasyResourceSpots;
   }
   else if ( useHerds == false ) {
      aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeEasy, 0);
      numberEasyResourceSpots = 0;
   }
   // If we still have some unassigned, and we're in the first age, try to dump them into a plan.
   if ( (kbGetAge() == cAge1) && (unassigned > 0) ) {
      if ((aggHunters > 0) && (unassigned > 0)) {
         aggHunters = aggHunters + unassigned;
         unassigned = 0;
      }
      if ( (easy > 0) && (unassigned > 0) ) {
         easy = easy + unassigned;
         unassigned = 0;
      }
      //If we're here and unassigned > 0, we'll just make an easy plan and dump them there, hoping
      //that there's easy food somewhere outside our base.
      numberEasyResourceSpots++;
      aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeEasy, numberEasyResourceSpots);
      easy = easy + unassigned;
      unassigned = 0;
      if ( gMaximumBaseResourceDistance < 110.0 )
         gMaximumBaseResourceDistance = gMaximumBaseResourceDistance + 10.0; 
   }  	

   //Now, the number of farmers we want is the unassigned total, plus reserve (existing farms) and prebuild (plan ahead).
   farmers = farmerReserve + farmerPreBuild;
   unassigned = unassigned - farmers;
   if (unassigned > 0) {
      //Still unassigned?  Make an extra easy plan, hope they can find food somewhere
      numberEasyResourceSpots++;
      aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeEasy, numberEasyResourceSpots);
      easy = easy + unassigned;
      unassigned = 0;
   }

   int numFarmPlansWanted = 0;
   if (farmers > 0) {
      int farmersAtMainBase = 0;
      farmersAtMainBase = farmers;
      if (gOtherBase1ID > 0) {
         if ((farmersAtMainBase > 1) && (farmerReserveOtherBase1 > 0)) {
            if (farmersAtMainBase < farmerReserveOtherBase1)
               farmerReserveOtherBase1 = farmersAtMainBase;
            farmersAtMainBase = farmersAtMainBase - farmerReserveOtherBase1;
            numFarmPlansWanted++;
         }
      }
      if (gOtherBase2ID > 0) {
         if ((farmersAtMainBase > 1) && (farmerReserveOtherBase2 > 0)) {
            if (farmersAtMainBase < farmerReserveOtherBase2)
               farmerReserveOtherBase2 = farmersAtMainBase;
            farmersAtMainBase = farmersAtMainBase - farmerReserveOtherBase2;
            numFarmPlansWanted++;
         }
      }
      if (gOtherBase3ID > 0) {
         if ((farmersAtMainBase > 1) && (farmerReserveOtherBase3 > 0)) {
            if (farmersAtMainBase < farmerReserveOtherBase3)
               farmerReserveOtherBase3 = farmersAtMainBase;
            farmersAtMainBase = farmersAtMainBase - farmerReserveOtherBase3;
            numFarmPlansWanted++;
         }
      }
      if (gOtherBase4ID > 0) {
         if ((farmersAtMainBase > 1) && (farmerReserveOtherBase4 > 0)) {
            if (farmersAtMainBase < farmerReserveOtherBase4)
               farmerReserveOtherBase4 = farmersAtMainBase;
            farmersAtMainBase = farmersAtMainBase - farmerReserveOtherBase4;
            numFarmPlansWanted++;
         }
      }
      if (farmersAtMainBase < 0)
         farmersAtMainBase = 0;

      if (farmersAtMainBase > 0) {
         if ( (aiGetWorldDifficulty() >= cDifficultyHard) && (aiGetGameMode() != cGameModeLightning) )
            numFarmPlansWanted = numFarmPlansWanted + 2;	
         else
            numFarmPlansWanted = numFarmPlansWanted + 1;               
      }
      gFarming = true;
   }
   else
      gFarming = false;

   //Egyptians can farm in the first age.
   if ( kbProtoUnitAvailable(cUnitTypeFarm) && (gFarmBaseID != -1) && (xsGetTime() > 2*60*1000) )
      aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeFarm, numFarmPlansWanted);
   else
      numFarmPlansWanted = 0;

   //Set breakdown based on goals.
   if (gOtherBase1ID > 0) {
      if ((numFarmPlansWanted > 1) && (farmerReserveOtherBase1 > 0)) {
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 1, otherFarmPriority, (1.0*farmerReserveOtherBase1)/foodGathererCount, gOtherBase1ID);
         numFarmPlansWanted--;
      }
      else
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 0, otherFarmPriority, 0, gOtherBase1ID);
   }
   if (gOtherBase2ID > 0) {
      if ((numFarmPlansWanted > 1) && (farmerReserveOtherBase2 > 0)) {
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 1, otherFarmPriority, (1.0*farmerReserveOtherBase2)/foodGathererCount, gOtherBase2ID);
         numFarmPlansWanted--;
      }
      else
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 0, otherFarmPriority, 0, gOtherBase2ID);
   }
   if (gOtherBase3ID > 0) {
      if ((numFarmPlansWanted > 1) && (farmerReserveOtherBase3 > 0)) {
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 1, otherFarmPriority, (1.0*farmerReserveOtherBase2)/foodGathererCount, gOtherBase3ID);
         numFarmPlansWanted--;
      }
      else
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 0, otherFarmPriority, 0, gOtherBase3ID);
   }
   if (gOtherBase4ID > 0) {
      if ( (numFarmPlansWanted > 1) && (farmerReserveOtherBase4 > 0) ) {
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 1, otherFarmPriority, (1.0*farmerReserveOtherBase2)/foodGathererCount, gOtherBase4ID);
         numFarmPlansWanted--;
      }
      else
         aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, 0, otherFarmPriority, 0, gOtherBase4ID);
   }
  //0.0+ to make sure floating point division.
   aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, numFarmPlansWanted, mainFarmPriority, (0.0+farmersAtMainBase)/foodGathererCount, gFarmBaseID);
   aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeHuntAggressive, numberAggressiveResourceSpots, aggressivePriority, (0.0+aggHunters)/foodGathererCount, mainBaseID); 
   aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeEasy, numberEasyResourceSpots, easyPriority, (0.0+easy)/foodGathererCount, mainBaseID);
}

//==============================================================================
void updateResourceHandler(int parm=0)
{
   if (parm == cResourceFood)
      updateFoodBreakdown();
   else
      updateBreakdowns();
}

//==============================================================================
int changeMainBase(int newSettle = -1)
{
   int newBaseID=kbUnitGetBaseID(newSettle);
   int oldMainBase=kbBaseGetMainID(cMyID);
   vector settlementPosition=kbUnitGetPosition(newSettle);
   // set the flags for the new base.
   //Figure out the front vector.
   vector baseFront=xsVectorNormalize(kbGetMapCenter()-settlementPosition);
   kbBaseSetFrontVector(cMyID, newBaseID, baseFront);
   //Military gather point.
   vector militaryGatherPoint=settlementPosition+baseFront*18;
   kbBaseSetMilitaryGatherPoint(cMyID, newBaseID, militaryGatherPoint);
   //Set the other flags.
   kbBaseSetMilitary(cMyID, newBaseID, true);
   kbBaseSetEconomy(cMyID, newBaseID, true);
   //Set the resource distance limit.
   kbBaseSetMaximumResourceDistance(cMyID, newBaseID, gMaximumBaseResourceDistance);
   // set new town location
   kbSetTownLocation(settlementPosition);
   //Add the settlement to the base.
   kbBaseAddUnit(cMyID, newBaseID, newSettle);
   kbBaseSetSettlement(cMyID, newBaseID, true);

   // remove all farm breakdowns
   aiRemoveResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, oldMainBase);
   aiRemoveResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, gOtherBase1ID);
   aiRemoveResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, gOtherBase2ID);
   aiRemoveResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, gOtherBase3ID);
   aiRemoveResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, gOtherBase4ID);

   // Switch the mainBase and set the main-ness of the base.
   aiSwitchMainBase(newBaseID, true);
   kbBaseSetMain(cMyID, newBaseID, true);

   // set the flags for the old base.
   kbBaseSetMain(cMyID, oldMainBase, false);

   int mainBaseID = kbBaseGetMainID(cMyID);

   // destroy the old defend plans and wallplans
   aiPlanDestroy( gDefendPlanID );
   aiPlanDestroy( gMBDefPlan1ID );
   if (gBuildWallsAtMainBase) {
      gResetWallPlans = true;
      aiPlanDestroy( gMainBaseAreaWallTeam1PlanID );
      aiPlanDestroy( gMainBaseAreaWallTeam2PlanID );
      gMainBaseAreaWallTeam1PlanID = -1;
      gMainBaseAreaWallTeam2PlanID = -1;
   }

   if (mainBaseID == gOtherBase1ID) {
      aiPlanDestroy(gOtherBase1DefPlanID);
      gOtherBase1ID = -1;
      gOtherBase1UnitID = -1;
      if (gBuildWalls) {
         aiPlanDestroy(gOtherBase1RingWallTeamPlanID);
         xsDisableRule("otherBase1RingWallTeam");
      }
   }
   else if (mainBaseID == gOtherBase2ID) {
      aiPlanDestroy(gOtherBase2DefPlanID);
      gOtherBase2ID = -1;
      gOtherBase2UnitID = -1;
      if (gBuildWalls) {
         aiPlanDestroy(gOtherBase2RingWallTeamPlanID);
         xsDisableRule("otherBase2RingWallTeam");
      }
   }
   else if (mainBaseID == gOtherBase3ID) {
      aiPlanDestroy(gOtherBase3DefPlanID);
      gOtherBase3ID = -1;
      gOtherBase3UnitID = -1;
      if (gBuildWalls) {
         aiPlanDestroy(gOtherBase3RingWallTeamPlanID);
         xsDisableRule("otherBase3RingWallTeam");
      }
   }
   else if (mainBaseID == gOtherBase4ID) {
      aiPlanDestroy(gOtherBase4DefPlanID);
      gOtherBase4ID = -1;
      gOtherBase4UnitID = -1;
      if (gBuildWalls) {
         aiPlanDestroy(gOtherBase4RingWallTeamPlanID);
         xsDisableRule("otherBase4RingWallTeam");
      }
   }

   //increase the gHouseAvailablePopRebuild
   gHouseAvailablePopRebuild = 22;
   //restart fishing too, if active.
   if ( gFishing && (gFishPlanID != -1) && aiPlanGetActive(gFishPlanID) ) {
      aiPlanDestroy( gFishPlanID );
      gFishPlanID = -1;
      int docks = kbUnitCount( cMyID, cUnitTypeDock, cUnitStateAliveOrBuilding );
      for(i=0; < docks) {
         int Dock = findUnitByIndex(cUnitTypeDock, i, cUnitStateAliveOrBuilding);
         if (Dock != -1)
            aiTaskUnitDelete( Dock );    			
      }
      xsEnableRule("fishing");
   }
   if (ResourceBaseID != -1) {
      kbBaseDestroy(cMyID, ResourceBaseID);
      ResourceBaseID = CreateBaseInBackLoc(newBaseID, 25, gMaximumBaseResourceDistance, "Temp Resource Base");
   }
   // call these to update the gatherplans with the new mainbase
   updateFoodBreakdown();
   updateBreakdowns();
   return( newBaseID );
}

//==============================================================================
rule relocateFarming
minInterval 108 //starts in cAge2 (or cAge3 on transport maps)
inactive
{
   int mainBaseID = kbBaseGetMainID(cMyID);
   //Fixup the old RB for farming.
   if (gFarmBaseID != -1) {
      if (findNumUnitsInBase(cMyID, gFarmBaseID, cUnitTypeAbstractSettlement, cUnitStateAliveOrBuilding) > 0)
         return;
      //Remove the old breakdown.
      aiRemoveResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, gFarmBaseID);
   }

   //If no settlement, then move the farming to another base that has a settlement.
   int unit = findUnit(cUnitTypeAbstractSettlement);
   if (unit != -1) {
      //Get new base ID.
      gFarmBaseID = kbUnitGetBaseID(unit);
      //Remove the breakdown if there's already one for the farm base.
      aiRemoveResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, gFarmBaseID);
      //Make a new breakdown.
      int numFarmPlans = aiPlanGetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeFarm);
      aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFarm, numFarmPlans, 90, 1.0, gFarmBaseID);
      if (cvMapSubType != VINLANDSAGAMAP) {
         //update mainbase, should work now
         changeMainBase( unit );
         if (ShowAIDebug) aiEcho("I'm in trouble.. new Mainbase ID: "+unit);
         }
   }
   else {
      //If there are no other bases without settlements... stop farming.
      gFarmBaseID = -1;
      aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeFarm, 0);
   }
}

//==============================================================================
void econAge2Handler(int age=1)
{
   // Start early settlement monitor if not already active (vinland, team mig, nomad)
   xsEnableRule("buildSettlements");

   //fishing
   if (gFishing)
      xsEnableRule("getPurseSeine");

   // Transports
   if (gTransportMap) 
      xsEnableRule("getEnclosedDeck");

   if ( (aiGetGameMode() == cGameModeDeathmatch) || (aiGetGameMode() == cGameModeLightning) ) {
      const int Armory = cUnitTypeGuildMeso;
      createSimpleBuildPlan(Armory, 1, 100, false, true, cEconomyEscrowID, kbBaseGetMainID(cMyID), 3);
      createSimpleBuildPlan(cUnitTypeHouse, 6, 100, false, true, cEconomyEscrowID, kbBaseGetMainID(cMyID), 2);
   }

   // Set escrow caps
   kbEscrowSetCap(cEconomyEscrowID, cResourceFood, 800.0);    // Age 3
   kbEscrowSetCap(cEconomyEscrowID, cResourceWood, 200.0);
   kbEscrowSetCap(cEconomyEscrowID, cResourceGold, 500.0);    // Age 3
   kbEscrowSetCap(cEconomyEscrowID, cResourceFavor, 30.0);
   kbEscrowSetCap(cMilitaryEscrowID, cResourceFood, 100.0);
   kbEscrowSetCap(cMilitaryEscrowID, cResourceWood, 200.0);   // Towers
   kbEscrowSetCap(cMilitaryEscrowID, cResourceGold, 200.0);   // Towers
   kbEscrowSetCap(cMilitaryEscrowID, cResourceFavor, 30.0);
}


//==============================================================================
void econAge3Handler(int age=0)
{
   // enable the relocateFarming rule now if this is a transport map
   if (gTransportMap)
      xsEnableRule("relocateFarming");

   xsEnableRule("getFortifiedTownCenter");

      // Fishing
   if (gFishing) 
      xsEnableRule("getSaltAmphora");

   if ((aiGetGameMode() == cGameModeDeathmatch) || (aiGetGameMode() == cGameModeLightning)) {
      createSimpleBuildPlan(cUnitTypeMarket, 1, 100, false, true, cEconomyEscrowID, kbBaseGetMainID(cMyID), 5);
      gExtraMarket = true; // Set the global so we know to look for SECOND market before trading.       
      createSimpleBuildPlan(cUnitTypeHouse, 2, 100, false, true, cEconomyEscrowID, kbBaseGetMainID(cMyID), 1);
   }

   // Set escrow caps
   kbEscrowSetCap( cEconomyEscrowID, cResourceFood, 1000.0);    // Age 4
   kbEscrowSetCap( cEconomyEscrowID, cResourceWood, 400.0);     // Settlements, upgrades
   kbEscrowSetCap( cEconomyEscrowID, cResourceGold, 1000.0);    // Age 4
   kbEscrowSetCap( cEconomyEscrowID, cResourceFavor, 30.0);
   kbEscrowSetCap( cMilitaryEscrowID, cResourceFood, 400.0);
   kbEscrowSetCap( cMilitaryEscrowID, cResourceWood, 400.0);
   kbEscrowSetCap( cMilitaryEscrowID, cResourceGold, 400.0);
   kbEscrowSetCap( cMilitaryEscrowID, cResourceFavor, 30.0);

   kbBaseSetMaximumResourceDistance(cMyID, kbBaseGetMainID(cMyID), 85.0);
}

//==============================================================================
void econAge4Handler(int age=0)
{
   int numBuilders = 0;
   int bigBuildingType = MyFortress;
   if (aiGetGameMode() == cGameModeDeathmatch) {
      createSimpleBuildPlan(cUnitTypeBarracks, 2, 90, true, false, cMilitaryEscrowID, kbBaseGetMainID(cMyID), 1);
      createSimpleBuildPlan(cUnitTypeCounterBuilding, 2, 90, true, false, cMilitaryEscrowID, kbBaseGetMainID(cMyID), 1);
      createSimpleBuildPlan(bigBuildingType, 3, 80, true, false, cMilitaryEscrowID, kbBaseGetMainID(cMyID), 2);
   }


   // Set escrow caps tighter
   if ((TitanAvailable) && (gTransportMap == false)) {
      kbEscrowSetCap(cEconomyEscrowID, cResourceFood, 1000.0);
      kbEscrowSetCap(cEconomyEscrowID, cResourceWood, 1000.0);     
      kbEscrowSetCap(cEconomyEscrowID, cResourceGold, 1000.0);    
      kbEscrowSetCap(cEconomyEscrowID, cResourceFavor, 60.0);
   }
   else  {
      kbEscrowSetCap(cEconomyEscrowID, cResourceFood, 300.0);    
      kbEscrowSetCap(cEconomyEscrowID, cResourceWood, 300.0);
      kbEscrowSetCap(cEconomyEscrowID, cResourceGold, 300.0);    
      kbEscrowSetCap(cEconomyEscrowID, cResourceFavor, 30.0);
   }

   kbEscrowSetCap( cMilitaryEscrowID, cResourceFood, 300.0);
   kbEscrowSetCap( cMilitaryEscrowID, cResourceWood, 300.0);   
   kbEscrowSetCap( cMilitaryEscrowID, cResourceGold, 300.0);   
   kbEscrowSetCap( cMilitaryEscrowID, cResourceFavor, 30.0);
}

//==============================================================================
void createCivPopPlan()
{    
   gCivPopPlanID = aiPlanCreate( "civPop"+xsGetTime(), cPlanTrain );
   if (gCivPopPlanID >= 0) {
      //Get our mainline villager PUID.
      const int gathererPUID = cUnitTypeVillagerAztec;
      aiPlanSetVariableInt(gCivPopPlanID, cTrainPlanUnitType, 0, gathererPUID);
      //Train off of economy escrow.
      aiPlanSetEscrowID(gCivPopPlanID, cEconomyEscrowID);
      //Default to 10.
      aiPlanSetVariableInt( gCivPopPlanID, cTrainPlanNumberToMaintain, 0, (kbGetAge()+1)*8 );  
      aiPlanSetVariableInt(gCivPopPlanID, cTrainPlanBuildFromType, 0, cUnitTypeAbstractSettlement);  
      aiPlanSetDesiredPriority(gCivPopPlanID, 98);
      aiPlanSetActive(gCivPopPlanID);
   }
}	
//==============================================================================
void initEcon() //setup the initial Econ stuff.
{  
   //Set our update resource handler.
   //    aiSetUpdateResourceEventHandler("updateResourceHandler");
   //    aiSetUpdateResourceLimit( int resourceID, float limit );

   //Set up auto-gather escrows.
   aiSetAutoGatherEscrowID(cEconomyEscrowID);
   aiSetAutoFarmEscrowID(cEconomyEscrowID);

   //Distribute the resources we have.
   kbEscrowAllocateCurrentResources();

   //Set our bases.
   gFarmBaseID = kbBaseGetMainID(cMyID);
   gGoldBaseID = kbBaseGetMainID(cMyID);
   gWoodBaseID = kbBaseGetMainID(cMyID);

   //Make a plan to manage the villager population.
   createCivPopPlan();

   gHerdPlanID = aiPlanCreate("GatherHerdable Plan", cPlanHerd);
   aiPlanSetVariableFloat( gHerdPlanID, cHerdPlanBuildingTypeID, 0, cUnitTypeGranary );
   aiPlanSetVariableFloat( gHerdPlanID, cHerdPlanDistance, 0, 16.0 );
   aiPlanAddUnitType( gHerdPlanID, cUnitTypeHerdable, 0, 100, 100 );
   if ( (cRandomMapName != "vinlandsaga") && (cRandomMapName != "team migration") )
      aiPlanSetBaseID( gHerdPlanID, kbBaseGetMainID(cMyID) );	
   aiPlanSetActive(gHerdPlanID);

   xsEnableRule("econForecastAge1");
}

//==============================================================================
void postInitEcon()
{
   //Set the RGP weights.  Script in charge.
   aiPlanSetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanScriptRPGPct, 0, 1.0);
   aiPlanSetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanCostRPGPct, 0, 0.0);
   aiSetResourceGathererPercentageWeight(cRGPScript, 1.0);
   aiSetResourceGathererPercentageWeight(cRGPCost, 0.0);

   //Setup AI Cost weights.
   kbSetAICostWeight(cResourceFood, aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanResourceCostWeight, cResourceFood));
   kbSetAICostWeight(cResourceWood, aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanResourceCostWeight, cResourceWood));
   kbSetAICostWeight(cResourceGold, aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanResourceCostWeight, cResourceGold));
   kbSetAICostWeight(cResourceFavor, aiPlanGetVariableFloat(gGatherGoalPlanID, cGatherGoalPlanResourceCostWeight, cResourceFavor));

   //Set initial gatherer percentages.
   float foodGPct=aiPlanGetVariableFloat(gGatherGoalPlanID,0, cResourceFood);    
   float woodGPct=aiPlanGetVariableFloat(gGatherGoalPlanID, 0, cResourceWood);   
   float goldGPct=aiPlanGetVariableFloat(gGatherGoalPlanID, 0, cResourceGold);   
   float favorGPct=aiPlanGetVariableFloat(gGatherGoalPlanID, 0, cResourceFavor);

   aiSetResourceGathererPercentage(cResourceFood, 1.0, false, cRGPScript);	// Changed these to 100% food early then
   aiSetResourceGathererPercentage(cResourceWood, 0.0, false, cRGPScript);	// the setEarlyEcon rule above will set the 
   aiSetResourceGathererPercentage(cResourceGold, 0.0, false, cRGPScript);	// former "initial" values once we have 7 (or 3 atlantean) gatherers.
   aiSetResourceGathererPercentage(cResourceFavor, 0.0, false, cRGPScript);
   aiNormalizeResourceGathererPercentages(cRGPScript);

   //Set up the initial resource break downs.
   int numFoodEasyPlans=aiPlanGetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeEasy);
   int numFoodHuntAggressivePlans=aiPlanGetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeHuntAggressive);
   int numFishPlans=aiPlanGetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeFish);
   int numWoodPlans=aiPlanGetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumWoodPlans, 0);
   int numGoldPlans=aiPlanGetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumGoldPlans, 0);
   int numFavorPlans=aiPlanGetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFavorPlans, 0);
   aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeEasy, numFoodEasyPlans, 100, 1.0, kbBaseGetMainID(cMyID));
   aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeHuntAggressive, numFoodHuntAggressivePlans, 90, 1.0, kbBaseGetMainID(cMyID));
   aiSetResourceBreakdown(cResourceFood, cAIResourceSubTypeFish, numFishPlans, 100, 1.0, kbBaseGetMainID(cMyID));

   aiSetResourceBreakdown(cResourceWood, cAIResourceSubTypeEasy, numWoodPlans, 55, 1.0, kbBaseGetMainID(cMyID));
   aiSetResourceBreakdown(cResourceGold, cAIResourceSubTypeEasy, numGoldPlans, 50, 1.0, kbBaseGetMainID(cMyID));
   aiSetResourceBreakdown(cResourceFavor, cAIResourceSubTypeEasy, numFavorPlans, 40, 1.0, kbBaseGetMainID(cMyID));
}

//==============================================================================
rule fishing
minInterval 1 //starts in cAge1
inactive
{
   static int Run = 0;
   xsSetRuleMinIntervalSelf(11);
   if ((cRandomMapName == "river styx") || (aiPlanGetActive(gFishPlanID))) {
      xsDisableSelf();
      return;
   }
   WaitForDock = true;
   if ((cvMapSubType == WATERNOMADMAP) && (kbUnitCount(cMyID, cUnitTypeAbstractSettlement, cUnitStateAlive) < 1))
      return;
   int mainBaseID = kbBaseGetMainID(cMyID);
   vector mainBaseLocation = kbBaseGetLocation(cMyID, mainBaseID);

   //Get the closest water area.  if there isn't one, we can't fish.
   static int areaID=-1;
   if (areaID == -1)
      areaID = kbAreaGetClosetArea(mainBaseLocation, cAreaTypeWater);
   if (areaID == -1) {
      xsDisableSelf();
      return;
   }

   //Get our fish gatherer.
   const int fishGatherer = cUnitTypeFishingShipAztec;

   if ((gTransportMap == false) && (xsGetTime() < 1*30*1000) && (cRandomMapName != "anatolia"))
      return;

   if (gTransportMap)
      gNumBoatsToMaintain = gNumBoatsToMaintain + aiRandInt(4);
   if (cRandomMapName == "Basin")
      gNumBoatsToMaintain = 4;

   if (kbUnitCount(0, cUnitTypeFish) < 1)
      gNumBoatsToMaintain = 1;


   //Create the fish plan.
   int fishPlanID = aiPlanCreate("FishPlan", cPlanFish);
   if (fishPlanID >= 0) {
      aiPlanSetDesiredPriority(fishPlanID, 52);
      aiPlanSetVariableVector(fishPlanID, cFishPlanLandPoint, 0, mainBaseLocation);
      aiPlanSetVariableVector(fishPlanID, cFishPlanWaterPoint, 0, kbAreaGetCenter(areaID));
      aiPlanSetVariableBool(fishPlanID, cFishPlanAutoTrainBoats, 0, true);
      aiPlanSetEscrowID(fishPlanID, cEconomyEscrowID);
      aiPlanAddUnitType(fishPlanID, fishGatherer, 2, gNumBoatsToMaintain, gNumBoatsToMaintain);
      aiPlanSetVariableFloat(fishPlanID, cFishPlanMaximumDockDist, 0, 500.0);
      gFishing = true;
      aiPlanSetActive(fishPlanID);
      gFishPlanID = fishPlanID;
   }
   aiPlanSetVariableInt(gGatherGoalPlanID, cGatherGoalPlanNumFoodPlans, cAIResourceSubTypeFish, 1);
   Run = Run + 1;
   if (Run > 1) {
      xsDisableSelf();
      return; 
   }

   gHouseAvailablePopRebuild = gHouseAvailablePopRebuild + 3;

   if (cRandomMapName == "Basin" && cMyCiv != cCivPoseidon) {
      xsDisableSelf();
      return;
   }

   if ((gTransportMap) || (cRandomMapName == "anatolia") && (gWaterExploreID == -1)) {
      //Make a plan to explore with the water scout.
      gWaterExploreID = aiPlanCreate("Explore_Water", cPlanExplore);
      if (gWaterExploreID >= 0) {
         aiPlanAddUnitType(gWaterExploreID, gWaterScout, 1, 1, 1);
         aiPlanSetDesiredPriority(gWaterExploreID, 100);
         aiPlanSetVariableBool(gWaterExploreID, cExplorePlanDoLoops, 0, false);
         aiPlanSetVariableBool(gWaterExploreID, cExplorePlanAvoidingAttackedAreas, 0, false);
         aiPlanSetVariableFloat(gWaterExploreID, cExplorePlanLOSMultiplier, 0, 1.5); //Test
         aiPlanSetEscrowID(gWaterExploreID, cEconomyEscrowID);
         aiPlanSetActive(gWaterExploreID);
      }
   }
   xsDisableSelf();
}

//==============================================================================
rule PurgeLostEcoUnits
minInterval 38 //starts in cAge1
inactive
{
   vector mainBaseLocation = kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID));
   int number = getNumUnits(cUnitTypeAbstractVillager, cUnitStateAlive, cActionIdle, cMyID);
   for(i=0; < number) {
      int Villager = findUnitByIndex(cUnitTypeAbstractVillager, i, cUnitStateAlive, cActionIdle);
      vector UnitLocation = kbUnitGetPosition(Villager);
      int AreaID = kbAreaGetIDByPosition(UnitLocation);
      if ( (kbUnitGetPlanID(Villager) == -1) && (SameAG(UnitLocation, mainBaseLocation) == false) &&
         (kbAreaGetType(AreaID) != cAreaTypeWater) &&
      (NumUnitsOnAreaGroupByRel(false, kbAreaGroupGetIDByPosition(UnitLocation), cUnitTypeAbstractSettlement, cPlayerRelationAny) <= 0) ) {
         aiTaskUnitDelete(Villager);  
         break;
      }
   }
   // Check Caravans too
   number = getNumUnits(cUnitTypeAbstractTradeUnit, cUnitStateAlive, cActionIdle, cMyID);
   for(i=0; < number) {
      int Caravan = findUnitByIndex(cUnitTypeAbstractTradeUnit, i, cUnitStateAlive, cActionIdle);
      UnitLocation = kbUnitGetPosition(Caravan);
      AreaID = kbAreaGetIDByPosition(UnitLocation);
      if ( (SameAG(UnitLocation, mainBaseLocation) == false) && (kbAreaGetType(AreaID) != cAreaTypeWater) ) {
         aiTaskUnitDelete(Caravan);     
         break;
      }			
   }	
}

//==============================================================================
rule randomUpgrader
minInterval 61 //starts in cAge5
inactive
{
   if ( TitanAvailable && (kbGetTechStatus(cTechSecretsoftheTitans) < cTechStatusResearching) )
      return;
   //Don't do anything until we have some pop.
   int maxPop = kbGetPopCap();
   if (maxPop < 120)
      return;
   //If we still have some pop slots to fill, quit.
   int currentPop = kbGetPop();
   if ((maxPop - currentPop) > 20)
      return;
   //If we have lots of resources, get a random upgrade.
   float currentFood = kbResourceGet(cResourceFood);
   float currentWood = kbResourceGet(cResourceWood);
   float currentGold = kbResourceGet(cResourceGold);
   if ( (currentFood >= 1000) && (currentWood >= 1000) && (currentGold >= 1000) ) {
      int upgradeTechID = -1;
      for(i=0; < 6) {
         upgradeTechID = kbTechTreeGetRandomUnitUpgrade();
         //Dont make another plan if we already have one.
         if ( (aiPlanGetIDByTypeAndVariableType(cPlanProgression, cProgressionPlanGoalTechID, upgradeTechID) >= 0) ||
            (aiPlanGetIDByTypeAndVariableType(cPlanResearch, cResearchPlanTechID, upgradeTechID) >= 0) ) {
            upgradeTechID = -1;
            continue;
         }
      }
      if ( upgradeTechID < 0 )
         return;
      int planID = aiPlanCreate("randomUpgrade", cPlanResearch);
      aiPlanSetVariableInt(planID, cResearchPlanTechID, 0, upgradeTechID);
      aiPlanSetDesiredPriority(planID, 50);
      aiPlanSetEscrowID(planID, cMilitaryEscrowID);
      aiPlanSetActive(planID);
   }
}

//==============================================================================
rule monitorTrade
inactive
minInterval 23 //starts in cAge3, activated in tradeWithCaravans
{
   if ( kbUnitGetCurrentHitpoints(gTradeMarketUnitID) <= 0.0 ) {
      int activeTradePlans = aiPlanGetNumber(cPlanTrade, -1, true);
      for(i=0; < activeTradePlans) {
         int tradePlanIndexID = aiPlanGetIDByIndex(cPlanTrade, -1, true, i);
         aiPlanDestroy(tradePlanIndexID);
      }
      gTradePlanID = -1;
      return;
   }

   int mainBaseID = kbBaseGetMainID(cMyID);
   const int tradeCartPUID = cUnitTypeCaravanGreek;
   bool test = false;

   if (gTradePlanID == -1) {
      if ( kbUnitGetCurrentHitpoints(gTradeMarketUnitID) > 0.0 )
         test = true;
      else
         return;
   }

   vector marketLocation = kbUnitGetPosition(gTradeMarketUnitID);
   int numEnemyAttBuildingsNearMarketInR60 = getNumUnitsByRel(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, cPlayerRelationEnemy, marketLocation, 60.0);
   int numMotherNatureAttBuildingsNearMarketInR50 = getNumUnits(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, 0, marketLocation, 50.0);
   int numEnemyMilUnitsNearMarketInR40 = getNumUnitsByRel(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cPlayerRelationEnemy, marketLocation, 40.0, true);
   int myMilUnitsNearMarketInR30 = getNumUnits(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cMyID, marketLocation, 30.0);
   int alliedMilUnitsNearMarketInR30 = getNumUnitsByRel(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cPlayerRelationAlly, marketLocation, 30.0, true);
   if ((numEnemyAttBuildingsNearMarketInR60 - numMotherNatureAttBuildingsNearMarketInR50 > 0)
      || (numEnemyMilUnitsNearMarketInR40 - myMilUnitsNearMarketInR30 - alliedMilUnitsNearMarketInR30 > 1))
   {
      if (test == false) {
         aiPlanDestroy(gTradePlanID);
         gTradePlanID = -1;
      }
      return;
   }

   if (test) {
      int tradePlanID = aiPlanCreate("MarketTrade", cPlanTrade);
      aiPlanSetInitialPosition(tradePlanID, kbUnitGetPosition(gTradeMarketUnitID));
      aiPlanSetVariableVector(tradePlanID, cTradePlanStartPosition, 0, kbUnitGetPosition(gTradeMarketUnitID));
      aiPlanSetVariableInt(tradePlanID, cTradePlanTradeUnitType, 0, tradeCartPUID);
      aiPlanSetVariableInt(tradePlanID, cTradePlanMarketID, 0, gTradeMarketUnitID);
      aiPlanAddUnitType(tradePlanID, tradeCartPUID, 1, 1, 1);     // Just one to start
      aiPlanSetVariableInt(tradePlanID, cTradePlanTargetUnitTypeID, 0, cUnitTypeSettlementsThatTrainVillagers);
      aiPlanSetBaseID(tradePlanID, mainBaseID);
      aiPlanSetEconomy(tradePlanID, true);
      aiPlanSetDesiredPriority(tradePlanID, 100);
      aiPlanSetVariableInt(gTradePlanID, cTradePlanTradeUnitTypeMax, 0, 1);
      aiPlanSetActive(tradePlanID);
      gTradePlanID = tradePlanID;
   }
}

//==============================================================================
rule tradeWithCaravans
minInterval 31 //starts in cAge3
inactive
{
   if ( kbUnitGetCurrentHitpoints(gTradeMarketUnitID) <= 0.0 ) {
      aiPlanDestroy(gTradePlanID);
      gTradePlanID = -1;
   }

   xsSetRuleMinIntervalSelf(31);
   //Force build a market.
   static int failedBase = -1;  // Set to the main base ID if no valid market position exists, so we don't retry forever.
   int mainBaseID = kbBaseGetMainID(cMyID);

   if (failedBase == mainBaseID) {  // We've failed at this spot before
      xsSetRuleMinIntervalSelf(210);
      failedBase = -1;    //Try again in 3.5 minutes
      return;
   }

   static bool builtMarket = false;
   static int marketTime = -1;   // Set when we create the build plan
   static int buildPlanID = -1;

   int targetNumMarkets = 1;
   if (gExtraMarket)
      targetNumMarkets = 2;      // One near main base, one for trade
   static bool extraRuleEnabled = false;

   if (builtMarket == false) {
      vector mainBaseLocation = kbBaseGetLocation(cMyID, mainBaseID);  // my main base location
      vector allyLocation = cInvalidVector;
      vector marketLocation = cInvalidVector;

      // Since we can't specify a target TC, if we have allies, we'll build in the corner
      // that is nearest the most distant ally TC, which should give us a good run back
      // to our TCs.  If no allies, or if ally corner == our corner, choose the
      // corner that is second closest to our base.
      // Do simple dx+dz distance check for each corner
      float bottom = -1;
      float top = -1;
      float right = -1;
      float left = -1;
      int closestToMe = -1;
      int closestToAlly = -1;
      int secondClosestToMe = -1;
      float min = -1.0;

      bottom = xsVectorGetX(mainBaseLocation) + xsVectorGetZ(mainBaseLocation);    // dist to bottom
      left = xsVectorGetX(mainBaseLocation) + (kbGetMapZSize() - xsVectorGetZ(mainBaseLocation));
      right = (kbGetMapXSize() - xsVectorGetX(mainBaseLocation)) + xsVectorGetZ(mainBaseLocation);
      top = (kbGetMapXSize() - xsVectorGetX(mainBaseLocation)) + (kbGetMapZSize() - xsVectorGetZ(mainBaseLocation)); 

      // Find closest corner, and mark it as distant so we can then find the second closest
      if ( xsVectorGetX(mainBaseLocation) < (kbGetMapXSize()/2) ) {  // we're on bottom left half
         if ( xsVectorGetZ(mainBaseLocation) < (kbGetMapZSize()/2) ) {  // we're lower right half ergo bottom corner
            bottom = 10000;     // Won't be closest
            closestToMe = 0;  // x0,z0
         }
         else {  // we're on upper left half, ergo left
            left = 10000;
            closestToMe = 1;  // x0, z1
         }
      }
      else {  // we're on upper right half
         if ( xsVectorGetZ(mainBaseLocation) > (kbGetMapZSize()/2) )
            {  // we're upper left half ergo top corner
            top = 10000;     // Won't be closest
            closestToMe = 3;  // x1, z1
         }
         else
            {  // we're on bottom right half, ergo right
            right = 10000;
            closestToMe = 2;  // x1, z0
         }
      }

      // Find second closest to me.
      min = 9000.0;
      if ( bottom < min ) {
         min = bottom;
         secondClosestToMe = 0;
      }
      if ( top < min ) {
         min = top;
         secondClosestToMe = 3;
      }
      if ( left < min ) {
         min = left;
         secondClosestToMe = 1;
      }
      if ( right < min ) {
         min = right;
         secondClosestToMe = 2;
      }

      // We've found the closest and second closest corners.  If we have an ally, find its closest corner

      // Look for an ally TC.  If we find one, use it to determine position.
      //If we don't have a query ID, create it.
      static int distantAllyTCQuery=-1;
      if (distantAllyTCQuery < 0) {
         distantAllyTCQuery=kbUnitQueryCreate("MarketQuery");
         //If we still don't have one, bail.
         if (distantAllyTCQuery < 0)
            return;
         //Else, setup the query data.
         kbUnitQuerySetPlayerRelation(distantAllyTCQuery, cPlayerRelationAlly);
         kbUnitQuerySetUnitType(distantAllyTCQuery, cUnitTypeAbstractSettlement);
         kbUnitQuerySetState(distantAllyTCQuery, cUnitStateAlive);
         kbUnitQuerySetPosition(distantAllyTCQuery, mainBaseLocation);
         kbUnitQuerySetAscendingSort(distantAllyTCQuery, true);
         if (gTransportMap)
            kbUnitQuerySetAreaGroupID(distantAllyTCQuery, kbAreaGroupGetIDByPosition(kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID))));
      }
      kbUnitQueryResetResults(distantAllyTCQuery);
      int tcCount = kbUnitQueryExecute(distantAllyTCQuery);
      int tcID = -1;
      if (tcCount > 0) {
         tcID = kbUnitQueryGetResult(distantAllyTCQuery, tcCount-1);
         allyLocation = kbUnitGetPosition(tcID);
      }

      if ( xsVectorGetX(allyLocation) < (kbGetMapXSize()/2) )
         {  // we're on bottom left half
         if ( xsVectorGetZ(allyLocation) < (kbGetMapZSize()/2) )
            {  // we're lower right half ergo bottom corner
            closestToAlly = 0;  // x0,z0
         }
         else
            {  // we're on upper left half, ergo left
            closestToAlly = 1;  // x0, z1
         }
      }
      else
         {  // we're on upper right half
         if ( xsVectorGetZ(allyLocation) > (kbGetMapZSize()/2) )
            {  // we're upper left half ergo top corner
            closestToAlly = 3;  // x1, z1
         }
         else
            {  // we're on bottom right half, ergo right
            closestToAlly = 2;  // x1, z0
         }
      }

      // Now, sort it all out...
      // Since we can't override the tendency to trade with our own settlements, this is what we'll do.
      // If the most distant ally's closest corner is not the same as ours, we'll go there.  
      // If we don't have an ally, or the ally's closest corner is the same as ours, we'll use our 
      // second closest corner.

      int chosenCorner = -1;
      static int LastCorner = -1;
      static int SwitchCount = 0;

      if ((mapRestrictsMarketAttack() == false) && (IhaveAllies == false) || (cRandomMapName == "watering hole")) {
         if ((aiRandInt(3) <= 1) && (cRandomMapName != "watering hole"))
            chosenCorner = secondClosestToMe;
         else
            chosenCorner = closestToMe;
      }
      else {
         if ((tcID < 0) || (closestToAlly == closestToMe)) {
            chosenCorner = closestToMe;
         }
         else {
            chosenCorner = closestToAlly;
         }
      }
      if (LastCorner == -1)
         LastCorner = chosenCorner;

      if ((LastCorner != chosenCorner) && (LastCorner != -1)) {
         SwitchCount = SwitchCount + 1;
         if (SwitchCount >= 2) {
            LastCorner = chosenCorner;
            SwitchCount  = 0;
         }
         else
            chosenCorner = LastCorner;
      }

      switch(chosenCorner)
      {
         case 0:
         {  // X and Z low
            marketLocation = xsVectorSetX(marketLocation, 2);
            marketLocation = xsVectorSetZ(marketLocation, 2);
            break;
         }
         case 1:
         {  // X low, Z hi
            marketLocation = xsVectorSetX(marketLocation, 2);
            marketLocation = xsVectorSetZ(marketLocation, kbGetMapZSize()-2);
            break;
         }
         case 2:
         {  // X hi, Z lo
            marketLocation = xsVectorSetX(marketLocation, kbGetMapXSize()-2);
            marketLocation = xsVectorSetZ(marketLocation, 2);
            break;
         }
         case 3:
         {  // X hi, Z hi
            marketLocation = xsVectorSetX(marketLocation, kbGetMapXSize()-2);
            marketLocation = xsVectorSetZ(marketLocation, kbGetMapZSize()-2);
            break;
         }
      }

      marketLocation = xsVectorSetY(marketLocation, 0);

      // Figure out if it's on our areaGroup.  If not, step 5% closer until it is.
      int homeAreaGroup = -1;
      int marketAreaGroup = -1;
      homeAreaGroup = kbAreaGroupGetIDByPosition(mainBaseLocation);

      int i = -1;
      vector towardHome = cInvalidVector;
      towardHome = mainBaseLocation - marketLocation;
      towardHome = towardHome / 20;    // 5% of distance from market to home
      bool success = false;

      for (i = 0; < 20) {
         marketAreaGroup = kbAreaGroupGetIDByPosition(marketLocation);
         if (marketAreaGroup == homeAreaGroup) {
            success = true;
            break;
         }
         else {
            marketLocation = marketLocation + towardHome;   // Try a bit closer
         }
      }

      //override on anatolia
      bool override = false;
      if (cRandomMapName == "anatolia") {
         vector backVector = kbBaseGetBackVector(cMyID, mainBaseID);
         float bx = xsVectorGetX(backVector);
         float bz = xsVectorGetZ(backVector);
         bx = bx * 30;
         bz = bz * 30;

         backVector = xsVectorSetX(backVector, bx);
         backVector = xsVectorSetZ(backVector, bz);
         backVector = xsVectorSetY(backVector, 0.0);
         vector backLocation = mainBaseLocation + backVector;

         int mainBaseAreaID = kbAreaGetIDByPosition(mainBaseLocation);
         int backAreaID = kbAreaGetIDByPosition(backLocation);
         if ((backAreaID != mainBaseAreaID) && (backAreaID != -1)) {
            vector backAreaLocation = kbAreaGetCenter(backAreaID);
            marketLocation = backAreaLocation;
            float backDistance = xsVectorLength(mainBaseLocation - backAreaLocation);
            if (backDistance < 45.0) {
               int index = -1;
               int areaID = -1;
               int areaType = -1;
               float savedDistance = 0.0;
               int numBorderAreas = kbAreaGetNumberBorderAreas(backAreaID);
               for (index = 0; < numBorderAreas) {
                  areaID = kbAreaGetBorderAreaID(backAreaID, index);
                  if (areaID == -1)
                     continue;

                  vector areaLocation = kbAreaGetCenter(areaID);
                  float distance = xsVectorLength(mainBaseLocation - areaLocation);
                  if ((distance >= 45.0) && (distance < 85.0)) {
                     areaType = kbAreaGetType(areaID);
                     if (areaType == cAreaTypeForest) {
                        int numTreesInR15 = getNumUnits(cUnitTypeTree, cUnitStateAlive, -1, 0, areaLocation, 15.0);
                        if (numTreesInR15 > 15)
                           continue;
                     }
                     if (areaType == cAreaTypeSettlement)
                        continue;
                     if (areaType == cAreaTypeImpassableLand)
                        continue;
                     int numBuildingsInR15 = getNumUnits(cUnitTypeLogicalTypeBuildingsNotWalls, cUnitStateAlive, -1, cMyID, areaLocation, 15.0);
                     if (numBuildingsInR15 > 3)
                        continue;
                     if (distance > savedDistance) {
                        marketLocation = areaLocation;
                        savedDistance = distance;
                        continue;
                     }
                  }
               }
            }
         }
         else
            marketLocation = mainBaseLocation;

         override = true;
         success = true;
      }
      //build a local market in 2 min anyway.
      if (extraRuleEnabled == false) {
         xsEnableRule("makeExtraMarket");
         extraRuleEnabled = true;
      }

      if (success == false) {
         failedBase = mainBaseID;
         return;
      }
      gTradeMarketDesiredLocation = marketLocation; // Set the global var for later reference in identifying the trade market.

      static float distanceIncrease = 0;

      bool Skip = false;
      int MarketsThere = getNumUnits(cUnitTypeMarket, cUnitStateAny, -1, cMyID, gTradeMarketDesiredLocation, 60.0);
      int ExistingPlan = findPlanByString("BUILDMARKET", cPlanBuild);
      if ((ExistingPlan != -1) || (MarketsThere > 0) || (buildPlanID != -1))
         Skip = true;
      if (Skip == false) {
         buildPlanID=aiPlanCreate("BUILDMARKET", cPlanBuild);
         if (buildPlanID < 0)
            return;		
         //Setup the build plan.
         aiPlanSetVariableInt(buildPlanID, cBuildPlanBuildingTypeID, 0, cUnitTypeMarket);
         if ((override == false) || (equal(marketLocation, mainBaseLocation))) {
            aiPlanSetVariableVector(buildPlanID, cBuildPlanInfluencePosition, 0, marketLocation);
            aiPlanSetVariableFloat(buildPlanID, cBuildPlanInfluencePositionDistance, 0, 30.0);
            aiPlanSetVariableFloat(buildPlanID, cBuildPlanInfluencePositionValue, 0, 100.0);
            aiPlanSetVariableInt(buildPlanID, cBuildPlanAreaID, 0, kbAreaGetIDByPosition(marketLocation));
            aiPlanSetVariableInt(buildPlanID, cBuildPlanNumAreaBorderLayers, 0, 2);
         }
         else {
            aiPlanSetVariableFloat(buildPlanID, cBuildPlanRandomBPValue, 0, 0.99);
            aiPlanSetVariableVector(buildPlanID, cBuildPlanCenterPosition, 0, marketLocation);
            aiPlanSetVariableFloat(buildPlanID, cBuildPlanCenterPositionDistance, 0, 15.0 + distanceIncrease);          
         }
         aiPlanAddUnitType(buildPlanID, cBuilderType, 1, 2, 2);
         aiPlanSetDesiredPriority(buildPlanID, 100);
         aiPlanSetEscrowID(buildPlanID, cEconomyEscrowID);
         aiPlanSetActive(buildPlanID);

         builtMarket = true;
         marketTime = xsGetTime(); 
      }
   }
   //If we don't have a query ID, create it.
   static int marketQueryID=-1;
   if (marketQueryID < 0) {
      marketQueryID=kbUnitQueryCreate("MarketQuery");
      //If we still don't have one, bail.
      if (marketQueryID < 0)
         return;
      //Else, setup the query data.
      kbUnitQuerySetPlayerID(marketQueryID, cMyID);
      kbUnitQuerySetUnitType(marketQueryID, cUnitTypeMarket);
      kbUnitQuerySetState(marketQueryID, cUnitStateAlive);
   }
   if (gTransportMap)
      kbUnitQuerySetAreaGroupID(marketQueryID, kbAreaGroupGetIDByPosition(kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID))));
   kbUnitQuerySetPosition(marketQueryID, gTradeMarketDesiredLocation);
   kbUnitQuerySetAscendingSort(marketQueryID, true);


   //Reset the results.
   kbUnitQueryResetResults(marketQueryID);
   //Run the query.  
   int numMarkets = kbUnitQueryExecute(marketQueryID);

   static int retryCount = 0;
   if (retryCount > 4) {
      retryCount = 0;
      xsSetRuleMinIntervalSelf(107);
      distanceIncrease = distanceIncrease + 5.0;
   }

   if (numMarkets <= 0) {
      if (aiPlanGetState(buildPlanID) < 0)
         {  
         // Scrap it and start over
         aiPlanDestroy(buildPlanID);  			
         buildPlanID = -1;
         builtMarket = false;
         retryCount = retryCount + 1;
      }
      return;        // No market at all, bail
   }
   if (numMarkets < targetNumMarkets) {
      if (aiPlanGetState(buildPlanID) < 0)
         {  
         // Scrap it and start over 
         aiPlanDestroy(buildPlanID); 		
         buildPlanID = -1;
         builtMarket = false;
         retryCount = retryCount + 1;
      }
      return;
   }

   retryCount = 0;

   // We have our target number of markets

   //reset the gTradeMarketUnitID to -1
   gTradeMarketUnitID = -1;

   for (i = 0; < numMarkets) {
      int marketUnitID = kbUnitQueryGetResult(marketQueryID, i);
      if (marketUnitID == -1)
         continue;

      if (marketUnitID != gExtraMarketUnitID) {
         gTradeMarketLocation = kbUnitGetPosition(marketUnitID);
         gTradeMarketUnitID = marketUnitID;
         break;
      }
   }

   if (gTradeMarketUnitID == -1) {
      return;
   }
   static bool MarketTower = false;
   if (MarketTower == false)
      xsEnableRule("TowerUpMarket");
   MarketTower = true;

   // We have a market for trade, activate the rule to rebuild if lost
   xsEnableRule("rebuildMarket");      // Will restart process if market is lost

   //Create the market trade plan.
   if (gTradePlanID >= 0) {
      aiPlanDestroy(gTradePlanID);  // Delete old one based on previous market, if any.
      gTradePlanID = -1;
   }
   gTradePlanID = aiPlanCreate("MarketTrade", cPlanTrade);
   //Get our cart PUID.
   const int tradeCartPUID = cUnitTypeCaravanGreek;
   aiPlanSetInitialPosition(gTradePlanID, kbUnitGetPosition(gTradeMarketUnitID));
   aiPlanSetVariableVector(gTradePlanID, cTradePlanStartPosition, 0, kbUnitGetPosition(gTradeMarketUnitID));
   aiPlanSetVariableInt(gTradePlanID, cTradePlanTradeUnitType, 0, tradeCartPUID);
   aiPlanSetVariableInt(gTradePlanID, cTradePlanMarketID, 0, gTradeMarketUnitID);
   aiPlanAddUnitType(gTradePlanID, tradeCartPUID, 1, 1, 1);     // Just one to start, max 1, maintain plan will adjust later
   aiPlanSetVariableInt(gTradePlanID, cTradePlanTradeUnitTypeMax, 0, 1);
   aiPlanSetVariableInt(gTradePlanID, cTradePlanTargetUnitTypeID, 0, cUnitTypeSettlementsThatTrainVillagers);
   aiPlanSetBaseID(gTradePlanID, mainBaseID);
   aiPlanSetEconomy(gTradePlanID, true);
   aiPlanSetDesiredPriority(gTradePlanID, 100);
   aiPlanSetActive(gTradePlanID);

   // Activate the rule to monitor it
   xsEnableRule("monitorTrade");
   distanceIncrease = 0;
   //Go away.
   xsDisableSelf();
}

//==============================================================================
rule sendIdleTradeUnitsToRandomBase
minInterval 7 //starts in cAge3
inactive
{
   //check the trade plan
   if ((gTradeMarketUnitID != -1) && (kbUnitGetCurrentHitpoints(gTradeMarketUnitID) <= 0)) {
      if (gTradePlanID != -1) {
         aiPlanDestroy(gTradePlanID);
         gTradePlanID = -1;
      }
      int activeTradePlans = aiPlanGetNumber(cPlanTrade, -1, true);
      for(i=0; < activeTradePlans)
         aiPlanDestroy( aiPlanGetIDByIndex(cPlanTrade, -1, true, i) );
   }

   int numMarkets = kbUnitCount(cMyID, cUnitTypeMarket, cUnitStateAlive);
   if (numMarkets < 1)
      return;

   const int tradeCartPUID = cUnitTypeCaravanGreek;
   int numTradeUnits = kbUnitCount(cMyID, tradeCartPUID, cUnitStateAlive);
   if (numTradeUnits < 1)
      return;

   static int lastUsedMarket = -1;
   static bool override = false;
   bool RetreatMB = false;
   static int count = 0;
   int tradeMarket1ID = -1;
   int tradeMarket2ID = -1;

   for(i=0; < numMarkets) {
      int marketID = findUnitByIndex(cUnitTypeMarket, i, cUnitStateAlive, -1, cMyID);
      if (marketID == -1)
         continue;

      if ((marketID == gTradeMarketUnitID) && (gTradeMarketUnitID != -1)) {
         tradeMarket1ID = marketID;
      }
      else {
         if (tradeMarket2ID == -1) {
            tradeMarket2ID = marketID;
         }
      }
   }

   int numEnemyAttBuildingsNearMarketInR50 = 0;
   int numMotherNatureAttBuildingsNearMarketInR50 = 0;
   int numEnemyMilUnitsNearMarketInR30 = 0;
   int myMilUnitsNearMarketInR30 = 0;
   int alliedMilUnitsNearMarketInR30 = 0;
   vector tradeMarketPosition = cInvalidVector;
   vector tradeUnitPos = cInvalidVector;
   vector targetMarketPos = cInvalidVector;

   int marketToUse = tradeMarket1ID;   //prefer our gTradeMarketUnitID
   if (marketToUse != -1) {
      tradeMarketPosition = kbUnitGetPosition(marketToUse);
      numEnemyAttBuildingsNearMarketInR50 = getNumUnitsByRel(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, cPlayerRelationEnemy, tradeMarketPosition, 50.0);
      numMotherNatureAttBuildingsNearMarketInR50 = getNumUnits(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, 0, tradeMarketPosition, 50.0);
      numEnemyMilUnitsNearMarketInR30 = getNumUnitsByRel(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cPlayerRelationEnemy, tradeMarketPosition, 30.0, true);
      myMilUnitsNearMarketInR30 = getNumUnits(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cMyID, tradeMarketPosition, 30.0);
      alliedMilUnitsNearMarketInR30 = getNumUnitsByRel(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cPlayerRelationAlly, tradeMarketPosition, 30.0, true);
      if ((numEnemyAttBuildingsNearMarketInR50 - numMotherNatureAttBuildingsNearMarketInR50 > 0)
         || (numEnemyMilUnitsNearMarketInR30 - myMilUnitsNearMarketInR30 - alliedMilUnitsNearMarketInR30 > 1))
      {
         marketToUse = -1;
      }
   }

   if (marketToUse == -1) {
      marketToUse = tradeMarket2ID;
      if (marketToUse == -1) {
         return;
      }
   }
   tradeMarketPosition = kbUnitGetPosition(marketToUse);

   if (lastUsedMarket == -1) {
      lastUsedMarket = marketToUse;
   }

   if (marketToUse != lastUsedMarket) {
      //send all units to our new market
      override = true;
   }

   if (gResetTradeMarket) {
      override = true;
      count = 0;
      gResetTradeMarket = false;
   }

   if (override) {
      int onumEnemyAttBuildingsNearMarketInR50 = getNumUnitsByRel(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, cPlayerRelationEnemy, tradeMarketPosition, 50.0);
      int onumMotherNatureAttBuildingsNearMarketInR50 = getNumUnits(cUnitTypeBuildingsThatShoot, cUnitStateAlive, -1, 0, tradeMarketPosition, 50.0);
      int onumEnemyMilUnitsNearMarketInR30 = getNumUnitsByRel(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cPlayerRelationEnemy, tradeMarketPosition, 30.0, true);
      int omyMilUnitsNearMarketInR30 = getNumUnits(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cMyID, tradeMarketPosition, 30.0);
      int oalliedMilUnitsNearMarketInR30 = getNumUnitsByRel(cUnitTypeLogicalTypeLandMilitary, cUnitStateAlive, -1, cPlayerRelationAlly, tradeMarketPosition, 30.0, true);
      if ((onumEnemyAttBuildingsNearMarketInR50 - onumMotherNatureAttBuildingsNearMarketInR50 > 0)
         || (onumEnemyMilUnitsNearMarketInR30 - omyMilUnitsNearMarketInR30 - oalliedMilUnitsNearMarketInR30 > 1))
      {
         RetreatMB = true;
      }

      if (count > 1) {
         override = false;
         count = 0;
         lastUsedMarket = marketToUse;
      }
      else {
         count = count + 1;
      }
   }

   int action = cActionIdle;
   int numTradeUnitsToUse = getNumUnits(tradeCartPUID, cUnitStateAlive, action, cMyID);
   if ((numTradeUnitsToUse < 1) || (aiRandInt(10) == 0) || (override)) {
      action = -1;
      numTradeUnitsToUse = getNumUnits(tradeCartPUID, cUnitStateAlive, action, cMyID);
      if (numTradeUnitsToUse < 1) {
         return;
      }
   }

   float minRequiredDistance = 40.0;
   int tradeDestinationID = -1;
   int mainBaseID = kbBaseGetMainID(cMyID);
   vector mainBaseLocation = kbBaseGetLocation(cMyID, mainBaseID);
   int mainBaseUnitID = getMainBaseUnitIDForPlayer(cMyID);
   if (mainBaseUnitID != -1) {
      float mainBaseTradeRouteLength = xsVectorLength(mainBaseLocation - tradeMarketPosition);
      if (mainBaseTradeRouteLength > minRequiredDistance)
         tradeDestinationID = mainBaseUnitID;
   }

   int min = 0;
   int max = 16;

   //override
   if (override)
      max = numTradeUnitsToUse;   //all trade units

   int otherBaseUnitID = -1;
   vector otherBaseUnitPosition = cInvalidVector;
   int tradeUnitID = -1;
   int planID = -1;
   int targetID = -1;
   vector targetPosition = cInvalidVector;

   float tradeRouteLength = 0.0;
   float currentTradeRouteLength = 0.0;
   int alliedTradeDestinationID = -1;
   int numAlliedSettlementsInR100 = getNumUnitsByRel(cUnitTypeAbstractSettlement, cUnitStateAlive, -1, cPlayerRelationAlly, tradeMarketPosition, 250);
   if (numAlliedSettlementsInR100 > 0) {
      if (numAlliedSettlementsInR100 > 3)
         numAlliedSettlementsInR100 = 3;
      for (i = 0; < numAlliedSettlementsInR100) {
         int alliedSettlementIDInR100 = findUnitByRelByIndex(cUnitTypeAbstractSettlement, i, cUnitStateAlive, -1, cPlayerRelationAlly, tradeMarketPosition, 250);
         if (alliedSettlementIDInR100 != -1) {
            vector alliedSettlementLocation = kbUnitGetPosition(alliedSettlementIDInR100);
            float alliedTradeRouteLength = xsVectorLength(alliedSettlementLocation - tradeMarketPosition);
            if ((alliedTradeRouteLength > minRequiredDistance) && (SameAG(alliedSettlementLocation, tradeMarketPosition)))
               alliedTradeDestinationID = alliedSettlementIDInR100;
         }
      }
   }

   if (numTradeUnitsToUse > max)
      numTradeUnitsToUse = max;
   for (i = 0; < numTradeUnitsToUse) {
      otherBaseUnitID = findUnit(cUnitTypeAbstractSettlement);
      otherBaseUnitPosition = kbUnitGetPosition(otherBaseUnitID);
      tradeRouteLength = xsVectorLength(otherBaseUnitPosition - tradeMarketPosition);

      tradeUnitID = findUnitByIndex(tradeCartPUID, i, cUnitStateAlive, action, cMyID);
      if (tradeUnitID > 0) {
         if (override) {
            if (RetreatMB)
               aiTaskUnitMove(tradeUnitID, mainBaseLocation);	
            else 
               aiTaskUnitWork(tradeUnitID, marketToUse);
            continue;
         }

         if (action == -1) {
            planID = kbUnitGetPlanID(tradeUnitID);
            if (planID != -1)
               continue;
            targetID = kbUnitGetTargetUnitID(tradeUnitID);
            if (targetID != -1) {
               targetPosition = kbUnitGetPosition(targetID);
               currentTradeRouteLength = xsVectorLength(targetPosition - tradeMarketPosition);
               if (currentTradeRouteLength > minRequiredDistance) {
                  //50% chance to use the alliedTradeDestinationID
                  if ((alliedTradeDestinationID != -1) && (aiRandInt(4) > 0)) {
                     tradeDestinationID = alliedTradeDestinationID;
                     continue;
                  }

                  if ((tradeRouteLength > currentTradeRouteLength) && (tradeRouteLength <= 100.0)) {
                     tradeDestinationID = otherBaseUnitID;
                     continue;
                  }
                  continue;
               }	
            }
         }

         if (tradeRouteLength > minRequiredDistance) {
            if (tradeDestinationID == -1) {
               tradeDestinationID = otherBaseUnitID;
            }
            else {
               if ((tradeRouteLength > mainBaseTradeRouteLength) || (aiRandInt(10) < 1))
                  tradeDestinationID = otherBaseUnitID;
            }
         }
         //50% chance to use the alliedTradeDestinationID
         if ((alliedTradeDestinationID != -1) && (aiRandInt(4) > 0)) {
            tradeDestinationID = alliedTradeDestinationID;
         }

         if ((tradeDestinationID != -1) && (SameAG(kbUnitGetPosition(tradeDestinationID), tradeMarketPosition)))
            {	
            aiTaskUnitWork(tradeUnitID, tradeDestinationID);
         }
      }
   }
}

//==============================================================================
rule airScout1
minInterval 83 //starts in cAge1
inactive
{
   static bool delay = false;
   if (delay) {
      delay = false;
      return;
   }

   static bool typeSwitched = false;
   int scoutType = gAirScout;
   vector mapCenter = kbGetMapCenter();
   static vector lastPosition = cInvalidVector;

   int explorePlanID = gAirScout1PlanID;  //aiPlanGetIDByIndex(cPlanExplore, -1, true, i);
   if ( aiPlanGetActive(explorePlanID) ) {
      int numUnitsInPlan = aiPlanGetNumberUnits(explorePlanID, cUnitTypeUnit);
      if (numUnitsInPlan > 0) {
         int unitID = aiPlanGetUnitByIndex(explorePlanID, 0);
         vector currentPosition = kbUnitGetPosition(unitID);
         if ( equal(currentPosition, lastPosition) ) {
            delay = true;
            aiPlanDestroy(explorePlanID);
            typeSwitched = false;
            lastPosition = cInvalidVector;
            aiTaskUnitMove(unitID, mapCenter);
         }
         else
            lastPosition = currentPosition;
      }
      else
         lastPosition = cInvalidVector;
      return;
   }

   int airScout1PlanID = aiPlanCreate("AirScout1Plan", cPlanExplore);
   if (airScout1PlanID >= 0) {
      aiPlanAddUnitType(airScout1PlanID, scoutType, 1, 1, 1);
      aiPlanSetDesiredPriority(airScout1PlanID, 100);	
      aiPlanSetVariableBool(airScout1PlanID, cExplorePlanDoLoops, 0, false);
      aiPlanSetVariableBool(airScout1PlanID, cExplorePlanAvoidingAttackedAreas, 0, true);
      aiPlanSetVariableFloat(airScout1PlanID, cExplorePlanLOSMultiplier, 0, 4.0);
      aiPlanSetEscrowID(airScout1PlanID, cEconomyEscrowID);
      aiPlanSetActive(airScout1PlanID);
      gAirScout1PlanID = airScout1PlanID;
   }
}

//==============================================================================
rule airScout2  //air scout plan that doesn't avoid attacked areas
minInterval 79 //starts in cAge1
inactive
{
   static bool delay = false;
   if (delay) {
      delay = false;
      return;
   }

   vector mapCenter = kbGetMapCenter();
   static vector lastPosition = cInvalidVector;

   int activeExplorePlans = aiPlanGetNumber(cPlanExplore, -1, true);
   for(i=0; < activeExplorePlans) {
      int explorePlanID = aiPlanGetIDByIndex(cPlanExplore, -1, true, i);
      if (explorePlanID == gAirScout2PlanID) {
         int numUnitsInPlan = aiPlanGetNumberUnits(explorePlanID, cUnitTypeUnit);
         if (numUnitsInPlan > 0) {
            int unitID = aiPlanGetUnitByIndex(explorePlanID, 0);
            if (unitID != -1) {
               vector currentPosition = kbUnitGetPosition(unitID);
               if (equal(currentPosition, lastPosition)) {
                  delay = true;
                  aiPlanDestroy(explorePlanID);
                  lastPosition = cInvalidVector;
                  aiTaskUnitMove(unitID, mapCenter);
               }
               else {
                  lastPosition = currentPosition;
               }
            }
            else {
               lastPosition = cInvalidVector;
            }
         }
         else {
            lastPosition = cInvalidVector;
         }
         return;
      }
   }

   int airScout2PlanID = aiPlanCreate("AirScout2Plan", cPlanExplore);
   if (airScout2PlanID >= 0) {
      aiPlanAddUnitType(airScout2PlanID, gAirScout, 1, 1, 1);
      aiPlanSetVariableBool(airScout2PlanID, cExplorePlanDoLoops, 0, false);
      aiPlanSetVariableBool(airScout2PlanID, cExplorePlanAvoidingAttackedAreas, 0, false);
      aiPlanSetVariableFloat(airScout2PlanID, cExplorePlanLOSMultiplier, 0, 6.0);
      aiPlanSetEscrowID(airScout2PlanID, cEconomyEscrowID);
      aiPlanSetDesiredPriority(airScout2PlanID, 99);
      aiPlanSetActive(airScout2PlanID);
      gAirScout2PlanID = airScout2PlanID;
   }
}

//==============================================================================
void earlyEcoCheat()	//Todo
{
   if ( cvOkToCheat ) {
      if (kbGetAge() <= cAge1) {
         aiResourceCheat( cMyID, cResourceFood, 100.0 );
         aiResourceCheat( cMyID, cResourceGold,  50.0 );
         aiResourceCheat( cMyID, cResourceWood,  50.0 );
      }
   }
}
