//==============================================================================
// The Return of the Gods AI
//==============================================================================
// ROTGAIProgr.xs
// This is a modification of Georg Kalus' extension of the default aomx ai file
// by Loki_GdD
//
// Handles progression.
//==============================================================================

//==============================================================================
void progressAge2Handler(int age=1)
{
   xsEnableRule("age2Progress");
}
void progressAge3Handler(int age=2)
{
   xsEnableRule("age3Progress");
}
void progressAge4Handler(int age=3)
{
}

//==============================================================================
rule unPauseAge2
minInterval 180 //starts in cAge1
inactive
{
   xsDisableSelf();
   if (gAge2ProgressionPlanID == -1)
      return;
   aiPlanSetVariableBool(gAge2ProgressionPlanID, cProgressionPlanPaused, 0, false);
   aiPlanSetVariableBool(gAge2ProgressionPlanID, cProgressionPlanAdvanceOneStep, 0, false);
}
rule unPauseAge3
minInterval 150 //starts in cAge2
inactive
{
   xsDisableSelf();
   if (gAge3ProgressionPlanID == -1)
      return;
   aiPlanSetVariableBool(gAge3ProgressionPlanID, cProgressionPlanPaused, 0, false);
   aiPlanSetVariableBool(gAge3ProgressionPlanID, cProgressionPlanAdvanceOneStep, 0, false);
}

//==============================================================================
rule age1Progress
minInterval 10 //starts in cAge1
inactive
{
   xsDisableSelf();
   if ( gAge2MinorGod >= 0 ) {
      gAge2ProgressionPlanID = createSimpleResearchPlan( gAge2MinorGod, cUnitTypeSettlementsThatTrainVillagers, cEconomyEscrowID, 100, true );
      aiPlanSetVariableBool(gAge2ProgressionPlanID, cProgressionPlanPaused, 0, true);
      aiPlanSetVariableBool(gAge2ProgressionPlanID, cProgressionPlanAdvanceOneStep, 0, true);
      if ( (cvMapSubType != NOMADMAP) && (cvMapSubType != WATERNOMADMAP) && (cvMapSubType != VINLANDSAGAMAP) )
         xsEnableRule( "unPauseAge2" );
      if ( kbResourceGet(cResourceWood) >= 1000 )
         xsSetRuleMinInterval( "unPauseAge2", 5 );
   }
}
/*
//Not ideal, but for now...
rule ageUpForce minInterval 230 active
{
   int godid = -1;
   int building = -1;
   switch( kbGetAge() ) {
   case cAge1: { godid = gAge2MinorGod; building = cUnitTypeTemple; break; }
   case cAge2: { godid = gAge2MinorGod; building = cUnitTypeGuildMeso; break; }
   case cAge3: { godid = gAge2MinorGod; building = cUnitTypeMarket; break; }
   case cAge4: { godid = cTechSecretsoftheTitans; break; } }  //End: switch()

  xsDisableSelf();  //For now... In future, expand this for more ages?
   rotgTechActivate( godid );
   for(resourceid=0; <= cResourceFavor)
      aiResourceCheat( cMyID, resourceid, 0.0 - kbTechCostPerResource(godid, resourceid) );
}
*/
//==============================================================================
rule age2Progress
minInterval 10 //starts in cAge2
inactive
{
   xsDisableSelf();
   if ( gAge3ProgressionPlanID < 0 ) {
      gAge3ProgressionPlanID = createSimpleResearchPlan( gAge3MinorGod, cUnitTypeSettlementsThatTrainVillagers, cEconomyEscrowID, 100, true );
      aiPlanSetVariableBool(gAge3ProgressionPlanID, cProgressionPlanPaused, 0, true);
      aiPlanSetVariableBool(gAge3ProgressionPlanID, cProgressionPlanAdvanceOneStep, 0, true);
      xsEnableRule("unPauseAge3");  //Delay the armory a bit!
   }
}

//==============================================================================
rule age3Progress
minInterval 10 //starts in cAge3
inactive
{
   xsDisableSelf();
   if ( gAge4MinorGod >= 0 ) {
      gAge4ProgressionPlanID = createSimpleResearchPlan( gAge4MinorGod, cUnitTypeSettlementsThatTrainVillagers, cEconomyEscrowID, 100, true );
      aiPlanSetVariableBool(gAge4ProgressionPlanID, cProgressionPlanAdvanceOneStep, 0, true);
   }
}

//==============================================================================
int _minorGod(int enabler1=-1, int god1=-1, int enabler2=-1, int god2=-1, int enabler3=-1, int god3=-1)
{
   int choice1 = -1;
   int choice2 = -1;
   if ( kbGetTechStatus(enabler1) >= cTechStatusActive )
      choice1 = god1;
   if ( kbGetTechStatus(enabler2) >= cTechStatusActive ) {
      if ( choice1 < 0 )
         choice1 = god2;
      else
         choice2 = god2;
   }
   if ( kbGetTechStatus(enabler3) >= cTechStatusActive ) {
      if ( choice1 < 0 )
         choice1 = god3;
      else
         choice2 = god3;
   }
   if ( aiRandInt(2) == 0 )
      return( choice1 );
   else
      return( choice2 );
}

void assignAztecMinorGods(void)	//age2, age3, age4
{
   gAge2MinorGod = _minorGod( cTechEnableHuehueIxchel, cTechAge2Huehue,
                              cTechEnableCoyolBuluc, cTechAge2Coyol,
                              cTechEnableXolYum, cTechAge2Xol );
   gAge3MinorGod = _minorGod( cTechEnableMayahTohil, cTechAge3Mayahuel,
                              cTechEnableMictColel, cTechAge3Mict,
                              cTechEnableXipeChuah, cTechAge3Xipe );
  //Override with water related gods on a watermap
   if ( gTransportMap )
      gAge4MinorGod = cTechAge4Tlaloc;
   else
      gAge4MinorGod = _minorGod( cTechEnableTonPawa, cTechAge4Ton,
                                 cTechAge1Aztec, cTechAge4Tlaloc,
                                 cTechAge1Huitz, cTechAge4Coat );
}

