//==============================================================================
// The Return of the Gods AI
//==============================================================================
// ROTGAITrain.xs
// This file contains all train rules
// by Loki_GdD
//==============================================================================

//==============================================================================
rule maintainTradeUnits
minInterval 10 //starts in cAge3
inactive
{
   int numMarkets = kbUnitCount(cMyID, cUnitTypeMarket, cUnitStateAliveOrBuilding);
   if ((numMarkets < 1) || (aiGetGameMode() == cGameModeDeathmatch) && (xsGetTime() < 10*60*1000))
      return;

   const int tradeCartPUID = cUnitTypeCaravanGreek;
   int numTradeUnits = kbUnitCount(cMyID, tradeCartPUID, cUnitStateAliveOrBuilding);
   float foodSupply = kbResourceGet(cResourceFood);

   int NumTcs = kbUnitCount(cMyID, cUnitTypeAbstractSettlement, cUnitStateAlive);
   int mainBaseID = kbBaseGetMainID(cMyID);
   vector mainBaseLocation = kbBaseGetLocation(cMyID, mainBaseID);
   vector MarketLoc = kbUnitGetPosition(gTradeMarketUnitID);
   if ((gTransportMap) && (SameAG(MarketLoc, mainBaseLocation) == false))
      return;

   int activeTrainPlans = aiPlanGetNumber(cPlanTrain, -1, true);
   for(i=0; < activeTrainPlans) {
      int trainPlanIndexID = aiPlanGetIDByIndex(cPlanTrain, -1, true, i);
      if ((tradeCartPUID == aiPlanGetVariableInt(trainPlanIndexID, cTrainPlanUnitType, 0)) && (aiPlanGetBaseID(trainPlanIndexID) == mainBaseID)) {
         int trainPlanBuildingID = aiPlanGetVariableInt(trainPlanIndexID, cTrainPlanBuildingID, 0);
         if ((kbUnitGetCurrentHitpoints(gTradeMarketUnitID) <= 0) && (trainPlanBuildingID != -1))
            aiPlanDestroy(trainPlanIndexID);
         else if (((trainPlanBuildingID != -1) && (trainPlanBuildingID != gTradeMarketUnitID))
            || ((kbUnitGetCurrentHitpoints(gTradeMarketUnitID) > 0) && (trainPlanBuildingID == -1))) {
            aiPlanDestroy(trainPlanIndexID);
            gResetTradeMarket = true;
         }
         else
            return;
      }
   }
   if ((IhaveAllies) && (NumTcs < 1)) {
      vector unitLoc = kbUnitGetPosition(findUnit(cUnitTypeMarket));
      NumTcs = NumUnitsOnAreaGroupByRel(false, kbAreaGroupGetIDByPosition(unitLoc), cUnitTypeAbstractSettlement, cPlayerRelationAlly);
   }
   int numIdleTrade = getNumUnits(tradeCartPUID, cUnitStateAlive, cActionIdle, cMyID);
   if ( (NumTcs < 1) || (numIdleTrade > 3) )
      return;
   int tradeTargetPop = gMaxTradeCarts;
   if (tradeTargetPop <= 0)
      return;

   if ( (cvMaxTradePop >= 0) && (tradeTargetPop > cvMaxTradePop) )
      tradeTargetPop = cvMaxTradePop;
   if ( numTradeUnits >= tradeTargetPop )
      return;
    
   int trainTradeUnitPlanID = aiPlanCreate("TradeCarts", cPlanTrain);
   if (trainTradeUnitPlanID < 0)
      return;
   aiPlanSetEconomy(trainTradeUnitPlanID, true);
   aiPlanSetVariableInt(trainTradeUnitPlanID, cTrainPlanUnitType, 0, tradeCartPUID);
   if ((numTradeUnits < tradeTargetPop - 3) && (tradeTargetPop > 4))
      aiPlanSetVariableInt(trainTradeUnitPlanID, cTrainPlanNumberToTrain, 0, 3);
   else
      aiPlanSetVariableInt(trainTradeUnitPlanID, cTrainPlanNumberToTrain, 0, 1);
   aiPlanSetBaseID(trainTradeUnitPlanID, mainBaseID);
   //Train at trade market if there is a trade market
   if ( kbUnitGetCurrentHitpoints(gTradeMarketUnitID) > 0.0 )
      aiPlanSetVariableInt(trainTradeUnitPlanID, cTrainPlanBuildingID, 0, gTradeMarketUnitID);
   aiPlanSetDesiredPriority(trainTradeUnitPlanID, 96);
   aiPlanSetVariableBool(trainTradeUnitPlanID, cTrainPlanUseMultipleBuildings, 0, true);
   aiPlanSetActive(trainTradeUnitPlanID);
}

//==============================================================================
rule trainMythUnit
minInterval 25 //starts in cAge2
inactive
{
   if ( kbGetAge() < cAge3 )
      return;
   float favorSupply = kbResourceGet(cResourceFavor);
   int numMilitaryMythUnits = ( kbUnitCount(cMyID, cUnitTypeLogicalTypeMythUnitNotTitan, cUnitStateAlive) -
                                kbUnitCount(cMyID, cUnitTypePegasus, cUnitStateAlive) );
   if ( numMilitaryMythUnits > 1 ) {
      if ( kbGetAge() == cAge4 ) {
         if ( (favorSupply < 50) && TitanAvailable && (kbGetTechStatus(cTechSecretsoftheTitans) < cTechStatusResearching) )
            return;
      }
   }
   if ( numMilitaryMythUnits >= 18 )
      return;

   int myth0 = -1;
   int myth1 = -1;
   int myth2 = -1;
   int myth3 = -1;
   int mythtemp = -1;
   int number = kbGetAge();
   if ( number >= 4 )
      number = 3;

   //age2 myth units
   if (gAge2MinorGod == cTechAge2Huehue)
      myth0 = cUnitTypeYahui;
   else if (gAge2MinorGod == cTechAge2Coyol)
      myth0 = cUnitTypeHuitznahua;
   else if (gAge2MinorGod == cTechAge2Xol)
      myth0 = cUnitTypeAhuizotl;
   // age3 myth units
   if (gAge3MinorGod == cTechAge3Mayahuel)
      myth1 = cUnitTypeAmox;
   else if (gAge3MinorGod == cTechAge3Xipe)
      myth1 = cUnitTypeGiantAztec;
   else if (gAge3MinorGod == cTechAge3Mict) {
      myth1 = cUnitTypeDemonAztec;
      mythtemp = cUnitTypeFlyingDemon;
   }
   // age4 myth units
   if (gAge4MinorGod == cTechAge4Tlaloc)
      myth2 = cUnitTypeTlaloque;
   else if (gAge4MinorGod == cTechAge4Coat)
      myth2 = cUnitTypeTwoHeadSerpent;
   else if (gAge4MinorGod == cTechAge4Ton)
      myth2 = cUnitTypeFireSerpent;

   if ( mythtemp >= 0 ) {
      if ( myth2 >= 0 )
         myth3 = myth2;
      myth2 = mythtemp;
      number++;
   }

   int puid = -1;
   switch( aiRandInt(number) ) {
   case 0: { puid = myth0; break; }
   case 1: { puid = myth1; break; }
   case 2: { puid = myth2; break; }
   case 3: { puid = myth3; break; } }
   if ( puid < 0 )
      return;
   int planID = aiPlanGetIDByTypeAndVariableType( cPlanTrain, cTrainPlanUnitType, puid );
   if ( planID >= 0 )
      return;
   planID = aiPlanCreate( "MythTrain"+puid, cPlanTrain);
   aiPlanSetVariableInt(planID, cTrainPlanUnitType, 0, puid);
   aiPlanSetVariableInt(planID, cTrainPlanNumberToTrain, 0, 2);
   aiPlanSetVariableBool(planID, cTrainPlanUseMultipleBuildings, 0, true);
   aiPlanSetBaseID(planID, kbBaseGetMainID(cMyID));
   aiPlanSetDesiredPriority(planID, 100);
   aiPlanSetMilitary(planID, true);
   aiPlanSetActive(planID);
   aiTaskUnitTrain( findUnit(cUnitTypeTemple), puid );
}


//==============================================================================
rule hesperides //Watch for ownership of a hesperides tree, make driads if you own it.
minInterval 30 //starts in cAge2
inactive
{
   static int driadPlan = -1;
   if ( aiPlanGetActive(driadPlan) != (kbUnitCount(cMyID,cUnitTypeHesperidesTree, cUnitStateAlive) > 0) ) {
      if ( aiPlanGetState(driadPlan) < 0 ) {
         aiPlanDestroy( driadPlan );
         driadPlan = aiPlanCreate( "DryanMaintain", cPlanTrain );
         aiPlanSetVariableInt( driadPlan, cTrainPlanUnitType, 0, cUnitTypeDryad );
         aiPlanSetVariableBool( driadPlan, cTrainPlanUseMultipleBuildings, 0, true );
         aiPlanSetMilitary( driadPlan, true );
         aiPlanSetDesiredPriority( driadPlan, 55 );
      }
      bool activate = ( aiPlanGetActive(driadPlan) == false );
      aiPlanSetActive( driadPlan, activate );
      if ( activate )
         aiPlanSetVariableInt( driadPlan, cTrainPlanNumberToMaintain, 0, 5 );
      else
         aiPlanSetVariableInt( driadPlan, cTrainPlanNumberToMaintain, 0, 0 );
   }
}

//==============================================================================
rule maintainSiegeUnits
minInterval 24 //starts in cAge3
inactive
runImmediately
{        
   int numSiegeWeaponBuildings = kbUnitCount(cMyID, cUnitTypeGuildMeso, cUnitStateAliveOrBuilding);
   int number = kbGetAge();
   if ( number > 3 )
      number = 3;
   if ( numSiegeWeaponBuildings < number ) {
      if ( aiPlanGetIDByTypeAndVariableType(cPlanBuild, cBuildPlanBuildingTypeID, cUnitTypeGuildMeso) < 0 )
         createSimpleBuildPlan( cUnitTypeGuildMeso, 1, 70, true, false, cMilitaryEscrowID, kbBaseGetMainID(cMyID), 1 );
      if ( numSiegeWeaponBuildings < 1 )
         return;
   }

   static int trainSiegeUnitPlanID = -1;
   if ( aiPlanGetState(trainSiegeUnitPlanID) < 0 ) {
      aiPlanDestroy( trainSiegeUnitPlanID );
      trainSiegeUnitPlanID = aiPlanCreate( "SiegeA"+cUnitTypeRamAztec, cPlanTrain );
      aiPlanSetVariableInt( trainSiegeUnitPlanID, cTrainPlanUnitType, 0, cUnitTypeRamAztec );
      aiPlanSetVariableBool( trainSiegeUnitPlanID, cTrainPlanUseMultipleBuildings, 0, true );
      aiPlanSetBaseID( trainSiegeUnitPlanID, kbBaseGetMainID(cMyID) );
      aiPlanSetDesiredPriority( trainSiegeUnitPlanID, 80 );
      aiPlanSetMilitary( trainSiegeUnitPlanID, true );
      aiPlanSetActive( trainSiegeUnitPlanID );
   }
   if ( kbGetAge() <= cAge3 )
      aiPlanSetVariableInt( trainSiegeUnitPlanID, cTrainPlanNumberToMaintain, 0, 3 );
   else
      aiPlanSetVariableInt( trainSiegeUnitPlanID, cTrainPlanNumberToMaintain, 0, 1 );

   static int trainSiege2 = -1;
   if ( kbGetAge() >= cAge4 ) {
      if ( aiPlanGetState(trainSiege2) < 0 ) {
         aiPlanDestroy( trainSiege2 );
         trainSiege2 = aiPlanCreate( "SiegeB"+cUnitTypeSiegeSlinger, cPlanTrain );
         aiPlanSetVariableInt( trainSiege2, cTrainPlanUnitType, 0, cUnitTypeSiegeSlinger );
         aiPlanSetVariableInt( trainSiege2, cTrainPlanNumberToMaintain, 0, 5 );
         aiPlanSetVariableBool( trainSiege2, cTrainPlanUseMultipleBuildings, 0, true );
         aiPlanSetBaseID( trainSiege2, kbBaseGetMainID(cMyID) );
         aiPlanSetDesiredPriority( trainSiege2, 92 );
         aiPlanSetMilitary( trainSiege2, true );
         aiPlanSetActive( trainSiege2 );
      }
   }
}

//================= EXTRA UNITS =================//
rule ExtraUnits
minInterval 7
group Forwarding
inactive
{
   int mainBaseID = kbBaseGetMainID(cMyID);
   const int Range = 45;
   const int UnitToCounter = cUnitTypeLogicalTypeMilitaryUnitsAndBuildings;
   const int UnitType = cUnitTypeLogicalTypeBuildingsThatTrainMilitary;

   int UnitsFound = kbUnitCount(cMyID, UnitType, cUnitStateAlive);
   for (i=0; < UnitsFound) {
      int unitID = findUnitByIndex(UnitType, i, cUnitStateAlive);
      int BaseID = kbUnitGetBaseID(unitID);
      int enemyID = findClosestUnitTypeByLoc(cPlayerRelationEnemy, UnitToCounter, cUnitStateAlive, kbUnitGetPosition(unitID), Range);
      if ((enemyID != -1) && (BaseID != -1) && (BaseID != mainBaseID))
         taskMilUnitTrainAtBase(BaseID, 3, cUnitTypeAbstractSiegeWeapon);	
   }
}

