//Not a stand-alone file! Just this-civ-specific stuffall collected together in here.
//To make things more encapsulated and less cluttered.

void LaunchAztec(int playerid=0, int civid=-1)  //find_this
{
  //CivNameOverride now called in AllCivsPostLaunch().
   set_civ_and_culture( playerid, civid, cTechAge1Aztec );
   if ( kbGetTechStatus(cTechStartingResourcesGreek) != cTechStatusUnobtainable )
      trTechSetStatus( playerid, cTechStartingResourcesGreek, cTechStatusActive );
   if ( civid == cTechAge1Camaxtli ) {
      RevealLOS( playerid, RELATION_ANY, cUnitTypeHuntable, cUnitTypeHerdable );
      xsEnableRule( "CamaxtliBonus"+playerid );
   }

   int qid = CreateQuery( playerid, cUnitTypeHumanSoldier, cUnitStateAlive );
   set_int( ATTACKERS_QRY, qid, playerid );

   qid = CreateQuery( playerid, cUnitTypeSkullTemple, cUnitStateAlive );
   kbUnitQuerySetMaximumDistance( qid, SKULL_TEMPLE_RADIUS );
   set_int( NEAR_SKULLS_QRY, qid, playerid );

   qid = CreateQuery( playerid, cUnitTypeTemple, cUnitStateAlive );
   kbUnitQuerySetAscendingSort( qid, true );
   set_int( NEARBY_TEMPLES_QRY, qid, playerid );

   qid = CreateQuery( playerid, cUnitTypeSlowSpeed, cUnitStateAlive );
   set_int( MICTLAN_SHADOWS_QRY, qid, playerid );

   qid = CreateQuery( playerid, cUnitTypeAbstractPharaoh, cUnitStateDead, false );
   set_int( DEAD_UNIT_QRY, qid, playerid );

   qid = CreateQuery( playerid, -1, cUnitStateAlive );
   set_int( POSITION_QRY, qid, playerid );

   set_int( CAPTURE_MODE_PRISONERS, 100, playerid );  //Offset big at start.
   set_int( CAPTURE_MODE_COOLDOWN, 0, playerid );
   set_int( SACRIFICE_REWARD_TRACKER, 0, playerid );
   set_int( SACRIFICE_REWARDS_OWED, 0, playerid );
   InitTlatoaniAbilities( playerid, choose(civid == cTechAge1Camaxtli, cTechAge1Tezca, civid) );
   copy_cost_trainpoints( playerid, cUnitTypeBlood, cUnitTypeTlatoani );  //To revert from installation ceremony.

   int nextid = trGetNextUnitScenarioNameNumber();
   UnitCreate( playerid, cUnitTypeInvisObstruction, 1, vector(0.5,0.0,0.5) );
   //Using set_int for storing unitid should be ok here, it's an early game 1-time thing.
   set_int( INVIS_OBSTRUCT_ID, kbGetBlockID(""+nextid), playerid );

   int arrayid = array_create( "aztc", 0 );
   set_tlatoani_id( -1, arrayid );
   set_prev_tlatoani_id( -1, arrayid );
   set_int( ARRAY_ID, arrayid, playerid );

   if ( kbIsPlayerHuman(playerid) == false ) {
      for(resourceid=0; < cResourceFavor) {
         kbTechTreeClearDropsiteUnitIDsByResource( resourceid );
         kbTechTreeAddDropsiteUnitIDByResource( resourceid, choose(resourceid == cResourceFood, cUnitTypeGranary, cUnitTypeStorehouse) );
         kbTechTreeAddDropsiteUnitIDByResource( resourceid, cUnitTypeSettlementLevel1 );
         kbTechTreeAddDropsiteUnitIDByResource( resourceid, cUnitTypeCitadelCenter );
      }
      trModifyProtounit( "Granary", playerid, cModifyBuildPoints, -9.9e12 );
      trModifyProtounit( "Storehouse", playerid, cModifyBuildPoints, -9.9e12 );
   }
   TRSelectUnimportantUnit();
   trUnitChangeInArea( playerid, playerid, "Villager Chinese", "VillagerAztec", 9.9e12 );
   trUnitChangeInArea( playerid, playerid, "Castle", "Hill Fort", 9.9e12 );  //For Sea of Worms
   trUnitChangeInArea( playerid, playerid, "Transport Ship Chinese", "Transport Ship Greek", 9.9e12 );  //For Vinlandsaga
   trUnitChangeInArea( playerid, playerid, "Fishing Ship Chinese", "FishingShipAztec", 9.9e12 );
   trUnitChangeInArea( playerid, playerid, "Barracks Chinese", "Barracks", 9.9e12 );
   trUnitChangeInArea( playerid, playerid, "Stable Chinese", "Counter Building", 9.9e12 );
   trUnitChangeInArea( playerid, playerid, "Titan Atlantean", "TitanAztec", 9.9e12 );
   xsEnableRule( "AztecP"+playerid );
}

void ExtMechCastDeathsAwakening(void)
{
  //16 created per cast.
   int qid = CreateQuery( -1, cUnitTypeDeathsAwakenToken, cUnitStateAlive, false );
   int shadowType = cUnitTypeShadowRunner + RNG(3);
   for(playerid=0; < cNumberPlayers) {
      kbUnitQuerySetPlayerID( qid, playerid, false );
      int results = kbUnitQueryExecute( qid );
      if ( results <= 0 )
         continue;
      int rewards = results;
      if ( playerid != 0 )
         rewards = xsMin( xsClamp(xsRound(0.10 * trPlayerGetPopulation(playerid)), 16, 8) * xsMax(results/16, 1), results );
      //trChatSend( 0, "DA_Tokens: Results="+results+", Rewards="+rewards+", Player="+playerid );
      for(i=0; < rewards) {
         change_proto( kbUnitQueryGetResult(qid, i), shadowType );
         shadowType++;
         if ( shadowType > cUnitTypeShadowSpearman )
            shadowType = cUnitTypeShadowRunner;
      }
      for(i=rewards; < results)
         destroy( kbUnitQueryGetResult(qid, i) );
      kbUnitQueryResetResults( qid );
   }
   kbUnitQueryDestroy( qid );
}

int jagNightQid = -1;
bool ExtMechJaguarNightPreCheck(int predatorid=-1)
{
  //Get the power-blocker going (if not already checked), setup the query.
   if ( trCheckGPActive("JagNightEffect", 0) == false )
      trTechInvokeGodPower( 0, "JagNightEffect", kbUnitGetPosition(predatorid) );
   if ( jagNightQid < 0 ) {
      jagNightQid = CreateQuery( RELATION_ENEMY, cUnitTypeLogicalTypeHandUnitsAttack, cUnitStateAlive, false );
      kbUnitQuerySetMaximumDistance( jagNightQid, 15.0 );
      kbUnitQuerySetAscendingSort( jagNightQid, true );
   }
   return( true );
}
void ExtMechJaguarNightPredator(int predatorid=-1)
{
  //1. Already attacking a Unit? Good enough.
   int targetid = kbUnitGetTargetUnitID( predatorid );
   if ( kbUnitGetAnimationActionType(predatorid) == cActionHandAttack ) {
      if ( kbUnitIsType(targetid, cUnitTypeUnit) )
         return;
   }
  //2. Find nearest suitable target, skip garrisons.
   kbUnitQuerySetPosition( jagNightQid, kbUnitGetPosition(predatorid) );
   kbUnitQuerySetUnitType( jagNightQid, cUnitTypeLogicalTypeNavalMilitary );
   int ignore = kbUnitQueryExecute( jagNightQid );
   kbUnitQuerySetUnitType( jagNightQid, cUnitTypeLogicalTypeImplodeAttack );
   int results0 = kbUnitQueryExecute( jagNightQid );
   int bestUnit = -1;
   for(i=ignore; < results0) {
      trUnitSelectClear();
      trUnitSelectByID( kbUnitQueryGetResult(jagNightQid, i) );
      if ( trUnitGetIsContained("All") == false ) {
         bestUnit = trGetSelectedUnitID( 0 );
         break;
      }
   }
  //3. Still no unit? Try a building.
   if ( bestUnit < 0 ) {
      kbUnitQuerySetUnitType( jagNightQid, cUnitTypeBuilding );
      if ( kbUnitQueryExecute(jagNightQid) > results0 )
         bestUnit = kbUnitQueryGetResult( jagNightQid, results0 );
   }
   kbUnitQueryResetResults( jagNightQid );
  //4. Attack if not already hitting it (AttackMove order seems to work better than aiTaskUnitWork()).
   if ( (bestUnit >= 0) && (bestUnit != targetid) ) {
      vector loc = kbUnitGetPosition( bestUnit );
      trUnitSelectClear();
      trUnitSelectByID( predatorid );
      trUnitMoveToPoint( xsVectorGetX(loc), xsVectorGetY(loc), xsVectorGetZ(loc), -1, true );
   }
}

void ExtMechHandOfFireVillagerTransport(int tokenid=-1, int extMechNearestQid=-1)
{
   vector centerLoc = kbUnitGetPosition( tokenid );
   kbUnitQuerySetPosition( extMechNearestQid, centerLoc );
   kbUnitQuerySetUnitType( extMechNearestQid, cUnitTypeEconomic );
   kbUnitQuerySetAscendingSort( extMechNearestQid, false );
   kbUnitQuerySetMaximumDistance( extMechNearestQid, 7.8 );
   int ignore = kbUnitQueryExecute( extMechNearestQid );
   kbUnitQuerySetMaximumDistance( extMechNearestQid, 10.3 );
   int edges = kbUnitQueryExecute( extMechNearestQid );
   for(i=ignore; < edges) {  //Only grab vills that are: > MinDist and <= MaxDist from center point.
      int villagerid = kbUnitQueryGetResult( extMechNearestQid, i );
      vector theLoc = kbUnitGetPosition( villagerid );
      theLoc = theLoc + (xsVectorNormalize(theLoc-centerLoc) * 2.4);
      teleport( villagerid, theLoc );
   }
   kbUnitQueryResetResults( extMechNearestQid );
   kbUnitQuerySetAscendingSort( extMechNearestQid, true );  //Restore query settings.
}

//Returns: Number of Shadows of Mictlan (these count against Tezca's summoning ability).
int ShadowsOfMictlanAbility(int playerid=-1, int tlatoaniid=-1, float fTimeFactor=1.0)
{
   int proximal = 0;
   int qid = get_int( MICTLAN_SHADOWS_QRY, playerid );
   if ( trCheckGPActive("DeathsAwaken", playerid) == false ) {
      if ( tlatoaniid >= 0 ) {
         kbUnitQuerySetPosition( qid, kbUnitGetPosition(tlatoaniid) );
         kbUnitQuerySetMaximumDistance( qid, TLATOANI_UNIT_AURA_RANGE );
         proximal = kbUnitQueryExecute( qid );
         kbUnitQuerySetMaximumDistance( qid, -1.0 );
      }
      int total = kbUnitQueryExecute( qid );
      if ( total > proximal )
         damage_results_range( qid, (fTimeFactor * SHADOW_DAMAGE_RATE), proximal, total, 1.2 );
   }
   else {  //Mictlan's power is active...
      proximal = kbUnitQueryExecute( qid );
      total = proximal;
   }
  //Results [0..proximal) = Regenerate.
  //Results [proximal..total) = Health Decay.
   if ( proximal > 0 )
      damage_results_range( qid, (fTimeFactor * kbProtoUnitGetTrainPoints(cUnitTypeAxe)), 0, proximal );
   kbUnitQueryResetResults( qid );
   return( total );
}

//=================================================================================================================================
// SPC Civ stuff (seperate from AztecRuleFunc to avoid performance hit, since these are for rare, special civ picks)
void CamaxBonusFunc(int playerid=-1)
{
   int barrackSpawns = get_int( CAMAXTLI_BARRACK_TRACKER, playerid );
   if ( barrackSpawns >= 2000 ) {
      xsDisableRule( "CamaxtliBonus"+playerid );
      return;
   }
   int nobleSpawns = get_int( CAMAXTLI_NOBLES_TRACKER, playerid );
   if ( (barrackSpawns + nobleSpawns) <= 0 )
      return;

   xsSetContextPlayer( playerid );
   int buildingid = find_unit( get_int(BASIC_QUERY, playerid), cUnitTypeSettlementsThatTrainVillagers );
   if ( barrackSpawns > 0 ) {
      subtract_int( CAMAXTLI_BARRACK_TRACKER, barrackSpawns, playerid );
      if ( buildingid >= 0 )
         BannerArmySpawn( playerid, buildingid, true, (cUnitTypeSpearmanAztec + RNG(3)), barrackSpawns );
   }
   if ( nobleSpawns > 0 ) {
      subtract_int( CAMAXTLI_NOBLES_TRACKER, nobleSpawns, playerid );
      if ( buildingid >= 0 )
         BannerArmySpawn( playerid, buildingid, true, (cUnitTypeJaguarKnight + RNG(3)), nobleSpawns );
   }
}
rule CamaxtliBonus1  minInterval 1 maxInterval 1 inactive group _dod1  { CamaxBonusFunc(1); }
rule CamaxtliBonus2  minInterval 1 maxInterval 1 inactive group _dod2  { CamaxBonusFunc(2); }
rule CamaxtliBonus3  minInterval 1 maxInterval 1 inactive group _dod3  { CamaxBonusFunc(3); }
rule CamaxtliBonus4  minInterval 1 maxInterval 1 inactive group _dod4  { CamaxBonusFunc(4); }
rule CamaxtliBonus5  minInterval 1 maxInterval 1 inactive group _dod5  { CamaxBonusFunc(5); }
rule CamaxtliBonus6  minInterval 1 maxInterval 1 inactive group _dod6  { CamaxBonusFunc(6); }
rule CamaxtliBonus7  minInterval 1 maxInterval 1 inactive group _dod7  { CamaxBonusFunc(7); }
rule CamaxtliBonus8  minInterval 1 maxInterval 1 inactive group _dod8  { CamaxBonusFunc(8); }
rule CamaxtliBonus9  minInterval 1 maxInterval 1 inactive group _dod9  { CamaxBonusFunc(9); }
rule CamaxtliBonus10 minInterval 1 maxInterval 1 inactive group _dod10 { CamaxBonusFunc(10); }
rule CamaxtliBonus11 minInterval 1 maxInterval 1 inactive group _dod11 { CamaxBonusFunc(11); }
rule CamaxtliBonus12 minInterval 1 maxInterval 1 inactive group _dod12 { CamaxBonusFunc(12); }
//===============================================================================================================================
int _SacrificeRewardGrant(int playerid=-1, int wantedSpawns=0, int numTemples=-1)
{
   if ( wantedSpawns <= 0 )
      return( 0 );
   if ( numTemples == 0 )
      return( 0 );
   int numSpawns = xsMin( wantedSpawns, xsMax(kbGetPopCap() - kbGetPop(), 0) );
   if ( numSpawns > 0 ) {
      int offset = xsClamp(kbGetAge(), cAge4, cAge2) * 3;  //3 myths per age baseline
      if ( kbGetAge() >= cAge3 )  //4 myths in Age3
         offset++;
      for(i=0; < numSpawns) {
         int techid = (cTechSpawnHuitznahua + RNG_Slow(offset));
         trTechSetStatus( playerid, techid, cTechStatusUnobtainable );
         trTechSetStatus( playerid, techid, cTechStatusActive );
      }
      string sText = "a myth unit";
      if ( numSpawns >= 2 )
         sText = numSpawns+" myth units";
      trChatSendToPlayer( 0, playerid, "Huitzilopochtli has granted you "+sText+" at your Temple!" );
   }
   int addToOwed = negate( numSpawns );
   if ( numTemples == -1 ) {  //Called via SacrificeHandler.
      addToOwed = (wantedSpawns - numSpawns);
      numSpawns = wantedSpawns;
   }
   if ( addToOwed != 0 )
      add_int( SACRIFICE_REWARDS_OWED, addToOwed, playerid );
   return( numSpawns );
}

void PrisonerSacrificeAtTemples(int playerid=0, int civid=-1, int qid=-1, int results=0)
{
   int normal_sacrifices = 0;
   int tlaloc_sacrifices = 0;
   int offset = xsMin(kbGetAge(), cAge4) * 4;
   for(i=0; < results) {
      int prisonerid = kbUnitQueryGetResult( qid, i );
      if ( kbUnitGetAnimationActionType(prisonerid) != cActionGather )
         continue;
      int templeid = kbUnitGetTargetUnitID( prisonerid );
      if ( kbUnitGetProtoUnitID(templeid) != cUnitTypeTlalocan ) {
         normal_sacrifices++;
         if ( kbUnitGetProtoUnitID(prisonerid) == cUnitTypePrisonerBig )
            normal_sacrifices++;
         if ( kbUnitGetAnimationActionType(templeid) != cActionOverrideAnimation ) {
            trUnitSelectClear();
            trUnitSelectByID( templeid );
            trUnitOverrideAnimation( 25, offset+RNG(4), false, true, -1, 0 );  //25=Cinematic
         }
      }
      else {  //Tlalocan.
         tlaloc_sacrifices++;
         if ( kbUnitGetProtoUnitID(prisonerid) == cUnitTypePrisonerBig )
            tlaloc_sacrifices++;
         UnitCreate( 0, cUnitTypeOsirisBoxGlow, 1, kbUnitGetPosition(prisonerid) );
      }
     //Convert -> Destroy is necessary here!
     //trUnitDelete(true) doesn't work in multiplayer, trUnitChangeProtoUnit() crashes on prisoners not trained from Market,
     //convert() is needed so prisoners don't add to the units_lost/units_lost_cost stats! (Which would give undeserved
     //rewards if Festival of Death is active.)
      convert( prisonerid, 0 );
      trUnitDestroy();
   }
   kbUnitQueryResetResults( qid );
   int addSacrifices = normal_sacrifices + tlaloc_sacrifices;
   if ( addSacrifices <= 0 )
      return;

  //Favor Grant.
   float fFavorModifier = kbProtoUnitGetTrainPoints( cUnitTypeBush );
   float fTlalocModifier = get_float( cUnitTypeTlalocan );
   float fSacrificeWeight = fFavorModifier * normal_sacrifices;
   if ( tlaloc_sacrifices > 0 )
      fSacrificeWeight = fSacrificeWeight + ((fFavorModifier + fTlalocModifier) * tlaloc_sacrifices);
   favor_grant = favor_grant + (fSacrificeWeight * 6.5);

  //Food/Wood/Gold Grant.
   fSacrificeWeight = kbProtoUnitGetTrainPoints( cUnitTypePalmStump );
   if ( fSacrificeWeight > 0.0 ) {
      fSacrificeWeight = fSacrificeWeight * (((1.0 + fTlalocModifier) * tlaloc_sacrifices) + normal_sacrifices);
      food_grant = food_grant + fSacrificeWeight;
      wood_grant = wood_grant + fSacrificeWeight;
      gold_grant = gold_grant + fSacrificeWeight;
   }

  //Huitz's free Myth Unit bonus.
   const int SACRIFICE_REWARD_THRESHOLD = 8;
   if ( civid == cTechAge1Huitz ) {
      int total = get_int(SACRIFICE_REWARD_TRACKER, playerid) + addSacrifices;
      if ( total >= SACRIFICE_REWARD_THRESHOLD ) {
         total = _SacrificeRewardGrant( playerid, (total / SACRIFICE_REWARD_THRESHOLD) );
         addSacrifices = addSacrifices - (total * SACRIFICE_REWARD_THRESHOLD);
      }
      if ( addSacrifices != 0 )
         add_int( SACRIFICE_REWARD_TRACKER, addSacrifices, playerid );
   }
}

void UpdatePrisonerAutoTargets(int playerid=-1, int basicQid=-1, int tlalocans=-1, int temples=-1)
{
  //Temples.
   int difference = (temples - get_int(PREV_NUM_TEMPLES, playerid));
   bool doTask = (difference != 0);
   if ( doTask )
      add_int( PREV_NUM_TEMPLES, difference, playerid );

  //Tlalocans.
   difference = (tlalocans - get_int(PREV_NUM_TLALOCANS, playerid));
   if ( difference != 0 ) {
      add_int( PREV_NUM_TLALOCANS, difference, playerid );
      doTask = true;
   }

  //Full Prisoner Retask if needed and not done already.
   if ( doTask && (gFullPrisonerRetask == false) ) {
      kbUnitQuerySetUnitType( basicQid, cUnitTypeLogicalTypeMeanPredatorsAutoAttack );
      AutoTaskPrisoners( playerid, basicQid, -1 );
   }
}

void ChinampaAndFishBoatHandle(int playerid=0, int chinampaQid=-1, int chinampas=0, bool tacticChange=false, float fMultiplier=1.0)
{
   int prevResults = 0;
   int posQid = get_int( POSITION_QRY, playerid );
   kbUnitQuerySetUnitType( posQid, cUnitTypeUtilityShip );
   kbUnitQuerySetMaximumDistance( posQid, 0.2 );

  //Chinampa Resource production toggle now handled in SpecialPowersTokensAztec().

  //1. Count garrisoned boats, transform to NoIdle type, store IDs so they dont show up in query later.
   for(i=0; < chinampas) {
      int farmid = kbUnitQueryGetResult( chinampaQid, i );
      if ( tacticChange )
         trainCancelByButtonIndex( 0, farmid, playerid );
      kbUnitQuerySetPosition( posQid, kbUnitGetPosition(farmid) );
      int results = kbUnitQueryExecute( posQid );
      if ( results <= prevResults )  //Nothing garrisoned.
         continue;
      prevResults = results;
      int boatid = kbUnitQueryGetResult( posQid, results-1 );
      if ( kbUnitGetProtoUnitID(boatid) != cUnitTypeFishingShipAztecNoIdle )
         mutate( boatid, cUnitTypeFishingShipAztecNoIdle );
   }
   kbUnitQueryResetResults( chinampaQid );

  //3. NoIdle boats stealthfully transform into IdleVill boats when *not* in a chinampa.
   kbUnitQuerySetActionType( posQid, cActionIdle );
   kbUnitQuerySetUnitType( posQid, cUnitTypeFishingShipAztecNoIdle );
   kbUnitQuerySetMaximumDistance( posQid, -1.0 );
   results = kbUnitQueryExecute( posQid );
   for(i=prevResults; < results)
      mutate( kbUnitQueryGetResult(posQid, i), cUnitTypeFishingShipAztec );
   kbUnitQueryResetResults( posQid );
   kbUnitQuerySetActionType( posQid, -1 );  //Unset action.

  //4. Resource Gathering.
   if ( prevResults > 0 )
      if ( get_int(cUnitTypeFoodToken, playerid) == 0 )
         food_grant = food_grant + (fMultiplier * get_float(cUnitTypeChinampa) * prevResults);
      else
         gold_grant = gold_grant + (fMultiplier * get_float(cUnitTypeDock) * prevResults);
}

int _ChinampaTacticChange(int playerid=-1) {
   int resourceid = cUnitTypeGoldToken;
   int otherResourceid = cUnitTypeFoodToken;
   if ( kbGetBuildLimit(playerid, otherResourceid) == 0 ) {
      resourceid = cUnitTypeFoodToken;
      otherResourceid = cUnitTypeGoldToken;
   }
   int numTokens = kbUnitCount( playerid, otherResourceid, cUnitStateBuilding );
   if ( numTokens > 0 ) {
      add_int( resourceid, 1, playerid );
      add_int( otherResourceid, -1, playerid );
   }
   return( numTokens );
}
//RETURNS: If chinampas are toggling thier resource production (token unit needs canceling!)
bool SpecialPowersTokensAztec(int playerid=-1, int basicQid=-1)
{
   bool chinampaTacticChange = false;
   int tokens = kbUnitCount( playerid, cUnitTypeSpecialPowers, cUnitStateAliveOrBuilding );
   if ( tokens <= 0 ) return( chinampaTacticChange );

  //1. Capture Mode Toggle (most probable).
  //Now Handled in ExtendedMechanics rule.

   int section = tokens - kbUnitCount(playerid, cUnitTypeSpecialPowers, cUnitStateAlive);
   if ( section > 0 ) {
     //#. Chinampa Resource.
      section = _ChinampaTacticChange( playerid );
      chinampaTacticChange = (section > 0);
      tokens = tokens - section;
      if ( tokens <= 0 ) return( chinampaTacticChange );

     //#. Tianguis mechanics (next most prob?)
      section = TianguisExchange( playerid, basicQid );
      tokens = tokens - section;
      if ( tokens <= 0 ) return( chinampaTacticChange );
   }

  //#. Tlalocan Sacrifice Preference.
   section = MultiUnitTypeQuery( basicQid, cUnitTypePreferTlalocOn, cUnitTypePreferTlalocOff );
   if ( section > 0 ) {
      destroy_results( basicQid, 1, section );
      TacticChangeBool( playerid, kbUnitQueryGetResult(basicQid, 0), cUnitTypeTlalocan,
                        cUnitTypePreferTlalocOff, cUnitTypePreferTlalocOn );
      kbUnitQueryResetResults( basicQid );

      if ( gFullPrisonerRetask == false ) {
         kbUnitQuerySetUnitType( basicQid, cUnitTypeLogicalTypeMeanPredatorsAutoAttack );
         AutoTaskPrisoners( playerid, basicQid, -1 );
      }
      tokens = tokens - section;
      if ( tokens <= 0 ) return( chinampaTacticChange );
   }

  //#. New Civ Titan fix.
   NewCultureTitanFix( playerid, basicQid, cUnitTypeTitanAztec );
   return( chinampaTacticChange );
}

//===================================================================================================================================
void AztecRuleFunc(int playerid=-1)  //find_this
{
  //Preliminary stuff.
   int qid = get_int( BASIC_QUERY, playerid );
   RuleFuncImmediateSetup( playerid, qid, cTechAge1Aztec );
   int arrayid = get_int( ARRAY_ID, playerid );
   float fTimeFactor = get_time_modifier( arrayid );
   gFullPrisonerRetask = false;

  //RuleFunc Special Units (above UpdatePrisonerAutoTargets() due to toggling tlalocan-sacr-pref).
   bool farmTactic = SpecialPowersTokensAztec( playerid, qid );

  //Everybody stuff (due to HandleScriptTechs, this must preceed most of the other stuff here).
   int number = kbUnitCount( playerid, cUnitTypeTlalocan, cUnitStateAlive );
   AllCivsNewMechanics( playerid, cTechAge1Aztec, qid, fTimeFactor, number );

  //Check if Prisoners should update thier targets.
  //(Above CapturePrisonersFunc to avoid double-tasking new captures, but under SpecialPowersTokensAztec() ).
   int temples = kbUnitCount( playerid, cUnitTypeTemple, cUnitStateAlive );
   UpdatePrisonerAutoTargets( playerid, qid, number );

  //Chinampa Gather.
   kbUnitQuerySetUnitType( qid, cUnitTypeChinampa );
   number = kbUnitQueryExecute( qid );
   if ( number > 0 )
      ChinampaAndFishBoatHandle( playerid, qid, number, farmTactic, fTimeFactor );

  //Capture Mode.
   int templeQid = -1;
   if ( kbGetTechStatus(cTechGarlandWarActive) >= cTechStatusActive ) {
      templeQid = get_int( NEARBY_TEMPLES_QRY, playerid );
      CapturePrisonersFunc( playerid, qid, templeQid, fTimeFactor );
   }

  //Huitz's free myths that were pop-blocked earlier.
   int civid = get_my_civ();
   if ( civid == cTechAge1Huitz )
      _SacrificeRewardGrant( playerid, get_int(SACRIFICE_REWARDS_OWED, playerid), temples );

  //Tlatoani Auras/Abilities/Revive/Retrain.
   int tlatoaniid = get_tlatoani_id( arrayid );
   number = ShadowsOfMictlanAbility( playerid, tlatoaniid, fTimeFactor );
   if ( kbUnitGetCurrentHitpoints(tlatoaniid) > 0.0 ) {
      switch( civid ) {
      case cTechAge1Quetz: { QuetzTlatoaniEffects(playerid, tlatoaniid, fTimeFactor); break; }
      case cTechAge1Huitz: { HuitzTlatoaniEffects(playerid, tlatoaniid, fTimeFactor, templeQid); break; }
      default:             { TezcaTlatoaniEffects(playerid, tlatoaniid, number); break; } }
   }
   else if ( tlatoaniid < 0 ) {
      if ( FindNewTlatoani(playerid, arrayid, qid) < 0 )
         add_float( cUnitTypeYardstick, fTimeFactor );
   }
   else {
      TlatoaniDeathHandler( playerid, tlatoaniid );
      set_tlatoani_id( -1, arrayid );
   }

  //Prisoner Sacrifice.
   kbUnitQuerySetUnitType( qid, cUnitTypeLogicalTypeMeanPredatorsAutoAttack );
   kbUnitQuerySetActionType( qid, cActionGather );
   number = kbUnitQueryExecute( qid );
   if ( number > 0 )
      PrisonerSacrificeAtTemples( playerid, civid, qid, number );

  //Idle Prisoners Auto-Task (iff full retask not already done for diff reason).
   if ( gFullPrisonerRetask == false ) {
      kbUnitQuerySetActionType( qid, cActionIdle );
      AutoTaskPrisoners( playerid, qid, templeQid );
   }

  //Amoxoaque turns enemies into Trees.
   kbUnitQuerySetUnitType( qid, cUnitTypeMinion );
   kbUnitQuerySetActionType( qid, cActionBirth );
   number = kbUnitQueryExecute( qid );
   for(i=0; < number) {
      change_proto( kbUnitQueryGetResult(qid, i), cUnitTypeTreeAmox );
      trUnitConvert( 0 );
      trUnitOverrideAnimation( 18, 0, false, true, -1, 0 );  //18=Birth
   }
   kbUnitQueryResetResults( qid );
   kbUnitQuerySetActionType( qid, -1 );  //BasicQuery have no action when this func completes!

  //Cinteteo Upgrade.
   float fValue = get_float( cUnitTypeFarm );
   if ( fValue > 0.0 )
      gold_grant = gold_grant + (fTimeFactor * fValue * GetFarmingVillPop(qid));

  //Festival of Death.
   fValue = get_float( cUnitTypeTestObject );
   if ( fValue > 0.0 ) {
      number = StatDifference( playerid, cStatUnitsLostCost, PREV_DEAD_UNITS_COST );
      if ( number > 0 )
         add_resource_grant( lowest_resource_type(), (fValue * number) );
   }

  //Give resources at end.
   GrantResourcesOwed( playerid );
}
rule AztecP1  minInterval 1 maxInterval 1 priority 100 group _dod1 inactive  { AztecRuleFunc(1); }
rule AztecP2  minInterval 1 maxInterval 1 priority 100 group _dod2 inactive  { AztecRuleFunc(2); }
rule AztecP3  minInterval 1 maxInterval 1 priority 100 group _dod3 inactive  { AztecRuleFunc(3); }
rule AztecP4  minInterval 1 maxInterval 1 priority 100 group _dod4 inactive  { AztecRuleFunc(4); }
rule AztecP5  minInterval 1 maxInterval 1 priority 100 group _dod5 inactive  { AztecRuleFunc(5); }
rule AztecP6  minInterval 1 maxInterval 1 priority 100 group _dod6 inactive  { AztecRuleFunc(6); }
rule AztecP7  minInterval 1 maxInterval 1 priority 100 group _dod7 inactive  { AztecRuleFunc(7); }
rule AztecP8  minInterval 1 maxInterval 1 priority 100 group _dod8 inactive  { AztecRuleFunc(8); }
rule AztecP9  minInterval 1 maxInterval 1 priority 100 group _dod9 inactive  { AztecRuleFunc(9); }
rule AztecP10 minInterval 1 maxInterval 1 priority 100 group _dod10 inactive { AztecRuleFunc(10); }
rule AztecP11 minInterval 1 maxInterval 1 priority 100 group _dod11 inactive { AztecRuleFunc(11); }
rule AztecP12 minInterval 1 maxInterval 1 priority 100 group _dod12 inactive { AztecRuleFunc(12); }
