//rotg_bigheroes.xs
//This is not a stand-alone file! Use rotg_script.
//This file consists of all Tlatoani-related code because we were constantly revising what the abilities were and things became very cluttered.

void InitTlatoaniAbilities(int playerid=-1, int civid=-1)
{
   UnitCreate( playerid, cUnitTypeInvisWorker, NUM_INVIS_WORKERS, vector(0.5,0.0,0.5) );
   int unitqid = CreateQuery( playerid, cUnitTypeInvisWorker, cUnitStateAlive );
   kbUnitQueryExecute( unitqid );
   set_int( INVIS_WORKER_QRY, unitqid, playerid );

   int buildqid = CreateQuery( playerid, -1, cUnitStateBuilding );
   kbUnitQuerySetMaximumDistance( buildqid, TLATOANI_BUILDING_AURA_RANGE );
   set_int( TLATOANI_BUILDAURA_QRY, buildqid, playerid );

   unitqid = -1;
   if ( civid == cTechAge1Quetz ) {
      kbUnitQuerySetUnitType( buildqid, cUnitTypeLogicalTypeMinimapFilterEconomic );
      unitqid = CreateQuery( playerid, cUnitTypeLogicalTypeIdleCivilian, cUnitStateAlive );
   }
   else if ( civid == cTechAge1Huitz )
      unitqid = CreateQuery( playerid, cUnitTypeLogicalTypeAffectedByHealingSpring, cUnitStateAlive );
   else {  //Tezca/Camaxtli
      set_int( SHADOW_SPAWN_TYPE, cUnitTypeShadowRunner, playerid );
      set_int( SHADOW_SUMMON_TIMER, 1, playerid );
      xsEnableRule( "ShadeSummonRe"+playerid );
   }
   kbUnitQuerySetMaximumDistance( unitqid, TLATOANI_UNIT_AURA_RANGE );
   set_int( TLATOANI_UNITAURA_QRY, unitqid, playerid );
}

int GatherIncreaseAura(int playerid=0, int gatherersQid=-1, float fPerFood=1.0, float fPerWood=-1.0, float fPerGold=-1.0, int startAt=0)
{
   int foods = 0;
   int woods = 0;
   int golds = 0;
   if ( fPerWood < 0.0 ) {
      fPerWood = fPerFood;
      fPerGold = fPerFood;
   }
   kbUnitQuerySetActionType( gatherersQid, cActionGather );  //Most resources
   kbUnitQueryExecute( gatherersQid );
   kbUnitQuerySetActionType( gatherersQid, cActionHunting );  //Hunts, Trees, Herds (invoke vill's "Hunting" action)
   int results = kbUnitQueryExecute( gatherersQid );
   for(i=startAt; < results) {
      int targetid = kbUnitGetTargetUnitID( kbUnitQueryGetResult(gatherersQid, i) );
      xsSetContextPlayer( kbUnitGetOwner(targetid) );
      switch( kbUnitGetResourceType(targetid) ) {  //Faster than "else if (kbUnitIsType(target, cUnitTypeFood))"...
      case cResourceFood: { foods++; break; }
      case cResourceWood: { woods++; break; }
      default:            { golds++; break; } }
      xsSetContextPlayer( playerid );
   }
   food_grant = food_grant + (fPerFood * foods);
   wood_grant = wood_grant + (fPerWood * woods);
   gold_grant = gold_grant + (fPerGold * golds);
   return( results );
}

//=================================================================================================================================
void _TaskEmpowerWorkers(int workersQid=-1, int targetsQid=-1, int numTargets=0)
{
  //All: Task the right num of workers to empower the targets.
   numTargets = xsMin( numTargets, NUM_INVIS_WORKERS );
   for(i=0; < numTargets) {
      int workerid = kbUnitQueryGetResult( workersQid, i );
      int targetid = kbUnitQueryGetResult( targetsQid, i );
      if ( kbUnitGetTargetUnitID(workerid) != targetid )
         aiTaskUnitWork( workerid, targetid );
   }
   kbUnitQueryResetResults( targetsQid );
   for(i=numTargets; < NUM_INVIS_WORKERS) {  //Remaining workers stop working on "old" targets
      workerid = kbUnitQueryGetResult( workersQid, i );
      if ( kbUnitGetAnimationActionType(workerid) == cActionEmpower )
         aiTaskUnitWork( workerid, workerid );  //"aiTaskUnitStopWorking"
   }
}

void QuetzTlatoaniEffects(int playerid=-1, int tlatoaniid=-1, float fTimeFactor=1.0)
{
   int buildingQid = get_int( TLATOANI_BUILDAURA_QRY, playerid );
   kbUnitQuerySetPosition( buildingQid, kbUnitGetPosition(tlatoaniid) );
  //Quetz 1. Eco buildings build faster.
   int numTargets = kbUnitQueryExecute( buildingQid );
   int unitsQid = get_int( INVIS_WORKER_QRY, playerid );
   _TaskEmpowerWorkers( unitsQid, buildingQid, numTargets );

  //Quetz 2. Tlatoani enhances nearby gathering.
   unitsQid = get_int( TLATOANI_UNITAURA_QRY, playerid );
   kbUnitQuerySetPosition( unitsQid, kbUnitGetPosition(tlatoaniid) );
   GatherIncreaseAura( playerid, unitsQid, (fTimeFactor * get_float(cUnitTypeScarabBlood)) );
   kbUnitQueryResetResults( unitsQid );
}

void TezcaTlatoaniEffects(int playerid=-1, int tlatoaniid=-1, int numShadows=0)
{
   int buildingQid = get_int( TLATOANI_BUILDAURA_QRY, playerid );
   kbUnitQuerySetPosition( buildingQid, kbUnitGetPosition(tlatoaniid) );
  //Tezca/Huitz 1. Military buildings build faster.
   kbUnitQuerySetState( buildingQid, cUnitStateBuilding );
   kbUnitQuerySetUnitType( buildingQid, cUnitTypeMilitaryBuilding );  //Include Towers in Building state.
   kbUnitQueryExecute( buildingQid );
   kbUnitQuerySetUnitType( buildingQid, cUnitTypeAbstractDock );
   int number = kbUnitQueryExecute( buildingQid );

   //Tezca 2. Military builds train faster.
   if ( number < NUM_INVIS_WORKERS ) {
      kbUnitQuerySetState( buildingQid, cUnitStateAlive );
      kbUnitQuerySetUnitType( buildingQid, cUnitTypeLogicalTypeBuildingsThatTrainMilitary );  //Exclude Towers in Alive state.
      kbUnitQueryExecute( buildingQid );
      kbUnitQuerySetUnitType( buildingQid, cUnitTypeAbstractDock );
      number = kbUnitQueryExecute( buildingQid );
   }
   _TaskEmpowerWorkers( get_int(INVIS_WORKER_QRY, playerid), buildingQid, number );

  //Tezca 3. Summon Shadows of Mictlan.
   if ( get_int(SHADOW_SUMMON_TIMER, playerid) == 0 ) {  //Ability recharged.
      number = xsMin( kbGetAge()+1, kbGetBuildLimit(playerid, cUnitTypeShadowRunner) - numShadows );
      if ( number > 0 ) {
         int protoid = get_int( SHADOW_SPAWN_TYPE, playerid );
         UnitCreate( playerid, protoid, number, kbUnitGetPosition(tlatoaniid) );
         add_int( SHADOW_SPAWN_TYPE, choose(protoid != cUnitTypeShadowSpearman, 1, -2), playerid );
         trChatSendToPlayer( 0, playerid, "Your Tlatoani has summoned Shadows of Mictlan!" );
      }
      add_int( SHADOW_SUMMON_TIMER, 2, playerid );
      xsEnableRule( "ShadeSummonRe"+playerid );
   }
}

void HuitzTlatoaniEffects(int playerid=-1, int tlatoaniid=-1, float fTimeFactor=1.0, int nearTempleQid=-1)
{
   int buildingQid = get_int( TLATOANI_BUILDAURA_QRY, playerid );
   kbUnitQuerySetPosition( buildingQid, kbUnitGetPosition(tlatoaniid) );
  //Huitz/Tezca 1. Military buildings build faster.
   kbUnitQuerySetUnitType( buildingQid, cUnitTypeMilitaryBuilding );  //Include Towers in Building state.
   kbUnitQueryExecute( buildingQid );
   kbUnitQuerySetUnitType( buildingQid, cUnitTypeAbstractDock );
   int numTargets = kbUnitQueryExecute( buildingQid );
   int unitsQid = get_int( INVIS_WORKER_QRY, playerid );
   _TaskEmpowerWorkers( unitsQid, buildingQid, numTargets );

  //Huitz 2. Reflect Damage aura.
   unitsQid = get_int( TLATOANI_UNITAURA_QRY, playerid );
   kbUnitQuerySetPosition( unitsQid, kbUnitGetPosition(tlatoaniid) );
   kbUnitQuerySetActionType( unitsQid, cActionHandAttack );
   kbUnitQueryExecute( unitsQid );
   kbUnitQuerySetActionType( unitsQid, cActionRangedAttack );
   damage_results( unitsQid, -1, (fTimeFactor * get_float(cUnitTypeWaypointFlag)) );

  //Huitz 3. Instant-Capture ability.
   bool doCapture = false;
   if ( get_int(HUITZ_CAPTURE_TIMER, playerid) == 0 ) {  //Ability recharged.
      if ( kbUnitGetAnimationActionType(tlatoaniid) == cActionHandAttack ) {  //Currently attacking.
         int targetid = kbUnitGetTargetUnitID( tlatoaniid );
         if ( kbUnitIsType(targetid, cUnitTypeUseableItem) )  //Target is capturable.
            if ( kbUnitIsType(targetid, cUnitTypeEconomic) == false )  //Target is not a civilian.
               doCapture = true;
      }
   }

   if ( doCapture ) {
      change_proto( targetid, cUnitTypePrisonerSmall );  //MUST TRANSFORM BEFORE CONVERT! Otherwise game may crash!
      trUnitConvert( playerid );
      doCapture = ( kbUnitGetOwner(targetid) == playerid );
      if ( doCapture ) {  //Capture succeeded.
         if ( nearTempleQid < 0 )
            nearTempleQid = get_int( NEARBY_TEMPLES_QRY, playerid );
         ExecutePrisonerTempleQuery( nearTempleQid, targetid, kbProtoUnitAvailable(cUnitTypeTlalocan) );
         trUnitSelectClear();
         trUnitSelectByID( tlatoaniid );
         trUnitOverrideAnimation( 26, 0, false, true, -1, 0 );  //26 = Gore
         add_int( HUITZ_CAPTURE_TIMER, 2, playerid );
         xsEnableRule( "InstaCaptureRe"+playerid );
        //Increase Capture cost, keep upper-bound loop going.
         float fStartCost = get_float( cUnitTypeTempleKronos );
         float fAddCost = fStartCost * (CAPTURE_COST_INCR_BASE - 1.0);
         if ( (fStartCost + fAddCost) > get_float(cUnitTypeEarth) )
            fAddCost = fAddCost - CAPTURE_COST_DECREASE;
         add_float( cUnitTypeTempleKronos, fAddCost );
      }
   }
   if ( doCapture == (kbGetTechStatus(cTechTlatoaniGoreEnable) >= cTechStatusActive) )
      trTechSetStatus( playerid, cTechTlatoaniGoreEnable, choose(doCapture, cTechStatusUnobtainable, cTechStatusActive) );
}

//================================================================================================================
void TlatoaniDeathHandler(int playerid=-1, int heroid=-1)
{
   int workerQid = get_int( INVIS_WORKER_QRY, playerid );
   for(i=0; < NUM_INVIS_WORKERS) {
      int workerid = kbUnitQueryGetResult( workerQid, i );
      aiTaskUnitWork( workerid, workerid );  //"aiTaskUnitStopWorking"
   }
   set_float( cUnitTypeYardstick, 0.0 );
   teleport( get_int(INVIS_OBSTRUCT_ID, playerid), kbUnitGetPosition(heroid) );
}

void ShadeSummonReFunc(int playerid=-1) {
   add_int( SHADOW_SUMMON_TIMER, -1, playerid );
   if ( get_int(SHADOW_SUMMON_TIMER, playerid) <= 0 )
      xsDisableRule( "ShadeSummonRe"+playerid );
}
rule ShadeSummonRe1  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(1); }
rule ShadeSummonRe2  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(2); }
rule ShadeSummonRe3  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(3); }
rule ShadeSummonRe4  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(4); }
rule ShadeSummonRe5  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(5); }
rule ShadeSummonRe6  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(6); }
rule ShadeSummonRe7  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(7); }
rule ShadeSummonRe8  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(8); }
rule ShadeSummonRe9  minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(9); }
rule ShadeSummonRe10 minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(10); }
rule ShadeSummonRe11 minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(11); }
rule ShadeSummonRe12 minInterval 180 maxInterval 180 inactive priority 100 { ShadeSummonReFunc(12); }

//RETURNS: ID of new alive Tlatoani (already stored in array), -1 if no living one found.
int FindNewTlatoani(int playerid=-1, int arrayid=-1, int basicQid=-1)
{
   int heroid = find_unit( basicQid, cUnitTypeTlatoani );
   if ( heroid < 0 )
      heroid = find_unit( basicQid, cUnitTypeTlatoaniQuetz );
   if ( heroid >= 0 ) {
      set_tlatoani_id( heroid, arrayid );
      teleport( get_int(INVIS_OBSTRUCT_ID, playerid), vector(0.5,0.0,0.5) );
      if ( heroid == get_prev_tlatoani_id(arrayid) ) {  //Revived, not trained.
         trUnitSelectClear();
         trUnitSelectByID( heroid );
         trUnitSetHP( 0.5 * get_float(cUnitTypeYardstick) );
      }
      else {  //Retrained.
         set_prev_tlatoani_id( heroid, arrayid );
         int freebies = get_int( FREE_TLATOANIS, playerid );
         if ( freebies > 0 ) {
            add_int( FREE_TLATOANIS, -1, playerid );
            if ( freebies == 1 ) {
               copy_cost_trainpoints( playerid, cUnitTypeTlatoani, cUnitTypeBlood );
               copy_cost_trainpoints( playerid, cUnitTypeTlatoaniQuetz, cUnitTypeBlood );
            }
         }
         destroy_results( get_int(DEAD_UNIT_QRY, playerid) );
      }
   }
   return( heroid );
}

void InstaCaptureReFunc(int playerid=-1) {
   add_int( HUITZ_CAPTURE_TIMER, -1, playerid );
   if ( get_int(HUITZ_CAPTURE_TIMER, playerid) <= 0 )
      xsDisableRule( "InstaCaptureRe"+playerid );
}
rule InstaCaptureRe1  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(1); }
rule InstaCaptureRe2  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(2); }
rule InstaCaptureRe3  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(3); }
rule InstaCaptureRe4  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(4); }
rule InstaCaptureRe5  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(5); }
rule InstaCaptureRe6  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(6); }
rule InstaCaptureRe7  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(7); }
rule InstaCaptureRe8  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(8); }
rule InstaCaptureRe9  minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(9); }
rule InstaCaptureRe10 minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(10); }
rule InstaCaptureRe11 minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(11); }
rule InstaCaptureRe12 minInterval 70 maxInterval 70 runImmediately inactive priority 100 { InstaCaptureReFunc(12); }

//===========================================================================================================================
//INCAS

void IntiSapaIncaPowers(int playerid=-1, int bigHeroID=-1, int basicQid=-1, float fTimeFactor=1.0)
{

}

void PachaSapaIncaPowers(int playerid=-1, int bigHeroID=-1, int basicQid=-1, float fTimeFactor=1.0)
{

}

void ViraSapaIncaPowers(int playerid=-1, int bigHeroID=-1, int basicQid=-1, float fTimeFactor=1.0)
{

}








