//Not a stand-alone file!
//Things just got cluttered.

//=======================================================================================================================
//Darn shame AoM doesn't support lambds/function-pointers (AoE3DE does). These 2 funcs will just have to be used and
//expanded as more "building finished event" mechanics get added.
float _PerBuildingDone(int playerid=-1, int scriptVar=-1, int buildingid=-1, float fValue=0.0)
{
/*
   if ( scriptVar == TC_BUILD_MAYA_QRY )
      BannerArmySpawn( playerid, buildingid, true, cUnitTypeRunnerMaya, 1, cUnitTypeVillagerMaya, fValue-1 );
   else if ( scriptVar == NATIVE_BARRACK_SPAWN_QRY )
      BannerArmySpawn( playerid, buildingid, true, get_int(BARRACK_SPAWN_TYPE, playerid), fValue );
   else if ( scriptVar == TEMPLE_BUILD_QRY ) {
      if ( fValue > 0 ) {
         int protoid = cFirstIncaAge2MU + get_int(INCA_AGE2_MYTHUNIT_OFFSET, playerid);
         UnitCreate( playerid, protoid, 1, kbUnitGetPosition(buildingid) );
         fValue--;
      }
   }
   else
      trChatSend( 0, "ERR: Invalid _PerBuildingDone() (Check PerBuilding): Player="+playerid+", Var="+scriptVar );
*/
   return( fValue );
}

void _PostBuildingsDone(int playerid=-1, int scriptVar=-1, int completed=0, float fValue=0.0)
{
/*
   if ( scriptVar == FARM_BUILD_QRY )
      food_grant = food_grant + (fValue * completed);
   else
      trChatSend( 0, "ERR: Invalid _PostBuildingsDone() (Check PerBuilding): Player="+playerid+", Var="+scriptVar );
*/
}

//For building-completion mechanics that expire.
void CleanupBuildingCompletion(int playerid=-1, int scriptVarQid=-1, int theQid=-1)
{
   if ( theQid < 0 )
      theQid = get_int( scriptVarQid, playerid );
   if ( theQid >= 0 ) {
      kbUnitQueryDestroy( theQid );
      subtract_int( scriptVarQid, theQid+1, playerid );
   }
  //Extra switch-case handling can be added here!
}

//Stream line the "building has been built effect" mechanic into 1 function.
//This is somewhat ugly w/o func-pointers/lambdas because the effects/constraints for "building complete" mechanics vary wildly.
//CONCEPT: A very reliable way of implementing "building completed" effects; search for building in its construction state only.
//Loop thru the prev-second's results and check the state. Alive means it just finished rn; apply completion effects. (Dead means
//it died rn.) Reset the query *only if* 1+ alive/dead results found ensures concept works and effects only applied 1x per build.
//This must be called as part of a RuleFunc (1x/sec). Only builds that can complete in <= 1.085 sec can fail to "trip" the system.
//(1.085 secs is the max delay between rules with min/maxInterval of 1. See "get_time_modifier".)
//PRE: MaxBuildings > 0.
//BUILDING BEING QUERIED MUST NOT USE SocketProtoUnit FEATURE! See BuildingCompletionBonusSocket().
//RETURNS: Num buildings completed.
int BuildingCompletionBonus(int playerid=-1, int scriptVarQid=-1, int theQid=-1, bool perBuilding=true, float fValue=0.0, int maxBuildings=999999999)
{
   bool reset = false;  //Pity there's no "kbUnitQueryRemoveResult(qid, index, preserveOrder)"
   int successes = 0;
   if ( theQid < 0 )
      theQid = get_int( scriptVarQid, playerid );
   int results = kbUnitQueryNumberResults( theQid );
   for(i=0; < results) {
      int foundationid = kbUnitQueryGetResult( theQid, i );
      if ( percent_complete(foundationid) >= 100 ) {
         reset = true;
         successes++;
         if ( perBuilding )
            fValue = _PerBuildingDone(playerid, scriptVarQid, foundationid, fValue);
         if ( successes >= maxBuildings )
            break;
      }
      else if ( trUnitDead() )
         reset = true;
   }
   if ( reset )
      kbUnitQueryResetResults( theQid );
   kbUnitQueryExecute( theQid );
   if ( (successes > 0) && (perBuilding == false) )
      _PostBuildingsDone( playerid, scriptVarQid, successes, fValue );
   return( successes );
}

//Exactly like the above func, except only for buildings that use the SocketProtoUnit feature.
int BuildingCompletionBonusSocket(int playerid=-1, int scriptVarQid=-1, int theQid=-1,
   int classOnlyWhenComplete=-1, bool perBuilding=true, float fValue=0.0, int maxBuildings=999999999)
{
   bool reset = false;
   int successes = 0;
   if ( theQid < 0 )
      theQid = get_int( scriptVarQid, playerid );
   int results = kbUnitQueryNumberResults( theQid );
   for(i=0; < results) {
      int foundationid = kbUnitQueryGetResult( theQid, i );
      if ( kbUnitIsType(foundationid, classOnlyWhenComplete) ) {  //Completed!
         reset = true;
         successes++;
         if ( perBuilding )
            fValue = _PerBuildingDone(playerid, scriptVarQid, foundationid, fValue);
         if ( successes >= maxBuildings )
            break;
      }
      else if ( kbUnitGetOwner(foundationid) != playerid )  //Dead.
         reset = true;
   }
   if ( reset )
      kbUnitQueryResetResults( theQid );
   kbUnitQueryExecute( theQid );
   if ( (successes > 0) && (perBuilding == false) )
      _PostBuildingsDone( playerid, scriptVarQid, successes, fValue );
   return( successes );
}

