//Not a stand-alone file!
//Just moved out of the main file because things got too cluttered.

const int TOTAL_CAPTURE_POINTS = cUnitTypeRugs;
const int SHIP_CAPTURE_POINTS = cUnitTypeGarrisonFlag;
const float MAX_SHIP_CAPTURE_POINTS = 400.0;

//===========================================================================================================
void ExecutePrisonerTempleQuery(int templeQid=-1, int prisonerid=-1, bool tlalocanPref=false)
{
   vector location = kbUnitGetPosition( prisonerid );
   kbUnitQuerySetPosition( templeQid, location );
   kbUnitQuerySetAreaGroupID( templeQid, kbAreaGroupGetIDByPosition(location) );
  //If prefer Tlalocan, then only search for Temples iff Tlalocan is not present.
  //If no preference, always search Temples too so that we grab anyone, whichever is closer.
   kbUnitQuerySetUnitType( templeQid, cUnitTypeTlalocan );
   if ( (kbUnitQueryExecute(templeQid) <= 0) || (tlalocanPref == false) ) {
      kbUnitQuerySetUnitType( templeQid, cUnitTypeAbstractTemple );
      if ( kbUnitQueryExecute(templeQid) <= 0 ) {
         kbUnitQuerySetUnitType( templeQid, cUnitTypeSettlementsThatTrainVillagers );
         if ( kbUnitQueryExecute(templeQid) <= 0 )
            return;
      }
   }
   aiTaskUnitWork( prisonerid, kbUnitQueryGetResult(templeQid, 0) );
   kbUnitQueryResetResults( templeQid );
}

void EnterCaptureMode(int playerid=-1)
{
   trTechSetStatus( playerid, cTechGarlandWarActive, cTechStatusActive );
   trTechSetStatus( playerid, cTechGarlandWarShipsActive, cTechStatusActive );
   trForbidProtounit( playerid, "CaptureEnter" );
   trUnforbidProtounit( playerid, "CaptureExit" );
   trChatSend( 0, GetPlayerName(playerid)+" has entered Capture Mode." );
   int headroom = get_int(CAPTURES_BEFORE_COOLDOWN, playerid) - (get_int(CAPTURE_MODE_PRISONERS, playerid) - 100);
   trChatSendToPlayer( 0, playerid, "Captures until cooldown: "+headroom );
}
void ExitCaptureMode(int playerid=-1, bool doCooldown=false)
{
   trTechSetStatus( playerid, cTechGarlandWarActive, cTechStatusUnobtainable );
   trTechSetStatus( playerid, cTechGarlandWarShipsActive, cTechStatusUnobtainable );
   trForbidProtounit( playerid, "CaptureExit" );
   if ( doCooldown == false ) {
      trUnforbidProtounit( playerid, "CaptureEnter" );
      trChatSend( 0, GetPlayerName(playerid)+" has left Capture Mode." );
   }
   else {
      trUnforbidProtounit( playerid, "CaptureWait" );
      trChatSend( 0, GetPlayerName(playerid)+" is in Capture Mode cooldown." );
      add_int( CAPTURE_MODE_COOLDOWN, 2, playerid );
      xsEnableRule( "CaptureCooldown"+playerid );
   }
}

//================================================================================================================
//PRE: gFullPrisonerRetask is false (to avoid expensive double-tasking).
//POST: Same var is true.
void AutoTaskPrisoners(int playerid=-1, int prisonerQid=-1, int templeQid=-1)
{
   gFullPrisonerRetask = true;
   int results = kbUnitQueryExecute( prisonerQid );
   if ( results <= 0 )
      return;
   if ( templeQid < 0 )
      templeQid = get_int( NEARBY_TEMPLES_QRY, playerid );
   bool tlalocanPref = kbProtoUnitAvailable( cUnitTypeTlalocan );
   for(i=0; < results)
      ExecutePrisonerTempleQuery( templeQid, kbUnitQueryGetResult(prisonerQid, i), tlalocanPref );
   kbUnitQueryResetResults( prisonerQid );
}

//=========================================================================================================================
int _capturable0 = -1;
int _capturable1 = -1;
int _capturable2 = -1;
int _num_capturables_set = 0;

void _AddPointsReevalShipsPaused(int playerid=-1, float fShipPoints=0.0, float fAddPoints=0.0, bool shipsPaused=false,
                                 float fTotalShipPoints=-9999.0) {
   if ( fShipPoints != 0.0 ) {
      if ( fTotalShipPoints <= -100.0 )
         fTotalShipPoints = get_float(SHIP_CAPTURE_POINTS) + fShipPoints;
      if ( (fTotalShipPoints >= MAX_SHIP_CAPTURE_POINTS) != shipsPaused )
         trTechSetStatus( playerid, cTechGarlandWarShipsActive, choose(shipsPaused, cTechStatusActive, cTechStatusUnobtainable) );
      add_float( SHIP_CAPTURE_POINTS, fShipPoints );
   }
   add_float( TOTAL_CAPTURE_POINTS, fAddPoints );
}
float _CalcPoints(int qid=-1, int start=0, int endd=0, bool checkTarget=true, int nearbySkullQid=-1)
{
   int counter = 0;
   float fBonus = 0.0;
   if ( checkTarget ) {
      if ( nearbySkullQid >= 0 ) {
         float fSkullModifier = get_float( cUnitTypeSkullTemple );
         for(i=start; < endd) {
            int attackerid = kbUnitQueryGetResult( qid, i );
            int actionid = kbUnitGetAnimationActionType( attackerid );
            if ( (actionid != cActionHandAttack) && (actionid != cActionRangedAttack) )
               continue;
            int targetid = kbUnitGetTargetUnitID( attackerid );
            if ( kbUnitIsType(targetid, cUnitTypeUseableItem) == false )
               continue;
            kbUnitQuerySetPosition( nearbySkullQid, kbUnitGetPosition(attackerid) );
            int nearbySkulls = kbUnitQueryExecute( nearbySkullQid );
            for(i2=0; < nearbySkulls) {
               int skullid = kbUnitQueryGetResult( nearbySkullQid, i2 );
               if ( kbUnitGetAnimationActionType(skullid) != cActionOverrideAnimation ) {
                  trUnitSelectClear();
                  trUnitSelectByID( skullid );
                  trUnitOverrideAnimation( 25, kbGetAge(), false, true, -1, 0 );
               }
            }
            kbUnitQueryResetResults( nearbySkullQid );
            fBonus = fBonus + (1.0 + (fSkullModifier * nearbySkulls));
            if ( _num_capturables_set < 3 ) {
               _num_capturables_set++;
               if ( _capturable0 < 0 )
                  _capturable0 = targetid;
               else if ( _capturable1 < 0 )
                  _capturable1 = targetid;
               else
                  _capturable2 = targetid;
            }
            counter = counter + kbProtoUnitGetPopulationCount(kbUnitGetProtoUnitID(attackerid));
         }
      }
      else for(i=start; < endd) {
         attackerid = kbUnitQueryGetResult( qid, i );
         actionid = kbUnitGetAnimationActionType( attackerid );
         if ( (actionid != cActionHandAttack) && (actionid != cActionRangedAttack) )
            continue;
         targetid = kbUnitGetTargetUnitID( attackerid );
         if ( kbUnitIsType(targetid, cUnitTypeUseableItem) == false )
            continue;
         if ( _num_capturables_set < 3 ) {
            _num_capturables_set++;
            if ( _capturable0 < 0 )
               _capturable0 = targetid;
            else if ( _capturable1 < 0 )
               _capturable1 = targetid;
            else
               _capturable2 = targetid;
         }
         counter = counter + kbProtoUnitGetPopulationCount(kbUnitGetProtoUnitID(attackerid));
      }
   }
   else for(i=start; < endd) {
      attackerid = kbUnitQueryGetResult( qid, i );
      actionid = kbUnitGetAnimationActionType( attackerid );
      if ( (actionid != cActionHandAttack) && (actionid != cActionRangedAttack) )
         continue;
      counter = counter + kbProtoUnitGetPopulationCount(kbUnitGetProtoUnitID(attackerid));
   }
   fBonus = fBonus + counter;
   return( fBonus );
}

void _AddPointsAndDoCaptures(int playerid=-1, float fShipPoints=0.0, float fAddPoints=0.0, bool shipsPaused=true, int nearTemplesQid=-1)
{
   float fTotalShipPoints = 0.0;
   float fCaptureCost = get_float( cUnitTypeTempleKronos );
   float fCurrentPoints = get_float(TOTAL_CAPTURE_POINTS) + fAddPoints;
   if ( fCurrentPoints >= fCaptureCost ) {
      int successes = 0;
      int threshold = get_int( CAPTURES_BEFORE_COOLDOWN, playerid );
      int current = get_int( CAPTURE_MODE_PRISONERS, playerid );
      int allowed = threshold - (current - 100);
      bool tlalocanPref = kbProtoUnitAvailable( cUnitTypeTlalocan );
      float fMaxCaptureCost = get_float( cUnitTypeEarth );
      fTotalShipPoints = get_float(SHIP_CAPTURE_POINTS) + fShipPoints;
      for(i=0; < _num_capturables_set) {
         if ( i == 0 )  int targetid = _capturable0;
         else if ( i == 1 ) targetid = _capturable1;
         else               targetid = _capturable2;

        //Perform the capture, select the right prisoner type.
         int weight = 2;
         int prisonerType = cUnitTypePrisonerBig;
         if ( kbUnitIsType(targetid, cUnitTypeHero) == false ) {
            if ( kbProtoUnitGetPopulationCount(kbUnitGetProtoUnitID(targetid)) < 3 ) {
               weight = 1;
               prisonerType = cUnitTypePrisonerSmall;
            }
         }
         change_proto( targetid, prisonerType );  //MUST TRANSFORM BEFORE CONVERT! Otherwise game may crash!
         trUnitConvert( playerid );
         if ( kbUnitGetOwner(targetid) != playerid )  //Capture failed (unit is too dead).
            continue;
         ExecutePrisonerTempleQuery( nearTemplesQid, targetid, tlalocanPref );

        //Charge for the capture, and adjust the bank-accounts/capture-costs.
         successes = successes + weight;
         fCaptureCost = fCaptureCost * xsPow(CAPTURE_COST_INCR_BASE, weight);
         if ( fCaptureCost > fMaxCaptureCost )
            fCaptureCost = fCaptureCost - CAPTURE_COST_DECREASE;
         if ( fTotalShipPoints > 0.0 ) {
            float fDeduct = xsMin( fTotalShipPoints, fCaptureCost );
            fTotalShipPoints = fTotalShipPoints - fDeduct;  //The var used for internal calcs.
            fShipPoints = fShipPoints - fDeduct;  //The var we add to the stored value.
         }

         fAddPoints = fAddPoints - fCaptureCost;
         fCurrentPoints = fCurrentPoints - fCaptureCost;
         if ( fCurrentPoints < fCaptureCost )
            break;
         if ( successes >= allowed )
            break;
      }  //End: for()

      if ( successes > 0 ) {
         set_float( cUnitTypeTempleKronos, fCaptureCost );
         if ( successes < allowed )
            add_int( CAPTURE_MODE_PRISONERS, successes, playerid );
         else {
            add_int( CAPTURE_MODE_PRISONERS, (current + successes - threshold) - current, playerid );
            ExitCaptureMode( playerid, true );
         }
      }
   }
   _AddPointsReevalShipsPaused( playerid, fShipPoints, fAddPoints, shipsPaused, fTotalShipPoints );
}

void CapturePrisonersFunc(int playerid=-1, int qid=-1, int nearTemplesQid=-1, float fTimeFactor=1.0)
{
   int nearAttackers = 0;
   int myAttackerQid = get_int( ATTACKERS_QRY, playerid );
   kbUnitQuerySetUnitType( myAttackerQid, cUnitTypeHumanSoldier );

  //Human Attackers.
   kbUnitQuerySetUnitType( qid, cUnitTypeSkullTemple );
   int tzompantlis = kbUnitQueryExecute( qid );
   if ( tzompantlis > 0 ) {
      kbUnitQuerySetMaximumDistance( myAttackerQid, SKULL_TEMPLE_RADIUS );
      for(i=0; < tzompantlis) {
         kbUnitQuerySetPosition( myAttackerQid, kbUnitGetPosition(kbUnitQueryGetResult(qid, i)) );
         kbUnitQuerySetActionType( myAttackerQid, cActionHandAttack );
         kbUnitQueryExecute( myAttackerQid );
         kbUnitQuerySetActionType( myAttackerQid, cActionRangedAttack );
         nearAttackers = kbUnitQueryExecute( myAttackerQid );
      }
      kbUnitQuerySetMaximumDistance( myAttackerQid, -1.0 );
   }
   else
      kbUnitQuerySetActionType( myAttackerQid, cActionRangedAttack );
   kbUnitQueryExecute( myAttackerQid );
   kbUnitQuerySetActionType( myAttackerQid, cActionHandAttack );
   int expandedAttackers = kbUnitQueryExecute( myAttackerQid );
   int shipAttackers = expandedAttackers;

  //Ship Attackers.
   bool shipsPaused = (kbGetTechStatus(cTechGarlandWarShipsActive) < cTechStatusActive);
   if ( shipsPaused == false ) {
      kbUnitQuerySetUnitType( myAttackerQid, cUnitTypeShip );
      kbUnitQueryExecute( myAttackerQid );
      kbUnitQuerySetActionType( myAttackerQid, cActionRangedAttack );
      shipAttackers = kbUnitQueryExecute( myAttackerQid );
   }
   if ( shipAttackers <= 0 )  //No point-generating units.
      return;

  //Results [0..nearAttackers) = in range of 1+ Tzompantlis.
  //Results [nearAttackers..expandedAttackers) = no nearby Tzompantli.
  //Results [expandedAttackers..shipsAttackers) = ship attackers.
   _num_capturables_set = 0;
   float fAddPoints = 0.0;
   float fShipPoints = (0.5 * _CalcPoints(myAttackerQid, expandedAttackers, shipAttackers, false));
   if ( nearAttackers > 0 )
      fAddPoints = _CalcPoints(myAttackerQid, 0, nearAttackers, true, get_int(NEAR_SKULLS_QRY, playerid));
   fAddPoints = fAddPoints + _CalcPoints(myAttackerQid, nearAttackers, expandedAttackers, true);
   fAddPoints = fAddPoints + fShipPoints;
   fAddPoints = fAddPoints * fTimeFactor;
   fShipPoints = fShipPoints * fTimeFactor;
   kbUnitQueryResetResults( myAttackerQid );
   if ( _num_capturables_set > 0 )
      _AddPointsAndDoCaptures( playerid, fShipPoints, fAddPoints, shipsPaused, nearTemplesQid );
   else
      _AddPointsReevalShipsPaused( playerid, fShipPoints, fAddPoints, shipsPaused );
}

//===========================================================================================================
void CaptureRechargeFunc(int playerid=-1) {
   add_int( CAPTURE_MODE_COOLDOWN, -1, playerid );
   if ( get_int(CAPTURE_MODE_COOLDOWN, playerid) <= 0 ) {
      xsDisableRule( "CaptureCooldown"+playerid );
      trChatSendToPlayer( 0, playerid, "Your Capture Mode cooldown period has expired." );
      trForbidProtounit( playerid, "CaptureWait" );
      trUnforbidProtounit( playerid, "CaptureEnter" );
   }
}
rule CaptureCooldown1  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(1); }
rule CaptureCooldown2  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(2); }
rule CaptureCooldown3  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(3); }
rule CaptureCooldown4  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(4); }
rule CaptureCooldown5  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(5); }
rule CaptureCooldown6  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(6); }
rule CaptureCooldown7  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(7); }
rule CaptureCooldown8  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(8); }
rule CaptureCooldown9  minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(9); }
rule CaptureCooldown10 minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(10); }
rule CaptureCooldown11 minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(11); }
rule CaptureCooldown12 minInterval 90 maxInterval 90 runImmediately inactive priority 100 { CaptureRechargeFunc(12); }
