//This is NOT a stand-alone file! Specify rotg_script as the file to include.

//========================================================================================================================================
// REQUIREMENTS FOR NATIVE CIVS:
// Embassy Name = "Embassy<Native>" all embassies consecutive in proto.
// Socket Name = "Socket<Native>" all sockets consecutive in proto.
// Tech Name = "Native<Native>" all native-techs consecutive in techtree.
// EACH Native Warrior:
//  - Has InventoryHolder unittype.
//  - Name starts with first 3 letters of native name. (Ie natives = "Zapotec", unit = "ZapClubman")
// MAX 5 Warriors per native civ.
// All "Embassy<Native>" and "Socket<Native>" have StrengthBonus unittype.
// All Embassies also have BuildingClass unittype, all Sockets do not.

//Every X Tarascan Heroes ("Cazonci") who dies will become a Solar Eagle once tech is active.
const int TAR_EAGLE_REWARD_AMOUNT = 2;  //Sync with tech descr.
const int cUnitTypeAbstractSocketOrEmbassy = cUnitTypeStrengthBonus;

const float SOCKET_AUTO_CONVERT_DISTANCE = 14.5;

int _NumNativeSitesPresent = -1;
bool NativeCodeRequired(void) {
   return( _NumNativeSitesPresent > 0 );
}
int firstnativetech_ = -1;
int lastnativetech_ = -2;
int firstpost_ = -1;
int lastpost_ = -2;
int _ClaimedSitesQid = -1;

//===========================================================================================================
void _NativePowerCastSuccessChat(int playerid=-1, string sPowerText="")
{
   trChatSendToPlayer( 0, playerid, "You have cast the "+sPowerText+" native power." );
   sPowerText = GetPlayerName(playerid)+" has cast the "+sPowerText+" native power.";
   for(otherid=1; < cNumberPlayers) {
      if ( otherid != playerid )
         trChatSendSpoofedToPlayer( playerid, otherid, sPowerText );
   }
}
bool _NativePowerLOSCheck(int unitid=-1, int playerid=-1, string sPowerName="", bool successText=true)
{
   trUnitSelectClear();
   trUnitSelectByID( unitid );
   bool CanSee = trUnitHasLOS( playerid );
   if ( CanSee ) {
      adjust_buildlimit( playerid, kbUnitGetProtoUnitID(unitid), -1, 0 );
      if ( successText )
         _NativePowerCastSuccessChat( playerid, sPowerName );
   }
   else {
      trChatSendToPlayer( 0, playerid, sPowerName+" requires line-of-sight to cast." );
      trUnitChangeProtoUnit( "Sling Stone" );
   }
   return( CanSee );
}

//==========================================================================================================
string tech_to_embassy(int nativetech=-1) {
   return( "Embassy" + xsSubString(kbGetTechName(nativetech), 100000, 6) );
}
string tech_to_socket(int nativetech=-1) {
   return( "Socket"+xsSubString(kbGetTechName(nativetech), 100000, 6) );
}
string socket_to_embassy(int socketType=-1) {
   return( "Embassy"+xsSubString(kbGetProtoUnitName(socketType), 100000, 6) );
}
string embassy_to_socket(int embassy=-1) {
   return( "Socket"+xsSubString(kbGetProtoUnitName(embassy), 100000, 7) );
}
int embassy_to_tech(int embassy=-1, int hiddenSubstrParam=7) {  //Oops! Ignore 2nd param.
   int retval = -1;
   string NativeName = "Native" + xsSubString(kbGetProtoUnitName(embassy), 100000, hiddenSubstrParam);
   for(techid=firstnativetech_; <= lastnativetech_) {
      if ( kbGetTechName(techid) == NativeName ) {
         retval = techid;
         break;
      }
   }
   return( retval );
}
int socket_to_tech(int socketType=-1) {
   return( embassy_to_tech(socketType, 6) );
}

//======================================================================================================================
void _protoEnable(int playerid=-1, int protoUnit=-1, bool ageReqMet=true, bool enabler=false) {
   if ( ageReqMet )
      if ( enabler ) trUnforbidProtounit(playerid, kbGetProtoUnitName(protoUnit));
      else           trForbidProtounit(playerid, kbGetProtoUnitName(protoUnit));
}
void _techStat(int playerid=-1, int techid=-1, bool enabler=true) {
   if ( kbGetTechStatus(techid) <= cTechStatusAvailable )
      trTechSetStatus( playerid, techid, choose(enabler, cTechStatusAvailable, cTechStatusUnobtainable) );
}
void _NativeAgeUpOrAllianceToggler(int playerid=-1, int nativeTech=-1, bool enabler=true, int ageid=-1)
{
   int prev = xsGetContextPlayer();
   xsSetContextPlayer( playerid );
   if ( ageid < 0 ) {
      ageid = kbGetAge();
      trTechSetStatus( playerid, nativeTech, choose(enabler, cTechStatusActive, cTechStatusUnobtainable) );
   }
  //CHICHIMECS.
   if ( nativeTech == cTechNativeChichimecs ) {
      _protoEnable( playerid, cUnitTypeChiArcher, (ageid >= cAge2), enabler );
      _protoEnable( playerid, cUnitTypeChiShaman, (ageid >= cAge2), enabler );
      _protoEnable( playerid, cUnitTypeChiSacredDeer, (ageid >= cAge3), enabler );
      for(protoid=cUnitTypeChiWolf; <= cUnitTypeChiBear)
         _protoEnable( playerid, protoid, (ageid >= (protoid-cUnitTypeChiEagle)), enabler );
      _techStat( playerid, cTechMediumChichi, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechChiSacredHunt, enabler );  //Age1
      _techStat( playerid, cTechChiBracer, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechChiWarDance, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechChiWoodcrafting, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechChiVotiveArrows, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechChiPeyote, (ageid >= cAge3) && enabler );
   }
  //TOLTECS.
   else if ( nativeTech == cTechNativeToltecs ) {
      _techStat( playerid, cTechMediumToltec, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTolChacMool, enabler );  //Age1
      _techStat( playerid, cTechTolCoatepantli, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTolToltecayotl, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTolWarSociety, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechTolPalaceOf, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechTolTempleOf, (ageid >= cAge4) && enabler );
   }
  //ZAPOTECS.
   else if ( nativeTech == cTechNativeZapotec ) {
      _techStat( playerid, cTechMediumZapotec, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechZapFestival, enabler );  //Age1
      _techStat( playerid, cTechZapScriptures, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechZapSacredCrops, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechZapCultOfTheDead, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechZapCloudPeople, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechZapTombsOfDaniBaan, (ageid >= cAge4) && enabler );
   }
  //HUASTEC.
   else if ( nativeTech == cTechNativeHuastec ) {
      if ( get_int(HUASTEC_TREE_TYPE, playerid) < 0 )
         for(techid=cTechResourceTreeGold; <= cTechResourceTreeFood)
            trTechSetStatus( playerid, techid, cTechStatusAvailable );
      _techStat( playerid, cTechMediumHuastec, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechHuaBodyModify, enabler );  //Age1
      _techStat( playerid, cTechHuaCottonPlanting, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechHuaPottery, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechHuaIxcuynimsGift, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechHuaFertilityFestival, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechHuaWarCry, (ageid >= cAge4) && enabler );
   }
  //TLAXCALTECS.
   else if ( nativeTech == cTechNativeTlaxcaltecs ) {
      _techStat( playerid, cTechMediumTlax, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTlaHuntingTrickle, enabler );  //Age1
      _techStat( playerid, cTechTlaRepublicOfMaize, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTlaDispersal, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTlaNorthernStars, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechTlaSenate, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechTlaSpanishAllies, (ageid >= cAge4) && enabler );
   }
  //TARASCANS.
   else if ( nativeTech == cTechNativeTarascans ) {
      _techStat( playerid, cTechMediumTarascan, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTarGillnets, enabler );  //Age1
      _techStat( playerid, cTechTarDanceOfOldGod, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTarBronzeWorking, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechTarXaratangaBlessing, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechTarBallgame, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechTarSacredEagle, (ageid >= cAge4) && enabler );
   }
  //MIXTECS.
   else if ( nativeTech == cTechNativeMixtecs ) {
      _techStat( playerid, cTechMediumMix, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechMixPainters, enabler );  //Age1
      _techStat( playerid, cTechMixSerpentCult, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechMixDzahuiPeople, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechMixGoldsmith, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechMixSlingerUpgrade, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechMixSunBow, (ageid >= cAge4) && enabler );
   }
  //NAHUA.
   else if ( nativeTech == cTechNativeNahua ) {
      _techStat( playerid, cTechMediumNahua, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechNahJagKnights1, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechNahLoom, enabler );  //Age1
      _techStat( playerid, cTechNahChinampas, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechNahMigration, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechNahAltepemeh, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechNahHarvest, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechNahCalendar, (ageid >= cAge4) && enabler );
   }
  //OTOMI.
   else if ( nativeTech == cTechNativeOtomi ) {
      _techStat( playerid, cTechMediumOtomi, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechOtoLumberjacks, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechOtoArson, (ageid >= cAge2) && enabler );
      _techStat( playerid, cTechOtoMercenaries, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechOtoAncientInhabit, (ageid >= cAge3) && enabler );
      _techStat( playerid, cTechOtoPaperFigures, (ageid >= cAge4) && enabler );
      _techStat( playerid, cTechOtoSiegeFestival, (ageid >= cAge4) && enabler );
   }
   xsSetContextPlayer( prev );
}

//PRE: Context player already set to Playerid.
void NativeAgeUpHandler(int playerid=-1, int ageid=-1) {
   for(nativeTech=firstnativetech_; <= lastnativetech_) {
      if ( kbGetTechStatus(nativeTech) >= cTechStatusActive )
         _NativeAgeUpOrAllianceToggler( playerid, nativeTech, true, ageid );
   }
}

//===========================================================================================================
void ExtMechChichimecVisionPower(int tokenid=-1)
{
   int ownerid = kbUnitGetOwner( tokenid );
   _NativePowerCastSuccessChat( ownerid, "Ancestral Vision" );
   adjust_buildlimit( ownerid, cUnitTypeChichiGPToken, -1, 0 );
   RevealLOS( ownerid, RELATION_ANY, cUnitTypeHuntable, cUnitTypeHerdable, cUnitTypeTree );
   change_proto( tokenid, cUnitTypeOsirisBoxGlow );

   add_int( CHICHIMEC_VISION_CASTS, 1, ownerid );
   if ( get_int(CHICHIMEC_VISION_CASTS, ownerid) < 2 ) {
      add_int( CHICHIMEC_VISION_RECHARGE, 2, ownerid );
      xsEnableRule( "ChiPowerRecharge"+ownerid );
   }
}

void ExtMechNahuaCursePower(int tokenid=-1, int nearestQid=-1)
{
   int ownerid = kbUnitGetOwner( tokenid );
   if ( _NativePowerLOSCheck(tokenid, ownerid, "Sun of Rain", false) == false )
      return;
   int maxTurkeys = (kbGetAgeForPlayer(ownerid)+1) * 2;  //2 Turkeys per age.
   kbUnitQuerySetPlayerRelation( nearestQid, -1 );
   kbUnitQuerySetUnitType( nearestQid, cUnitTypeHumanSoldier );
   kbUnitQuerySetPosition( nearestQid, kbUnitGetPosition(tokenid) );
   kbUnitQuerySetMaximumDistance( nearestQid, 7.8 );
   int results = PlayerLoopQuery( nearestQid, ownerid, cPlayerRelationEnemy, maxTurkeys );
   if ( results > 0 ) {
      _NativePowerCastSuccessChat( ownerid, "Sun of Rain" );
      adjust_buildlimit( ownerid, cUnitTypeNahuaGPToken, -1, 0 );
      change_proto( tokenid, cUnitTypeOsirisBoxGlow );
      results = xsMin( results, maxTurkeys );
      for(i=0; < results)
         change_proto( kbUnitQueryGetResult(nearestQid, i), cUnitTypeTurkey );
      kbUnitQueryResetResults( nearestQid );
   }
   else {
      trChatSendToPlayer( 0, ownerid, "Sun of Rain can only be cast on enemy human units." );
      destroy( tokenid );
   }
   reset_nearest_extmech_qid( nearestQid );
}

void ExtMechStoneAncestorsPower(int tokenid=-1, int nearestQid=-1)
{
   int ownerid = kbUnitGetOwner( tokenid );
   if ( _NativePowerLOSCheck(tokenid, ownerid, "Stone Ancestors", false) == false )
      return;
   int buildingid = -1;
   bool spawnUnits = false;
   kbUnitQuerySetPlayerRelation( nearestQid, -1 );
   kbUnitQuerySetUnitType( nearestQid, cUnitTypeLogicalTypeBuildingsNotWalls );
   kbUnitQuerySetPosition( nearestQid, kbUnitGetPosition(tokenid) );
   kbUnitQuerySetMaximumDistance( nearestQid, 5.0 );
   int number = PlayerLoopQuery( nearestQid, ownerid, cPlayerRelationEnemy, 1 );
   if ( number > 0 ) {
      buildingid = kbUnitQueryGetResult( nearestQid, 0 );
      kbUnitQueryResetResults( nearestQid );
      vector position = kbUnitGetPosition(buildingid) + vector(1,0,1);  //Offset from center a bit.
      if ( get_int(STONE_POWER_DELAY, ownerid) > 0 ) {
         add_int( STONE_POWER_DELAY, -1, ownerid );
         adjust_buildlimit( ownerid, cUnitTypeOtomiGPToken, -1, 0 );
         _NativePowerCastSuccessChat( ownerid, "Stone Ancestors" );
         damage_unit( buildingid,
            choose(kbUnitIsType(buildingid, cUnitTypeAbstractSettlement) || kbUnitIsType(buildingid, cUnitTypeAbstractFortress) ||
                   kbUnitIsType(buildingid, cUnitTypeLogicalTypeValidReverseWonderTarget) || (kbUnitGetProtoUnitID(buildingid) == cUnitTypeTitanGate),
            400.0, 9.9e12) );
      }
      else
         spawnUnits = true;
   }
   else if ( get_int(STONE_POWER_DELAY, ownerid) <= 0 )
      spawnUnits = true;
   else {
      trChatSendToPlayer( 0, ownerid, "Stone Ancestors can only be cast over an enemy non-wall building." );
      destroy( tokenid );
   }
   if ( spawnUnits ) {
      add_int( STONE_POWER_DELAY, 1, ownerid );
      number = choose( kbGetAgeForPlayer(ownerid) >= cAge4, 2, 1 );
      if ( buildingid < 0 )
         position = kbUnitGetPosition( tokenid );
      UnitCreate( ownerid, cUnitTypeOtoWema, number, position, trTimeMS() );
      change_proto( tokenid, cUnitTypeOsirisBoxGlow );
   }
   reset_nearest_extmech_qid( nearestQid );
}

void ExtMechCamaxtliPowerCast(int tokenid=-1, int nearestQid=-1)
{
   int ownerid = kbUnitGetOwner( tokenid );
   kbUnitQuerySetPlayerID( nearestQid, ownerid, false );
   kbUnitQuerySetPlayerRelation( nearestQid, -1 );
   kbUnitQuerySetPosition( nearestQid, kbUnitGetPosition(tokenid) );
   kbUnitQuerySetMaximumDistance( nearestQid, 1.2 );
   int unitid = find_unit( nearestQid, cUnitTypeTlaxCaptain );
   if ( unitid >= 0 ) {
      adjust_buildlimit( ownerid, cUnitTypeTlaxGPToken, -1, 0 );
      _NativePowerCastSuccessChat( ownerid, "Camaxtli's Incarnation" );
      change_proto( tokenid, cUnitTypeOsirisBoxGlow );
      change_proto( unitid, cUnitTypeTlaxBigHeroRanged );
   }
   else {
      trChatSendToPlayer( 0, ownerid, "Camaxtli's Incarnation must be cast on one of your Tlaxcaltec Captains." );
      destroy( tokenid );
   }
   reset_nearest_extmech_qid( nearestQid );
}

void ExtMechDzahuisRagePower(int tokenid=-1, int nearestQid=-1)
{
   const int BERRIES_TO_KILL = 5;  //Max num that will be removed.
   int ownerid = kbUnitGetOwner( tokenid );
   if ( _NativePowerLOSCheck(tokenid, ownerid, "Dzahui's Rage") == false )
      return;
   trUnitChangeProtoUnit( "MixGPDamager" );
   kbUnitQuerySetPlayerRelation( nearestQid, cPlayerRelationAny );
   kbUnitQuerySetUnitType( nearestQid, cUnitTypeBuilding );
   kbUnitQuerySetPosition( nearestQid, kbUnitGetPosition(tokenid) );
   kbUnitQuerySetMaximumDistance( nearestQid, 8.0 );
   int ignore = kbUnitQueryExecute( nearestQid );  //Exclude buildings (ie, the native gatherable tree).
   kbUnitQuerySetUnitType( nearestQid, cUnitTypeWildCrops );
   int number = xsMin( kbUnitQueryExecute(nearestQid), (ignore + BERRIES_TO_KILL) );
   destroy_results( nearestQid, ignore, number );
   kbUnitQueryResetResults( nearestQid );
   reset_nearest_extmech_qid( nearestQid );
}

void ExtMechToltecSerpentPower(int tokenid=-1)
{
   int ownerid = kbUnitGetOwner( tokenid );
   if ( _NativePowerLOSCheck(tokenid, ownerid, "Feathered Serpent") ) {
      trUnitChangeProtoUnit( "TolBigSerpent" );
      UnitCreate( ownerid, cUnitTypeOsirisBoxGlow, 1, kbUnitGetPosition(tokenid) );
   }
}

void ExtMechTarascanHeartPower(int tokenid=-1)
{
   int ownerid = kbUnitGetOwner( tokenid );
   if ( _NativePowerLOSCheck(tokenid, ownerid, "Heart of Curicaueri") ) {
      UnitCreate( 0, cUnitTypeOsirisBoxGlow, 1, kbUnitGetPosition(tokenid) );
      trUnitChangeProtoUnit( "TarHealingRelic" );
   }
}
void ExtMechTarascanHeroDeath(int tokenid=-1)
{
   bool doEagle = false;
   int ownerid = kbUnitGetOwner( tokenid );
   if ( trTechStatusActive(ownerid, cTechTarSacredEagle) ) {
      if ( get_int(SACRED_EAGLE_TRACKER, ownerid) < TAR_EAGLE_REWARD_AMOUNT )
         add_int( SACRED_EAGLE_TRACKER, 1, ownerid );
      else if ( kbUnitCount(ownerid, cUnitTypeTarEagle, cUnitStateAlive) < kbGetBuildLimit(ownerid, cUnitTypeTarEagle) )
         doEagle = true;
   }
   if ( doEagle ) {
      UnitCreate( ownerid, cUnitTypeTarEagle, 1, kbUnitGetPosition(tokenid) );
      subtract_int( SACRED_EAGLE_TRACKER, TAR_EAGLE_REWARD_AMOUNT, ownerid );
   }
   change_proto( tokenid, cUnitTypeHeroDeath );
}
void ExtMechHuastecPowerCast(int tokenid=-1)
{
   int ownerid = kbUnitGetOwner( tokenid );
   if ( _NativePowerLOSCheck(tokenid, ownerid, "Tamoanchan Tree") ) {
      UnitCreate( 0, cUnitTypeOsirisBoxGlow, 1, kbUnitGetPosition(tokenid) );
      int protoid = get_int( HUASTEC_TREE_TYPE, ownerid );
      if ( (protoid < cUnitTypeHuaTreeGold) || (protoid > cUnitTypeHuaTreeFood) )
         protoid = cUnitTypeHuaResourceTree;
      change_proto( tokenid, protoid );
   }
}

//================================================================================================================
void NatHuastecFestivalHandler(int playerid=-1)
{
   int farmValue = kbUnitCount(playerid, cUnitTypeAbstractFarm, cUnitStateAlive) +
                   (kbUnitCount(playerid, cUnitTypeFarmBig, cUnitStateAlive) * 8) +
                   (kbUnitCount(playerid, cUnitTypeCottonFarmBig, cUnitStateAlive) * 8);
   if ( get_my_culture() == cCultureAtlantean )
      farmValue = farmValue * 3;
   favor_grant = favor_grant + farmValue;
   int otherReward = farmValue * 10;
   food_grant = food_grant + otherReward;
   wood_grant = wood_grant + otherReward;
   gold_grant = gold_grant + otherReward;
   trChatSendSpoofedToPlayer( playerid, playerid, "Your Huastec fertility festival has granted you "+otherReward+" Food, Wood, Gold, and "+farmValue+" Favor." );
}

void NatZapotecFestivalHandler(int playerid=-1)
{
//get_int(ZAPOTEC_FESTIVAL_REWARD, playerid)
   int ageid = kbGetAge();
   if (ageid == cAge1)  int reward = 200;
   else if (ageid == cAge2) reward = 400;
   else if (ageid == cAge3) reward = 600;
   else                     reward = 1000;

   int remaining = reward;
   int food = RNG_Slow( remaining );
   int wood = 0;
   remaining = remaining - food;
   if ( remaining > 0 ) {
      wood = RNG_Slow( remaining );
      remaining = remaining - wood;
   }
   int gold = remaining;
   string sText = " festival has granted you: ";
   if ( food > 0 )
      sText = sText + (food+" Food");
   if ( wood > 0 ) {
      if ( food > 0 )
         sText = sText + ", ";
      sText = sText + (wood+" Wood");
   }
   if ( gold > 0 ) {
      if ( (food+wood) > 0 )
         sText = sText + ", ";
      sText = sText + (gold+" Gold");
   }
   sText = sText + "!";

   trChatSendToPlayer( 0, playerid, "Your"+sText );
   for(otherid=1; < cNumberPlayers) {
      if ( kbIsPlayerMutualAlly(otherid) == false )
         continue;
      if ( get_culture(otherid) == cTechAge1Inca )
         trModifyProtounit( kbGetProtoUnitName(MITA_ACCUMULATOR), otherid, cModifySpeed, reward );
      if ( otherid != playerid )
         trChatSendSpoofedToPlayer( playerid, otherid, GetPlayerName(playerid)+"'s"+sText );
      trPlayerGrantResources( otherid, "Food", food );
      trPlayerGrantResources( otherid, "Wood", wood );
      trPlayerGrantResources( otherid, "Gold", gold );
   }
}

void NatZapotecTombsOfDaniBaan(int playerid=-1, int basicQid=-1)
{
   trChatSend( 0, "Player="+playerid+" TombsOfDaniBaan research." );
}

//=====================================================================================================================
const int ChichiAnimalInfo = cUnitTypeLightningCloud;
void ChichimecNatives(int playerid=-1, int basicQid=-1, int qid=-1, float fTimeFactor=1.0)
{
  //Each new Elder Deer trained lowers the buildlimit (until post is destroyed/rebuilt).
   int number = get_int( NUM_SACRED_DEER, playerid );
   int difference = kbUnitCount(playerid, cUnitTypeChiSacredDeer, cUnitStateAlive) - number;
   if ( difference != 0 ) {
      add_int( NUM_SACRED_DEER, difference, playerid );
      if ( difference > 0 )
         adjust_buildlimit( playerid, cUnitTypeChiSacredDeer, negate(difference), 0 );
   }

  //Chichimec Archers regen faster in combat w/ tech.
   if ( kbGetTechStatus(cTechChiPeyote) >= cTechStatusActive ) {
      kbUnitQuerySetActionType( qid, cActionRangedAttack );
      kbUnitQuerySetUnitType( qid, cUnitTypeChiArcher );
      kbUnitQueryExecute( qid );
      kbUnitQuerySetActionType( qid, cActionHandAttack );
      kbUnitQuerySetUnitType( qid, cUnitTypeChiShaman );
      damage_results( qid, -1, (fTimeFactor * -0.5) );
   }

   int index = 0;
   int result0 = -1;
   int result1 = -1;
   int result2 = -1;
   int result3 = -1;
   int result4 = -1;
   int result5 = -1;
   int result6 = -1;
   int result7 = -1;
   int result8 = -1;
   int result9 = -1;
   int result10 = -1;
   int result11 = -1;
   float timer0 = 0.0;
   float timer1 = 0.0;
   float timer2 = 0.0;
   float timer3 = 0.0;
   float timer4 = 0.0;
   float timer5 = 0.0;
   float timer6 = 0.0;
   float timer7 = 0.0;
   float timer8 = 0.0;
   float timer9 = 0.0;
   float timer10 = 0.0;
   float timer11 = 0.0;

   int addToShamanLimit = 0;
   int animalQid = get_int( CHICHIMEC_ANIMALS_QRY, playerid );
   int loopCount = xsMin( kbUnitQueryNumberResults(animalQid), 12 );
   for(i=0; < loopCount) {
      int animalid = kbUnitQueryGetResult( animalQid, i );
      if ( kbUnitGetCurrentHitpoints(animalid) <= 0.0 ) {
         addToShamanLimit++;
         continue;
      }

      subtract_float( ChichiAnimalInfo+i, fTimeFactor );
      float fTimer = get_float( ChichiAnimalInfo+i );
      if ( fTimer <= 0.0 ) {
         addToShamanLimit++;
         change_proto( animalid, cUnitTypeChiShaman );
         continue;
      }

      switch( index ) {
      case 0:  { result0 = animalid; timer0 = fTimer; break; }
      case 1:  { result1 = animalid; timer1 = fTimer; break; }
      case 2:  { result2 = animalid; timer2 = fTimer; break; }
      case 3:  { result3 = animalid; timer3 = fTimer; break; }
      case 4:  { result4 = animalid; timer4 = fTimer; break; }
      case 5:  { result5 = animalid; timer5 = fTimer; break; }
      case 6:  { result6 = animalid; timer6 = fTimer; break; }
      case 7:  { result7 = animalid; timer7 = fTimer; break; }
      case 8:  { result8 = animalid; timer8 = fTimer; break; }
      case 9:  { result9 = animalid; timer9 = fTimer; break; }
      case 10: { result10 = animalid; timer10 = fTimer; break; }
      default: { result11 = animalid; timer11 = fTimer; break; } }
      index++;
   }
   if ( addToShamanLimit > 0 ) {
      kbUnitQueryResetResults( animalQid );
      kbUnitQuerySetMaximumDistance( animalQid, 0.1 );
      for(i=0; < index) {
         switch( i ) {
         case 0:  { animalid = result0; fTimer = timer0; break; }
         case 1:  { animalid = result1; fTimer = timer1; break; }
         case 2:  { animalid = result2; fTimer = timer2; break; }
         case 3:  { animalid = result3; fTimer = timer3; break; }
         case 4:  { animalid = result4; fTimer = timer4; break; }
         case 5:  { animalid = result5; fTimer = timer5; break; }
         case 6:  { animalid = result6; fTimer = timer6; break; }
         case 7:  { animalid = result7; fTimer = timer7; break; }
         case 8:  { animalid = result8; fTimer = timer8; break; }
         case 9:  { animalid = result9; fTimer = timer9; break; }
         case 10: { animalid = result10; fTimer = timer10; break; }
         default: { animalid = result11; fTimer = timer11; break; } }
         kbUnitQuerySetUnitType( animalQid, kbUnitGetProtoUnitID(animalid) );
         kbUnitQuerySetPosition( animalQid, kbUnitGetPosition(animalid) );
         kbUnitQueryExecute( animalQid );
         set_float( ChichiAnimalInfo+i, fTimer );
      }
      kbUnitQuerySetMaximumDistance( animalQid, -1.0 );
      kbUnitQuerySetPosition( animalQid, cInvalidVector );
      loopCount = xsMin( kbUnitQueryNumberResults(animalQid), 12 );
   }

   int newResults = MultiUnitTypeQuery( animalQid, cUnitTypeChiEagle, cUnitTypeChiWolf, cUnitTypeChiJaguar, cUnitTypeChiBear );
   newResults = xsMin( newResults, 12 );
   for(i=loopCount; < newResults)
      add_float( ChichiAnimalInfo+i, 45.0 );

   addToShamanLimit = addToShamanLimit - (newResults - loopCount);
   if ( addToShamanLimit != 0 )
      adjust_buildlimit( playerid, cUnitTypeChiShaman, addToShamanLimit, 0, 12 );
}

//====================================================================================================================
void NahuaNatives(int playerid=-1, int basicQid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
  //Fighting units near the Native Tlatoani generate favor.
   kbUnitQuerySetUnitType( basicQid, cUnitTypeNahTlatoani );
   int results = kbUnitQueryExecute( basicQid );
   if ( results <= 0 )
      return;
   int numUnits = 0;
   kbUnitQuerySetUnitType( nativeQid, cUnitTypeUnit );
   kbUnitQuerySetMaximumDistance( nativeQid, 12.0 );
   for(i=0; < results) {
      int resultid = kbUnitQueryGetResult( basicQid, i );
      if ( kbUnitGetActionType(resultid) == cActionHandAttack )
         numUnits--;
      kbUnitQuerySetPosition( nativeQid, kbUnitGetPosition(resultid) );
      kbUnitQuerySetActionType( nativeQid, cActionRangedAttack );
      kbUnitQueryExecute( nativeQid );
      kbUnitQuerySetActionType( nativeQid, cActionHandAttack );
      numUnits = numUnits + kbUnitQueryExecute(nativeQid);
      kbUnitQueryResetResults( nativeQid );
   }
   kbUnitQueryResetResults( basicQid );
   kbUnitQuerySetMaximumDistance( nativeQid, -1.0 );
   kbUnitQuerySetPosition( nativeQid, cInvalidVector );
   if ( numUnits > 0 )
      favor_grant = favor_grant + (fTimeFactor * get_float(cUnitTypeEmbassyNahua) * numUnits);
}

//=================================================================================================================
void TlaxcaltecNatives(int playerid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
/*
  //Food trickle for hunters/shepherds/foragers w/ the tech.
   float fRate = kbProtoUnitGetTrainPoints( cUnitTypeArrow );
   if ( fRate > 0.0 ) {
      int number = 0;
      kbUnitQuerySetUnitType( nativeQid, cUnitTypeAbstractVillager );
      kbUnitQuerySetActionType( nativeQid, cActionGather );
      int results0 = kbUnitQueryExecute( nativeQid );
      kbUnitQuerySetActionType( nativeQid, cActionHunting );
      int results1 = kbUnitQueryExecute( nativeQid );
      for(i=0; < results1) {
         int resultid = kbUnitQueryGetResult( nativeQid );
         int targetid = kbUnitGetTargetUnitID( resultid );
         if ( i < results0 ) {  //Gather section.
            if ( kbUnitIsType(targetid, cUnitTypeWildCrops) == false )
               continue;
            number = number + kbProtoUnitGetPopulationCount(kbUnitGetProtoUnitID(resultid));
         }
         else if ( kbUnitIsType(targetid, cUnitTypeHuntable) == false ) {  //Hunting section.
            if ( kbUnitIsType(targetid, cUnitTypeHerdable) == false )
               continue;
            number = number + kbProtoUnitGetPopulationCount(kbUnitGetProtoUnitID(resultid));
         }
      }
      kbUnitQueryResetResults( nativeQid );
      food_grant = food_grant + (fTimeFactor * fRate * number);
   }

  //Infantry resist Myth Unit damage.
   fRate = get_float( cUnitTypeShrine );
   if ( fRate > 0.0 ) {
      fRate = fRate * fTimeFactor;
      kbUnitQuerySetUnitType( nativeQid, cUnitTypeAbstractInfantry );
      results0 = kbUnitQueryExecute( nativeQid );
      for(i=0; < results0) {
         resultid = kbUnitQueryGetResult( nativeQid );
         int kbworkers = kbUnitGetNumberWorkers( resultid );
         int attackers = 0;
         for(i2=0; < kbworkers) {
            int workerid = kbUnitGetWorkerID( resultid );
            if ( kbUnitIsType(workerid, cUnitTypeMythUnit) == false )
               continue;
            int actionid = kbUnitGetAnimationActionType( workerid );
            if ( (actionid == cActionHandAttack) || (actionid == cActionRangedAttack) )
               attackers++;
         }
         if ( attackers > 0 )
            damage_unit( resultid, (fRate * attackers) );
      }
      kbUnitQueryResetResults( nativeQid );
   }
*/
}

//=================================================================================================================
void OtomiNatives(int playerid=-1, int basicQid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
  //Hero unit regens faster when fighting.
   kbUnitQuerySetUnitType( nativeQid, cUnitTypeOtoHero );
   kbUnitQuerySetActionType( nativeQid, cActionHandAttack );
   kbUnitQueryExecute( nativeQid );
   kbUnitQuerySetUnitType( nativeQid, cUnitTypeOtoPriest );
   kbUnitQuerySetActionType( nativeQid, cActionIdle );
   damage_results( nativeQid, -1, (fTimeFactor * -0.5) );

  //Badi ritual hinders building production.
   kbUnitQuerySetUnitType( nativeQid, cUnitTypeOtoPriest );
   kbUnitQuerySetActionType( nativeQid, cActionHandAttack );
   int results = kbUnitQueryExecute( nativeQid );
   for(i=0; < results) {
      int resultid = kbUnitQueryGetResult( nativeQid, i );
      int targetid = kbUnitGetTargetUnitID( resultid );
      xsSetContextPlayer( kbUnitGetOwner(targetid) );
      bool empowered = false;
      int kbworkers = kbUnitGetNumberWorkers( targetid );
      for(i2=0; < kbworkers) {
         if ( kbUnitGetAnimationActionType(kbUnitGetWorkerID(targetid, i2)) != cActionEmpower )
            continue;
         empowered = true;
         break;
      }
      xsSetContextPlayer( playerid );
      if ( empowered == false ) {
         trainCancelByButtonIndex( 0, targetid, kbUnitGetOwner(targetid) );
//         UnitCreate( 0, cUnitTypePestilenceSFX1, 1, kbUnitGetPosition(targetid) );
      }
   }
   kbUnitQueryResetResults( nativeQid );
}

void ToltecNatives(int playerid=-1, int basicQid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
}

void ZapotecNatives(int playerid=-1, int basicQid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
  //Farming generates Favor.
   float fRate = get_float( cUnitTypeGranary );
   if ( fRate > 0.0 )
      favor_grant = favor_grant + (fTimeFactor * fRate * GetFarmingVillPop());

  //MythUnits regenerate (could be done with pure techtree/proto, but this is much easier).
   fRate = get_float( cUnitTypeSocketZapotec );
   if ( fRate < 0.0 ) {
      kbUnitQuerySetUnitType( basicQid, cUnitTypeMythUnit );
      damage_results( basicQid, -1, (fTimeFactor * fRate) );
   }
/*
   float fCurrent = get_float( cUnitTypeEmbassyDeath );
   float fThreshold = get_float( cUnitTypeEmbassyZapotec );
   kbUnitQuerySetUnitType( nativeQid, cUnitTypeZapPriest );
   kbUnitQuerySetActionType( nativeQid, cActionRangedAttack );
   int results = kbUnitQueryExecute( nativeQid );
   fRate = xsMin( (fThreshold - fCurrent), (fTimeFactor * results) );
   fCurrent = fCurrent + fRate;
   if ( fCurrent >= fThreshold ) {
      if ( kbUnitCount(playerid, cUnitTypeZapCloudWarrior, cUnitStateAlive) < kbGetBuildLimit(playerid, cUnitTypeZapCloudWarrior) ) {
         UnitCreate( playerid, cUnitTypeZapCloudWarrior, 1, kbUnitGetPosition(kbUnitQueryGetResult(nativeQid, 0)) );
         fRate = fRate - fThreshold;
      }
   }
   kbUnitQueryResetResults( nativeQid );
   if ( fRate != 0.0 )
      add_float( cUnitTypeEmbassyDeath, fRate );
*/
}
void MixtecNatives(int playerid=-1, int basicQid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
}
void TarascanNatives(int playerid=-1, int basicQid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
}
void HuastecNatives(int playerid=-1, int basicQid=-1, int nativeQid=-1, float fTimeFactor=1.0)
{
}

//=======================================================================================================
void PlayerNativeMechanics(int playerid=-1, int basicQid=-1, float fTimeFactor=1.0)
{
   int nativeQid = get_int( NATIVES_QRY, playerid );
   if ( kbGetTechStatus(cTechNativeChichimecs) >= cTechStatusActive )  //CHICHIMECS.
      ChichimecNatives( playerid, basicQid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeNahua) >= cTechStatusActive )  //NAHUA.
      NahuaNatives( playerid, basicQid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeTlaxcaltecs) >= cTechStatusActive )  //TLAXCALTECS.
      TlaxcaltecNatives( playerid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeToltecs) >= cTechStatusActive )  //TOLTECS.
      ToltecNatives( playerid, basicQid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeOtomi) >= cTechStatusActive )  //OTOMIS.
      OtomiNatives( playerid, basicQid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeZapotec) >= cTechStatusActive )  //ZAPOTEC.
      ZapotecNatives( playerid, basicQid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeMixtecs) >= cTechStatusActive )  //MIXTECS.
      MixtecNatives( playerid, basicQid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeTarascans) >= cTechStatusActive )  //ZAPOTEC.
      TarascanNatives( playerid, basicQid, nativeQid, fTimeFactor );
   if ( kbGetTechStatus(cTechNativeHuastec) >= cTechStatusActive )  //HUASTEC.
      HuastecNatives( playerid, basicQid, nativeQid, fTimeFactor );
}

//===============================================================================================================================
//It's a darn shame there's no kbProtoUnitGetNumberProtosITrain() / kbProtoUnitGetProtoITrainByIndex() funcs...
int get_stored_warrior(int embassy=-1, int index=-1) {
   int retval = -1;
   if ( index <= 3 )      retval = kbUnitCostPerResource(embassy, index);
   else if ( index == 4 ) retval = kbProtoUnitGetMaximumVelocity(embassy);
   return( retval );
}
bool set_stored_warrior(int embassy=-1, int index=-1, int warrior=-1) {
   float fWarrior = 0.1 + warrior;  //Make sure float doesn't round down (it really shouldn't...)
   if ( index <= 3 )
      trModifyProtounit( kbGetProtoUnitName(embassy), 0, cModifyCostGold+index, fWarrior - kbUnitCostPerResource(embassy, index) );
   else if ( index == 4 )
      trModifyProtounit( kbGetProtoUnitName(embassy), 0, cModifySpeed, fWarrior - kbProtoUnitGetMaximumVelocity(embassy) );
   return( index <= 4 );
}

int get_number_stored_warriors(int embassy=-1) {
   return( kbGetBuildLimit(0, embassy) );
}
void populate_natives_from_embassy(int firstnative=-1, int lastnative=-1, int embassy=-1)
{
   int trainNum = 0;
   string sSubName = xsSubString( kbGetProtoUnitName(embassy), 3, 7 );  //Get <Nat> from Embassy<Native>.
   for(protoid=firstnative; <= lastnative) {
      if ( kbProtoUnitIsUnitType(protoid, cUnitTypeInventoryHolder) == false ) continue;
      if ( protoid == cUnitTypeHuaHero ) continue;
      if ( protoid == cUnitTypeNahTlatoani ) continue;
      if ( protoid == cUnitTypeOtoHero ) continue;
      if ( protoid == cUnitTypeTolLeader ) continue;
      if ( protoid == cUnitTypeTolBigSerpent ) continue;
      if ( protoid == cUnitTypeMixLord ) continue;
      if ( protoid == cUnitTypeMixLady ) continue;
      if ( protoid == cUnitTypeTlaxBigHeroRanged ) continue;
      if ( protoid == cUnitTypeTlaxBigHeroMelee ) continue;
      if ( (protoid >= cUnitTypeChiEagle) && (protoid <= cUnitTypeChiSacredDeer) ) continue;
      if ( xsSubString(kbGetProtoUnitName(protoid), 3) != sSubName ) continue;

      if ( set_stored_warrior(embassy, trainNum, protoid) )
         trainNum++;
      else
         trChatSend( 0, "ERR: "+kbGetProtoUnitName(embassy)+" trains too many natives! Max "+trainNum+" supported." );
   }
   set_int( embassy, trainNum, 0 );
}

void _UpdateNativeLimit(int playerid=-1, int embassyProto=-1, int delta=0)
{
   if ( playerid <= 0 )
      return;
   int origDelta = delta;
   int previous = (get_int(embassyProto, playerid) - 100000);
   int current = previous + delta;
   if ( current == 0 ) {  //Lost all posts!
      _NativeAgeUpOrAllianceToggler( playerid, embassy_to_tech(embassyProto), false );
      delta = (1 - previous);
   }
   else if ( previous == 0 ) {  //Gained first post!
      _NativeAgeUpOrAllianceToggler( playerid, embassy_to_tech(embassyProto), true );
      delta--;
   }
   add_int( embassyProto, origDelta, playerid );
   if ( delta == 0 )
      return;

   int numNatives = get_number_stored_warriors( embassyProto );
   for(i=0; < numNatives) {
      int protoid = get_stored_warrior( embassyProto, i );
      add_int( protoid, (delta * kbGetBuildLimit(0, protoid)), playerid );
   }
  //Special Case: Chichimec ShamanAnimals limit & Sacred Deer Train 1x per Trade Post construction.
   if ( embassyProto == cUnitTypeEmbassyChichimecs ) {
      for(protoid=cUnitTypeChiEagle; <= cUnitTypeChiBear)
         adjust_buildlimit( playerid, protoid, (delta * kbGetBuildLimit(0, protoid)), 0, 12 );
      adjust_buildlimit( playerid, cUnitTypeChiSacredDeer, origDelta, 0, 6 );
   }
}

void NativesPreLaunch(int playerid=-1)
{
  //Like BasicQuery, except action is unspecified (and only for native-related use lol).
   int nativeQid = CreateQuery( playerid, -1, cUnitStateAlive, false );
   set_int( NATIVES_QRY, nativeQid, playerid );

   if ( get_number_stored_warriors(cUnitTypeEmbassyChichimecs) >= 0 ) {  //Chichis initialized (thus found on this map)!
      nativeQid = CreateQuery( playerid, -1, cUnitStateAlive, false );
      set_int( CHICHIMEC_ANIMALS_QRY, nativeQid, playerid );
      for(i=0; < 12)
         set_float( ChichiAnimalInfo+i, 0.0 );
   }

   set_int( STONE_POWER_DELAY, 2, playerid );
   set_int( CHICHIMEC_VISION_CASTS, 0, playerid );
   set_int( CHICHIMEC_VISION_RECHARGE, 0, playerid );
}
//=========================================================================================================================
//PRE: Context = 0, postid = Completed Emb on a native site, get_int(EmbassyXX, playerid) = previously-acknowledged num of EmbassyXX for playerid.
void RegisterEmbassyBuilt(int siteid=-1, int embassyProto=-1)
{
   int ownerid = kbUnitGetOwner( siteid );
   _UpdateNativeLimit( ownerid, embassyProto, 1 );
   kbUnitQuerySetPosition( _ClaimedSitesQid, kbUnitGetPosition(siteid) );
   kbUnitQueryExecute( _ClaimedSitesQid );
   //trChatSend( 0, "RegisterEmbassyBUILT() called! Post="+siteid+", Embassy="+kbGetProtoUnitName(embassyProto) );
}
//Called when a completed embassy (with RegisterEmbassyBuilt() called on it) has now died and is a socket again.
void RegisterEmbassyDeath(int siteid=-1)
{
   int ownerid = trQuestVarGet( "nsp"+siteid );
   int socketProto = kbUnitGetProtoUnitID( siteid );
   int embassyProto = kbGetProtoUnitID( socket_to_embassy(socketProto) );
   _UpdateNativeLimit( ownerid, embassyProto, -1 );
   convert( siteid, 0 );
   trQuestVarSet( "nsp"+siteid, 0 );
   //trChatSend( 0, "RegisterEmbassyDEATH() called! Post="+siteid+", Socket="+kbGetProtoUnitName(socketProto) );
}

//Called by ExtendedMechanics very frequently on the builder token unit.
//So: start building, continue building, just finished, foundation was just destroyed/back to socket.
void ExtMechEmbassyBuilderHandler(int tokenBuilder=-1, int nearestQid=-1)
{
   if ( kbUnitGetAnimationActionType(tokenBuilder) == cActionBuild )
      return;
   int ownerid = kbUnitGetOwner( tokenBuilder );
   kbUnitQuerySetPlayerID( nearestQid, ownerid, false );
   kbUnitQuerySetPlayerRelation( nearestQid, -1 );
   kbUnitQuerySetPosition( nearestQid, kbUnitGetPosition(tokenBuilder) );
   kbUnitQuerySetMaximumDistance( nearestQid, 16.0 );
   int siteid = find_unit( nearestQid, cUnitTypeAbstractSocketOrEmbassy );
   bool destroyBuilder = (siteid < 0);  //Nothing nearby?
   if ( destroyBuilder == false ) {
      destroyBuilder = kbUnitIsType(siteid, cUnitTypeBuildingClass);
      if ( destroyBuilder )  //Completed embassy. Register it and destroy builder.
         RegisterEmbassyBuilt( siteid, kbUnitGetProtoUnitID(siteid) );
      else {  //Still a socket.
         destroyBuilder = (trQuestVarGet("nsp"+siteid) > 0);
         if ( destroyBuilder )  //Started building before, but not now? Must've been destroyed by enemy.
            trQuestVarSet( "nsp"+siteid, 0 );
         else {
            bool notStarted = (percent_damaged(siteid) <= 0);
            if ( notStarted )
               trUnitConvert( 0 );  //Needed to task-build on the socket.
            trUnitSelectClear();
            trUnitSelectByID( tokenBuilder );
            if ( notStarted )
               trUnitBuildUnit( socket_to_embassy(kbUnitGetProtoUnitID(siteid)), kbUnitGetPosition(siteid) );
            else
               trUnitDoWorkOnUnit( trGetUnitScenarioName(siteid), -1 );
            trQuestVarSet( "nsp"+siteid, ownerid );
         }
      }
   }
   if ( destroyBuilder )
      destroy( tokenBuilder );
   reset_nearest_extmech_qid( nearestQid );
}

void ExtMechGlobalNativeHandler(void)
{
   static int socketQid = -1;
   static int nearbyQid = -1;
   if ( socketQid < 0 ) {
      socketQid = CreateQuery( RELATION_ANY, cUnitTypeAbstractSocketOrEmbassy, cUnitStateAlive, false );
      kbUnitQueryExecute( socketQid );
      nearbyQid = CreateQuery( RELATION_ENEMY, cUnitTypeLogicalTypeConvertsHerds, cUnitStateAlive, false );
      kbUnitQuerySetMaximumDistance( nearbyQid, SOCKET_AUTO_CONVERT_DISTANCE );
   }

  //Sockets need a manually-coded AutoConvert action.
   int results = kbUnitQueryNumberResults( socketQid );
   for(i=0; < results) {
      int siteid = kbUnitQueryGetResult( socketQid, i );
      if ( kbUnitIsType(siteid, cUnitTypeBuildingClass) )  //A completed Embassy.
         continue;
      kbUnitQuerySetPosition( nearbyQid, kbUnitGetPosition(siteid) );
      int theUnits = kbUnitQueryExecute( nearbyQid );
      if ( theUnits <= 0 )  //CPU-saver: Early out if no nearby units.
         continue;
      kbUnitQueryResetResults( nearbyQid );
      if ( percent_damaged(siteid) > 0 )  //Don't steal a Site that's under construction.
         continue;
      int highestPlayer = -1;
      int highestUnits = -1;
      int ownerid = kbUnitGetOwner( siteid );
      int ownersUnits = 0;
      for(playerid=1; < cNumberPlayers) {
         kbUnitQuerySetPlayerID( nearbyQid, playerid, false );
         theUnits = kbUnitQueryExecute( nearbyQid );
         kbUnitQueryResetResults( nearbyQid );
         if ( playerid == ownerid )
            ownersUnits = theUnits;
         if ( theUnits > highestUnits ) {
            highestUnits = theUnits;
            highestPlayer = playerid;
         }
      }
      kbUnitQuerySetPlayerID( nearbyQid, -1, false );
      if ( highestUnits > (1.9*ownersUnits) )
         convert( siteid, highestPlayer );
   }

  //Destroyed embassies need to be processed.
   bool reset = false;
   results = kbUnitQueryNumberResults( _ClaimedSitesQid );
   for(i=0; < results) {
      siteid = kbUnitQueryGetResult( _ClaimedSitesQid, i );
      if ( kbUnitIsType(siteid, cUnitTypeBuildingClass) )  //Still an Embassy.
         continue;
      reset = true;
      RegisterEmbassyDeath( siteid );
   }
   if ( reset ) {
      kbUnitQueryResetResults( _ClaimedSitesQid );
      kbUnitQuerySetMaximumDistance( _ClaimedSitesQid, -1.0 );
      for(protoid=firstpost_; <= lastpost_) {
         kbUnitQuerySetUnitType( _ClaimedSitesQid, protoid );
         kbUnitQueryExecute( _ClaimedSitesQid );
      }
      kbUnitQuerySetUnitType( _ClaimedSitesQid, cUnitTypeBuildingClass );  //Revert settings back.
      kbUnitQuerySetMaximumDistance( _ClaimedSitesQid, 0.2 );
   }
}

void ROTG_NativesInit(void)
{
   int firstnative = -1;  //Lowest Proto id of a native warrior.
   int lastnative = -2;   //Highest Proto id of a native warrior.
   int numPostProtos = 0;

   for(protoid=cUnitTypeReindeer+1; < cNumberProtoUnits) {
    //Only look at the ROTG units. Mod units always at end of proto file, so starting here saves 800+ iterations!
      if ( kbProtoUnitIsUnitType(protoid, cUnitTypeInventoryHolder) ) {  //NativeWarrior
         lastnative = protoid;
         if ( firstnative < 0 )
            firstnative = protoid;
      }
      else if ( kbProtoUnitIsUnitType(protoid, cUnitTypeAbstractSocketOrEmbassy) ) {  //Embassy or Socket.
         if ( kbProtoUnitIsUnitType(protoid, cUnitTypeBuildingClass) == false )
            continue;
         numPostProtos++;
         lastpost_ = protoid;
         if ( firstpost_ < 0 )
            firstpost_ = protoid;
        //Embassy<Native> build limit represents the previously-registered count of that type of post.
        //Heavily offsetted so BuilderToken can task-build more.
         for(playerid=1; < cNumberPlayers)
            set_int( protoid, 100000, playerid );
      }
   }

  //Error Catcher: Check each NativeXXX tech for its corresponding EmbassyXXX/SocketXXX protos.
   int numNativeTechs = 0;
   for(techid=cTechWaterDamage+1; < cNumberTechs) {
      string theName = kbGetTechName( techid );
      if ( xsSubString(theName, 6) != "Native" )
         continue;
      numNativeTechs++;
      if ( firstnativetech_ < 0 )
         firstnativetech_ = techid;
      lastnativetech_ = techid;
      if ( kbGetProtoUnitID(tech_to_embassy(techid)) < 0 )
         trChatSend( 0, "ERR: "+theName+" has no corresponding Embassy unit." );
      if ( kbGetProtoUnitID(tech_to_socket(techid)) < 0 )
         trChatSend( 0, "ERR: "+theName+" has no corresponding Socket unit." );
   }
   string errorString = "";
   if ( numNativeTechs != numPostProtos )
      errorString = "ERR: "+numNativeTechs+" Native techs found, while "+numPostProtos+" native Embassies found.";
   else if ( ((lastnativetech_-firstnativetech_)+1) != numNativeTechs )
      errorString = "ERR: All 'Native' tech IDs must be consecutive!";
   else if ( ((lastpost_-firstpost_)+1) != numPostProtos )
      errorString = "ERR: All 'Embassy' proto IDs must be consecutive!";
   if ( errorString != "" ) {
      trChatSend( 0, errorString );
      return;
   }

   int qid = CreateQuery( RELATION_ANY, cUnitTypeAbstractSocketOrEmbassy, cUnitStateAliveOrBuilding, false );
   _NumNativeSitesPresent = kbUnitQueryExecute( qid );
   if ( _NumNativeSitesPresent <= 0 ) {
      kbUnitQueryDestroy( qid );
      return;
   }

  //At least 1 Native Site found.
  //Init this before RegisterEmbassyBuilt().
   _ClaimedSitesQid = CreateQuery( RELATION_ANY, cUnitTypeBuildingClass, cUnitStateAlive, false );
   kbUnitQuerySetMaximumDistance( _ClaimedSitesQid, 0.2 );
   for(playerid=1; < cNumberPlayers)
      trUnforbidProtounit( playerid, "EmbassyBuilderToken" );

   for(i=0; < _NumNativeSitesPresent) {
      int resultid = kbUnitQueryGetResult( qid, i );
      int embassyUnit = kbUnitGetProtoUnitID( resultid );
      int ownerPlayer = kbUnitGetOwner( resultid );
      bool isSocket = (kbUnitIsType(resultid, cUnitTypeBuildingClass) == false);
      if ( isSocket ) {  //A Socket.
         convert( resultid, 0 );
         ownerPlayer = 0;
         embassyUnit = kbGetProtoUnitID( socket_to_embassy(embassyUnit) );
      }
      if ( get_number_stored_warriors(embassyUnit) < 0 ) {
         populate_natives_from_embassy( firstnative, lastnative, embassyUnit );  //Before any calls to RegisterEmbassyBuilt()!
         for(playerid=1; < cNumberPlayers)
            trUnforbidProtounit( playerid, kbGetProtoUnitName(embassyUnit) );
      }
      trQuestVarSet( "nsp"+resultid, ownerPlayer );  //nsp = NativeSitePlayer
      if ( (isSocket == false) && (ownerPlayer > 0) )
         RegisterEmbassyBuilt( resultid, embassyUnit );
   }
   kbUnitQueryDestroy( qid );
}

//===========================================================================================================
void ChiPowerReFunc(int playerid=-1) {
   add_int( CHICHIMEC_VISION_RECHARGE, -1, playerid );
   if ( get_int(CHICHIMEC_VISION_RECHARGE, playerid) <= 0 ) {
      xsDisableRule( "ChiPowerRecharge"+playerid );
      add_int( cUnitTypeChichiGPToken, 1, playerid );
   }
}
rule ChiPowerRecharge1  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(1); }
rule ChiPowerRecharge2  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(2); }
rule ChiPowerRecharge3  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(3); }
rule ChiPowerRecharge4  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(4); }
rule ChiPowerRecharge5  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(5); }
rule ChiPowerRecharge6  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(6); }
rule ChiPowerRecharge7  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(7); }
rule ChiPowerRecharge8  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(8); }
rule ChiPowerRecharge9  minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(9); }
rule ChiPowerRecharge10 minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(10); }
rule ChiPowerRecharge11 minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(11); }
rule ChiPowerRecharge12 minInterval 300 maxInterval 300 inactive runImmediately { ChiPowerReFunc(12); }
