//==============================================================================
// BASICVC.xs
// A really, really simple victory condition script.
//==============================================================================

// Include the extended mechanics
include "extendedmechanics.xs";

bool _StandardVictory = false;

//PRE: Context player set to Playerid.
void _PlayerDefeatedHandler(int playerid=-1)
{
   trSetPlayerDefeated( playerid );
   xsDisableRuleGroup( "_dod"+playerid );  //"disable on defeat"

   if ( get_my_culture() == cTechAge1Aztec ) {
      int heroid = get_tlatoani_id( get_int(ARRAY_ID, playerid) );
      if ( kbUnitGetCurrentHitpoints(heroid) <= 0.0 )
         destroy( heroid );
      destroy( get_int(INVIS_OBSTRUCT_ID, playerid) );
   }
}

rule InitBasicVCNoMain active runImmediately {
   xsDisableSelf();
   _StandardVictory = ( (vcGetGameplayMode() == cGameModeSupremacy) || (vcGetGameplayMode() == cGameModeLightning) ||
                        (vcGetGameplayMode() == cGameModeTreaty) );
}
rule BasicVC1 minInterval 10 maxInterval 10 active
{
   static int _PrevDefeatedCount = -1;  //So 1st run always checks for conquest.
   int defeated = 0;
   for(playerid=1; < cNumberPlayers) {
      if ( kbHasPlayerLost(playerid) ) {
         defeated++;
         continue;
      }
      xsSetContextPlayer( playerid );
      if ( kbUnitCount(playerid, cUnitTypeLogicalTypeNeededForVictory, cUnitStateAlive) > 0 )
         continue;
      defeated++;
      trChatSendSpoofed( playerid, GetPlayerName(playerid)+" has been defeated!" );
      _PlayerDefeatedHandler( playerid );
   }
   if ( defeated != _PrevDefeatedCount ) {
      _PrevDefeatedCount = defeated;
      vcCheckConquestVictory();
   }
   if ( kbIsGameOver() )
      xsDisableSelf();
}

void resignEventHandler(int playerid=-1) {
   xsSetContextPlayer( playerid );
   _PlayerDefeatedHandler( playerid );
}
void buildingUpgradeEventHandler(int unused=1)
{
//trChatSend( 0, "buildingUpgradeEventHandler() called! Param="+unused );
   if ( _StandardVictory == false )
      return;
   if ( kbIsGameOver() == false )
      vcCheckSettlementVictory( 300 );
}
void allianceChangeEventHandler(int unused=1)
{
   if ( _StandardVictory == false )
	return;
   if ( kbIsGameOver() == false )
	vcCheckSettlementVictory( 300 );
}
void buildingConstructedEventHandler(int unused=1)
{
   if ( _StandardVictory == false )
      return;
   if ( kbIsGameOver() )
      return;
   xsSetContextPlayer( 0 );
   kbLookAtAllUnitsOnMap();
   static int buildingQid = -1;
   if ( buildingQid < 0 )
      buildingQid = CreateQuery( RELATION_ANY, cUnitTypeWonder, cUnitStateAlive, false );
   int results = kbUnitQueryExecute( buildingQid );
   //trChatSend( 0, "Number Wonders Found: "+results );
   for(i=0; < results) {
      int playerid = kbUnitGetOwner( kbUnitQueryGetResult(buildingQid, i) );
      if ( kbHasPlayerLost(playerid) == false )
         vcStartOrUpdateWonderTimer( playerid, "Wonder", 600 );
   }
   kbUnitQueryResetResults( buildingQid );
}

